<?php
class AdminController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/logout');
        }
    }

    public function init()
    {
        $this->path = '/admin';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->view->modulo = 8;
        $this->view->usuario = Zend_Auth::getInstance()->getIdentity();

        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header', $this->view->render("header.phtml"));
            $response->insert('tools', $this->view->render("tools/admin.phtml"));
            $response->insert('menu' , $this->view->render("menu-admin.phtml"));
        } else {
            $this->_helper->layout->disableLayout(true);
            $this->_helper->viewRenderer->setNoRender(true);
        }
    }
    
    public function indexAction()
    {  
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->title = 'Administración';

        if($this->getRequest()->isXmlHttpRequest()){
            $this->renderScript('admin/index.phtml');
        }
    }

    public function informesAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $this->view->title = 'Informes';
            $this->renderScript('admin/informes.phtml');
        }
    }

    public function alertasAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $this->view->title = 'Alertas';
            $this->renderScript('admin/alertas.phtml');
        }
    }

    public function autorizacionesAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $this->view->title = 'Autorizaciones pendientes';

            $modelAutorizaciones = new Default_Model_AutorizacionDocumento();
            $where = "estado='0'";
            $autorizaciones = $modelAutorizaciones->fetchAll($where);

            $this->view->autorizaciones = $autorizaciones;
            $this->renderScript('admin/autorizaciones.phtml');
        }
    }
}