<?php
class AjaxClienteController extends Zend_Controller_Action
{
    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/');
        }
    }
    
    public function indexAction()
    {
        $this->_redirect('/start/');
    }

    public function getAllAction()
    {
        // deshabilito la vista y el layout
        $this->_helper->viewRenderer->setNoRender();
        $this->_helper->layout->disableLayout();
        $cliente = new Cliente();
        $clientes = $cliente->getAll();
        if($clientes!=false) {
            $data = '<table class="ajax_window_table">';
            $data .= '<caption>Clientes encontrados : '.count($clientes).'</caption>';
            $data .= '<thead>';
            $data .= '<tr>';
            $data .= '<th>Razón Social</th>';
            $data .= '<th>R.U.T.</th>';
            $data .= '</tr>';
            $data .= '</thead>';
            $data .= '<tbody>';
            foreach($clientes as $row) {
                $data .= '<tr id="'.$row->rut.'"><td>'.$row->razon_social.'</td><td>'.$this->view->formatRut($row->rut).'</td></tr>';
            }
            $data .= '</tbody>';
            $data .= '</table>';
            $result = $data;
        } else {
            $result = '<p>No se han registrado clientes.</p>';
        }
        echo $result;
    }

    public function searchAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();

            $param = $this->_getParam('term');
            $data = Default_Model_VistaClientes::search($param);
            $result = Zend_Json_Encoder::encode($data);
            echo $result;
        }
    }
}