<?php
class AjaxContactoController extends Zend_Controller_Action
{
    public function init()
    {
         $auth = Zend_Auth::getInstance();

        if (!$auth->hasIdentity()) {
            $this->_redirect('/');
        }
    }
    
    public function indexAction()
    {
        $this->_redirect('/start/');
    }

    public function getAllAction()
    {
        // deshabilito la vista y el layout
        $this->_helper->viewRenderer->setNoRender();
        $this->_helper->layout->disableLayout();
        $contacto = new ContactoAgenda();
        $contactos = $contacto->getAll();
        if($contactos!=false) {
            $data = '<table class="ajax_window_table">';
            $data .= '<caption>Contactos encontrados : '.count($contactos).'</caption>';
            $data .= '<thead>';
            $data .= '<tr>';
            $data .= '<th>Nombre</th>';
            $data .= '</tr>';
            $data .= '</thead>';
            $data .= '<tbody>';
            foreach($contactos as $row) {
                $data .= '<tr id="'.$row->nombre.'"><td>'.$row->nombre.'</td></tr>';
            }
            $data .= '</tbody>';
            $data .= '</table>';
            $result = $data;
        } else {
            $result = '<p>No se han registrado contactos.</p>';
        }
        echo $result;
    }
    
    public function newCategoriaAction()
    {
        $this->_helper->viewRenderer->setNoRender();
        $this->_helper->layout->disableLayout();  
        $valor = $this->_request->getPost('valor');    
        $categoria = new CategoriaContacto();
        $row = $categoria->createRow();
        $row->nombre = $valor;
        $row->save(); 
    }

    public function searchAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();

            $param = $this->_getParam('term');
            $data = Default_Model_Contacto::search($param);
            $result = Zend_Json_Encoder::encode($data);
            echo $result;
        }
    }
}