<?php
class AjaxOrdenCompraController extends Zend_Controller_Action
{
    public function init()
    {
         $auth = Zend_Auth::getInstance();

        if (!$auth->hasIdentity()) {
            $this->_redirect('/');
        }
    }
    
    public function indexAction()
    {
        $this->_redirect('/start/');
    }

    public function putItemOrdenFromArticuloAction()
    {
        // deshabilito la vista y el layout
        $this->_helper->viewRenderer->setNoRender();
        $this->_helper->layout->disableLayout();
        
        // recibo los valores para insertar en la orden
        $articulo_id = (int)$this->_request->getPost('id');
        $cantidad = (int)$this->_request->getPost('c');
        $orden_id = (int)$this->_request->getPost('oc');
        $precio = (int)$this->_request->getPost('p');

        $articulo = new ArticuloInventario();
        $articuloToItem = $articulo->fetchRow('id='.$articulo_id);

        $detalle = 'Código ' . $articuloToItem->codigo . ' - ' . $articuloToItem->nombre;

        $item = new ItemOrdenCompra();
        $row = $item->createRow();
        $row->orden_id = $orden_id;
        $row->cantidad = $cantidad;
        $row->valor = $precio;
        $row->descripcion = $detalle;
        $row->save();
        return true;
    }

    public function getFormEditItemAction()
    {
        // deshabilito la vista y el layout
        $this->_helper->viewRenderer->setNoRender();
        $this->_helper->layout->disableLayout();

        $item = new ItemOrdenCompra();
        $id = (int)$this->_request->getPost('id');
        $row = $item->fetchRow('id='.$id);

        $formItem = new ItemOrdenCompraForm();
        $formItem->id->setValue($row->id);
        $formItem->orden_id->setValue($row->orden_id);
        $formItem->valor->setValue($row->valor);
        $formItem->cantidad->setValue($row->cantidad);
        $formItem->unidad_medida_id->setValue($row->unidad_medida_id);
        $formItem->descripcion->setValue($row->descripcion);
        $formItem->setAction('/orden-compra/edit-item/');
        $formItem->submit->setLabel('editar ítem');
        echo $formItem;
    }
}