<?php
class AreaTrabajoController extends Zend_Controller_Action
{
    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/area-trabajo';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }
    
    public function indexAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $currentPage = $this->_getParam('page', 1);

            $area = new Default_Model_AreaTrabajo();
            $areas = $area->fetchAll();

            $paginador = Zend_Paginator::factory($areas);
            $paginador->setItemCountPerPage($this->paginacion['cant_items'])
                      ->setPageRange($this->paginacion['cant_pages'])
                      ->setCurrentPageNumber($currentPage);

            Zend_View_Helper_PaginationControl::setDefaultViewPartial('pagination_control.phtml');

            $this->view->areas = $paginador;
            $this->view->title = 'Áreas de trabajo';
            $this->renderScript('area-trabajo/index.phtml');
        }

    }

    public function getFormAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->getRequest()->isXmlHttpRequest()){

            $request = $this->getRequest();
            $form = new Default_Form_AreaTrabajo(null, $this->path);

            if($this->_request->getParam('id')) {

                $area = new Default_Model_AreaTrabajo();
                $where = $area->getAdapter()->quoteInto("id=?", (int)$this->_request->getParam('id'));
                $row = $area->fetchRow($where)->toArray();
                $form->populate($row);
                $form->setAction('/area-trabajo/edit');
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar área de trabajo";

            } else {

                $this->view->title = "Crear área de trabajo";

            }
            $this->view->form = $form;
            $this->renderScript('area-trabajo/form.phtml');
        }
    }

    public function newAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $form = new Default_Form_AreaTrabajo(null, $this->path);

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {

                    $area = new Default_Model_AreaTrabajo();
                    $row = $area->createRow();
                    $row->nombre = $form->getValue('nombre');
                    $row->save();

                    $mSession->mensajes[] = 'El registro fue creado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear el registro.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';

                }

                $this->_forward('index', 'area-trabajo');

            } else {
                $this->view->title = 'Crear ára de trabajo';
                $form->populate($request->getPost());
                $this->view->form = $form;
                $this->renderScript('area-trabajo/form.phtml');
            }
        }
        $this->view->form = $form;
    }

    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $area = new Default_Model_AreaTrabajo();

        $request = $this->getRequest();
        $form = new Default_Form_AreaTrabajo(null, $this->path);
        $form->setAction($this->path . '/edit');
        $form->submit->setLabel("guardar cambios");

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {

                    $where = $area->getAdapter()->quoteInto("id=?", (int)$form->getValue('id'));
                    $row = $area->fetchRow($where);
                    $row->id = $form->getValue('id');
                    $row->nombre = $form->getValue('nombre');
                    $row->save();

                    $mSession->mensajes[] = 'El registro fue editado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar el registro.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';

                }

                $this->_forward('index', 'area-trabajo');

            } else {
                 $this->view->title = 'Editar ára de trabajo';
                $form->populate($request->getPost());
                $this->view->form = $form;
                $this->renderScript('area-trabajo/form.phtml');
            }
        } else {

            if ($this->_request->getParam('id')) {

                $where = $area->getAdapter()->quoteInto("id=?", (int)$this->_request->getParam('id'));
                $registro = $area->fetchRow($where);
                $form->populate($registro->toArray());
            }
        }
        $this->view->form = $form;
    }

    public function deleteAction()
    {
        if($this->_getParam('id')){

            $mSession = new Zend_Session_Namespace('expressauto');
            
            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            try {

                $model = new Default_Model_AreaTrabajo();
                $where = $model->getAdapter()->quoteInto("id = ?" , (int)$this->_getParam('id'));
                $model->delete($where);

                $mSession->mensajes[] = 'El área de trabajo fue eliminada de forma exitosa.';
                $mSession->claseMensaje = 'confirmacion';

                $this->_forward('index','area-trabajo');

            } catch (Exception $e) {

                $mSession->tipo_error = 1;
                $mSession->errores[] = $e->getMessage();

                $this->_forward('error-delete-registro','error');
            }
        }
    }
}