<?php
class BaseController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/logout');
        }
    }

    public function init()
    {
        $this->path = '/base';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->view->modulo = 9;
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();

        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header', $this->view->render("header.phtml"));
            $response->insert('menu' , $this->view->render("menu-base.phtml"));
        } else {
            $this->_helper->layout->disableLayout(true);
            $this->_helper->viewRenderer->setNoRender(true);
        }
    }

    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->title = 'Tablas base del sistema';

        if($this->getRequest()->isXmlHttpRequest()){
            $this->renderScript('base/index.phtml');
        }
    }
}