<?php
class CategoriaVehiculoController extends Zend_Controller_Action
{

    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/categoria-vehiculo';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }
    
    public function indexAction()
    {
       if($this->getRequest()->isXmlHttpRequest()){

           $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $currentPage = $this->_getParam('page', 1);

            $categoria = new Default_Model_CategoriaVehiculo();
            $categorias = $categoria->fetchAll();

            $paginador = Zend_Paginator::factory($categorias);
            $paginador->setItemCountPerPage($this->paginacion['cant_items'])
                      ->setPageRange($this->paginacion['cant_pages'])
                      ->setCurrentPageNumber($currentPage);

            Zend_View_Helper_PaginationControl::setDefaultViewPartial('pagination_control.phtml');

            $this->view->categorias = $paginador;
            $this->view->title = 'Categorías de vehículos';

            $this->renderScript('categoria-vehiculo/index.phtml');
       }
    }

    public function getFormAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->getRequest()->isXmlHttpRequest()){

            $request = $this->getRequest();
            $form = new Default_Form_Categoria(null, $this->path);

            if($this->_request->getParam('id')) {

                $categoria = new Default_Model_CategoriaVehiculo();
                $where = $categoria->getAdapter()->quoteInto("id=?", (int)$this->_request->getParam('id'));
                $row = $categoria->fetchRow($where)->toArray();
                $form->populate($row);
                $form->setAction('/categoria-vehiculo/edit');
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar categoría de vehículos";

            } else {

                $this->view->title = "Crear categoría de vehículos";

            }
            $this->view->form = $form;
            $this->renderScript('categoria-vehiculo/form.phtml');
        }
    }

    public function newAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $form = new Default_Form_Categoria(null, $this->path);

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {
                    $categoria = new Default_Model_CategoriaVehiculo();
                    $row = $categoria->createRow();
                    $row->nombre = $form->getValue('nombre');
                    $row->save();

                    $mSession->mensajes[] = 'El registro fue creado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear el registro.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                }
                $this->_forward('index', 'categoria-vehiculo');

            } else {
                $form->populate($request->getPost());
            }
        }
        $this->view->form = $form;
    }

    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $categoria = new Default_Model_CategoriaVehiculo();

        $request = $this->getRequest();
        $form = new Default_Form_Categoria();
        $form->setAction($this->path . '/edit');
        $form->submit->setLabel("guardar cambios");

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {

                    $where = $categoria->getAdapter()->quoteInto("id=?", (int)$form->getValue('id'));
                    $row = $categoria->fetchRow($where);
                    $row->nombre = $form->getValue('nombre');
                    $row->save();

                    $mSession->mensajes[] = 'La categoría fue <strong>editada</strong> de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar el registro.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';

                }
                $this->_forward('index', 'categoria-vehiculo');
            } 
        } else {

            if ($this->_request->getParam('id')) {
                
                $where = $categoria->getAdapter()->quoteInto("id=?", (int)$this->_request->getParam('id'));
                $registro = $area->fetchRow($where);
                $form->populate($registro->toArray());
            }
        }
        $this->view->form = $form;
    }


    public function deleteAction()
    {
        if($this->_getParam('id')){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            try {

                $model = new Default_Model_CategoriaVehiculo();
                $where = $model->getAdapter()->quoteInto("id = ?" , (int)$this->_getParam('id'));
                $model->delete($where);

                $mSession->mensajes[] = 'La categoría fue eliminada de forma exitosa.';
                $mSession->claseMensaje = 'confirmacion';

                $this->_forward('index','categoria-vehiculo');

            } catch (Exception $e) {

                $mSession->tipo_error = 1;
                $mSession->errores[] = $e->getMessage();

                $this->_forward('error-delete-registro','error');
            }
        }
    }
}