<?php
class ClienteInfoFacturacionController extends Zend_Controller_Action
{
    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
        $this->path = '/cliente-info-facturacion';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }

    public function getFormAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->getRequest()->isXmlHttpRequest()){

            $request = $this->getRequest();
            

            if($this->_getParam('id')) {

                $rut = App_Rut::cleanToDb($this->_request->getParam('id'));
                $infoFacturacion = new Default_Model_ClienteInfoFacturacion();
                $where = $infoFacturacion->getAdapter()->quoteInto("cliente=?", $rut);
                $row = $infoFacturacion->fetchRow($where)->toArray();

                $form = new Default_Form_ClienteInfoFacturacion(null, $this->path, '/cliente/view/' . $row['cliente']);
                $form->populate($row);
                $form->setAction('/cliente-info-facturacion/edit');
                $form->cliente->setValue($rut);
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar cliente";

            } elseif($this->_getParam('from_id')) {

                $rut = App_Rut::cleanToDb($this->_getParam('from_id'));
                $form = new Default_Form_ClienteInfoFacturacion(null, $this->path, '/cliente/view/' . $rut);
                $form->cliente->setValue($rut);
                $this->view->title = "Agregar información de facturación";

                if($this->_getParam('ref_id')=='1'){

                    $cliente = new Default_Model_Cliente();
                    $where = $cliente->getAdapter()->quoteInto("rut=?", $rut);
                    $row = $cliente->fetchRow($where);
                    $form->razon_social->setValue($row->nombre);
                    $form->rut->setValue(App_Rut::format($row->rut));
                    $form->direccion->setValue($row->direccion);
                    $form->comuna->setValue($row->comuna);
                    $form->ciudad->setValue($row->ciudad);
                    $form->telefono->setValue($row->telefono);
                }

                $link  = "<span style='position:absolute;margin:-40px 0 0 25px;'>";
                $link .= "<a class='info' title='Copiar la información del cliente a la de facturación'";
                $link .= " href='/cliente-info-facturacion/get-form/0/0/".$rut."/1'>Copiar los datos del cliente</a></span>";
                echo $link;
            }

            $this->view->form = $form;
            $this->renderScript('archivos-comunes/form.phtml');
        }
    }

    public function newAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_ClienteInfoFacturacion(null, $this->path);
        $this->view->title = "Agregar información de facturación";

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {
                    
                    $infoFacturacion = new Default_Model_ClienteInfoFacturacion();
                    $row = $infoFacturacion->createRow();
                    $row->cliente = $form->getValue('cliente');
                    $row->razon_social = $form->getValue('razon_social');
                    $row->rut = App_Rut::cleanToDb($form->getValue('rut'));
                    $row->direccion = $form->getValue('direccion');
                    $row->comuna = $form->getValue('comuna');
                    $row->ciudad = $form->getValue('ciudad');
                    $row->telefono = $form->getValue('telefono');
                    $row->giro = $form->getValue('giro');
                    $row->save();
                    $mSession->mensajes[] = 'Los datos de facturación fueron agregados de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_forward('view','cliente', null, array('id' => $row->cliente));

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear el cliente.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_forward('index','cliente');
                }
            } else {

                $this->view->form = $form;
                $form->populate($request->getPost());
                $this->renderScript('archivos-comunes/form.phtml');
            }
        }
    }

    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $infoFacturacion = new Default_Model_ClienteInfoFacturacion();

        $request = $this->getRequest();
        $form = new Default_Form_ClienteInfoFacturacion(null, $this->path);

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $cliente = App_Rut::cleanToDb($form->getValue('cliente'));
                    $where = $infoFacturacion->getAdapter()->quoteInto("cliente=?", $cliente);
                    $row = $infoFacturacion->fetchRow($where);
                    $row->rut = $form->getValue('rut');
                    $row->razon_social = $form->getValue('razon_social');
                    $row->direccion = $form->getValue('direccion');
                    $row->comuna = $form->getValue('comuna');
                    $row->ciudad = $form->getValue('ciudad');
                    $row->telefono = $form->getValue('telefono');
                    $row->giro = $form->getValue('giro');
                    $row->save();

                    $mSession->mensajes[] = 'La información de facturación fue editada de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                    $this->_forward('view', 'cliente', null, array('id'=> $cliente));

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar el registro.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_forward('index','cliente');
                }

            } else {

                $form->populate($request->getPost());
                $this->view->form = $form;
                $form->setAction('/cliente-info-facturacion/edit');
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar información de facturación";
                $this->renderScript('archivos-comunes/form.phtml');
            }
        }
    }

    public function deleteAction()
    {
        if($this->getRequest()->isXmlHttpRequest() &&
           $this->_getParam('id') &&
           $this->_helper->validateRecordExists('vista_clientes', 'rut', App_Rut::cleanToDb($this->_getParam('id')))){

            $mSession = new Zend_Session_Namespace('expressauto');
            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            try {

                $rut = App_Rut::cleanToDb($this->_getParam('id'));
                $cliente = new Default_Model_Cliente();
                $where = $cliente->getAdapter()->quoteInto('rut = ?' , $rut);
                $cliente->delete($where);
                $mSession->mensajes[] = 'El cliente fue eliminado de forma exitosa.';
                $mSession->claseMensaje = 'confirmacion';
                $this->_forward('index','cliente');

            } catch (Exception $e) {

                $mSession->error['mensajes'][]      = $e->getMessage();
                $mSession->error['tipo']            = 1;
                $mSession->error['registro_id']     = $rut;
                $mSession->error['registro_tabla']  = 'clientes';
                $this->_forward('error-delete-registro','error');

            }
        }
    }
}