<?php

class CodigoTransaccionTarjetaController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
    }
    
    public function init()
    {   
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/codigo-transaccion-tarjeta';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }

    public function getFormAction()
    {
        
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        if($this->getRequest()->isXmlHttpRequest() AND 
           $this->_getParam('pago_id') AND 
           $this->_helper->validateRecordExists('pagos_recibidos', 'id', $this->_getParam('pago_id'))){
            
            $request = $this->getRequest();
            $form = new Default_Form_CodigoTransaccionTarjeta(null, $this->path);
            $this->view->title = "Ingresar código transacción";
            $pago_id = (int)$this->_getParam('pago_id');
            $form->pago_id->setValue($pago_id);
            
            $this->view->form = $form;
            $this->renderScript('codigo-transaccion-tarjeta/form.phtml');
        }
    }
    
    public function newAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_CodigoTransaccionTarjeta(null, $this->path);
        $this->view->title = 'Ingresar código transacción';
        
        if ($this->getRequest()->isPost()) {
                if ($form->isValid($request->getPost())) {
                
                try {
                    
                    $codigo = new Default_Model_CodigoTransaccionTarjeta();
                    $row = $codigo->createRow();
                    $row->pago_id = $form->getValue('pago_id');
                    $row->creador = $this->usuario->rut;
                    $row->codigo_transaccion = $form->getValue('codigo_transaccion');
                    $row->save();
                    $mSession->mensajes[] = 'El código fue registrado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';
                    
                    $this->_forward('view','pago-recibido', null, array('id' => $form->getValue('pago_id')));

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar ingresar el documento.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_forward('index','pago-recibido');
                }
                
            } else {
                $this->view->form = $form;
                $form->populate($request->getPost());
                $this->renderScript('cotizacion/form.phtml');
            }
        }
         
        
    }
}