<?php
class ComprasController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/logout');
        }
    }

    public function init()
    {
        $this->path = '/compras';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->view->modulo = 3;
        $this->view->usuario = Zend_Auth::getInstance()->getIdentity();

        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header', $this->view->render("header.phtml"));
            $response->insert('tools', $this->view->render("tools/compras.phtml"));
            $response->insert('menu' , $this->view->render("menu-compras.phtml"));
        } else {
            $this->_helper->layout->disableLayout(true);
            $this->_helper->viewRenderer->setNoRender(true);
        }
    }

    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->title = 'Gestión de compras y proveedores';

        if($this->getRequest()->isXmlHttpRequest()){
            $this->renderScript('compras/index.phtml');
        }
    }

    public function informesAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $this->view->title = 'Informes';
            $this->renderScript('compras/informes.phtml');
        }
    }
}