<?php
class CondicionesGeneralesController extends Zend_Controller_Action
{
    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/condiciones-generales';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }
    
    public function indexAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            
            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $currentPage = $this->_getParam('page', 1);

            $condicion = new Default_Model_CondicionGeneral();
            $condiciones = $condicion->fetchAll();

            $paginador = Zend_Paginator::factory($condiciones);
            $paginador->setItemCountPerPage($this->paginacion['cant_items'])
                      ->setPageRange($this->paginacion['cant_pages'])
                      ->setCurrentPageNumber($currentPage);

            Zend_View_Helper_PaginationControl::setDefaultViewPartial('pagination_control.phtml');

            $this->view->condiciones = $paginador;
            $this->view->title = 'Condiciones generales documentos';
            $this->renderScript('condiciones-generales/index.phtml');
        }
    }

    public function getFormAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->_getParam('id')) {

            $condicion = new Default_Model_CondicionGeneral();
            $where = $condicion->getAdapter()->quoteInto("documento=?", $this->_getParam('id'));
            $row = $condicion->fetchRow($where)->toArray();

            $request = $this->getRequest();
            $form = new Default_Form_CondicionGeneral(null, $this->path);
            $form->populate($row);
            
            $this->view->title = "Editar condiciones generales";
            $this->view->form = $form;
            $this->view->documento =  $row['nombre'];
            $this->renderScript('condiciones-generales/form.phtml');
        }
    }

    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_CondicionGeneral(null, $this->path);

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {

                    $condicion = new Default_Model_CondicionGeneral();
                    $where = $condicion->getAdapter()->quoteInto("documento=?", $form->getValue('documento'));
                    $row = $condicion->fetchRow($where);
                    $row->condiciones = $form->getValue('condiciones');
                    $row->save();

                    $mSession->mensajes[] = 'La condiciones generales fueron editadas de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar guardar los cambios.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                }

                $this->_forward('index', 'condiciones-generales');

            } else {
                $this->view->title = 'Editar condiciones generales';
                $form->submit->setLabel("Guardar cambios");
                $form->populate($request->getPost());
                $this->view->form = $form;
                $this->renderScript('condiciones-generales/form.phtml');
            }
        }
    }
}