<?php
class CuentaContableController extends Zend_Controller_Action
{
    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/cuenta-contable';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }
    
    public function indexAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            //$cuentas = new Default_Model_CuentaCorriente();
            //$this->view->cuentas = $cuentas->fetchAll();
            $this->view->title = 'Cuentas contables';
            $this->renderScript('cuenta-contable/index.phtml');
        }

    }


    public function newAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $form = new Default_Form_CuentaCorriente(null, $this->path);
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {

                    $cuenta = new Default_Model_CuentaCorriente();
                    $row = $cuenta->createRow();
                    $row->banco = $form->getValue('banco');
                    $row->numero_cuenta = $form->getValue('numero_cuenta');
                    $row->titular = $form->getValue('titular');
                    $row->linea_credito = $form->getValue('linea_credito');

                    $row->save();

                    $mSession->mensajes[] = 'La cuenta corriente fue creada de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear la cuenta corriente.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';

                }
                $this->_redirect($this->path . '/list');

            } else {
                $form->populate($request->getPost());
            }
        }
        $this->view->form = $form;
    }


    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $form = new Default_Form_CuentaCorriente(null, $this->path);
        $form->setAction($this->path . '/edit');
        $form->submit->setLabel("guardar cambios");

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {
                    $cuenta = new Default_Model_CuentaCorriente();
                    $id = (int)$form->getValue('id');
                    $row = $cuenta->fetchRow('id='.$id);
                    $row->banco = $form->getValue('banco');
                    $row->numero_cuenta = $form->getValue('numero_cuenta');
                    $row->titular = $form->getValue('titular');
                    $row->linea_credito = $form->getValue('linea_credito');
                    $row->save();
                    $mSession->mensajes[] = 'El registro fue editado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';
                } catch (Exception $e) {
                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar el registro.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                }
                $this->_redirect($this->path . '/list');
            } else {
                $form->populate($request->getPost());
            }
        } else {
            $id = (int)$this->_request->getParam('id', 0);
            if ($id > 0) {
                $cuenta = new Default_Model_CuentaCorriente();
                $registro = $cuenta->fetchRow('id='.$id);
                $form->populate($registro->toArray());
            }
        }
        $this->view->form = $form;
    }
    

    public function deleteAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $form = new Default_Form_Delete();
        $form->setAction($this->path . '/delete');

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                
                $cuenta = new Default_Model_CuentaCorriente();
                $where = 'id = '. $form->getValue('id');
                $cuenta->delete($where);
                $mSession->mensajes[] = 'El registro fue eliminado de forma exitosa.';
                $mSession->claseMensaje = 'confirmacion';
                $this->_redirect($this->path . '/list');
            }
        } else {
            $id = (int)$this->_request->getParam('id', 0);
            if ($id > 0) {
                $cuenta = new Default_Model_CuentaCorriente();
                $this->view->cuenta = $cuenta->fetchRow('id='.$id);
                $form->id->setValue($id);
            }
        }
        $this->view->form = $form;
    }

    public function viewAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_request->getParam('id', 0);
        $cuenta = new Default_Model_CuentaCorriente();
        $cuenta->setId($id);
        $this->view->cuenta = $cuenta->getRowById();
        if(false==$this->view->cuenta) {
            $this->_redirect($this->path . '/list/');
        }

    }

}