<?php
class FormaPagoController extends Zend_Controller_Action
{
    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/forma-pago';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }

    public function indexAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $currentPage = $this->_getParam('page', 1);

            $forma = new Default_Model_FormaPago();
            $formas = $forma->fetchAll(null, 'TIPO');

            $paginador = Zend_Paginator::factory($formas);
            $paginador->setItemCountPerPage($this->paginacion['cant_items'])
                      ->setPageRange($this->paginacion['cant_pages'])
                      ->setCurrentPageNumber($currentPage);

            Zend_View_Helper_PaginationControl::setDefaultViewPartial('pagination_control.phtml');

            $this->view->formas = $paginador;
            $this->view->title = 'Formas de pago';
            $this->renderScript('forma-pago/index.phtml');
        }
    }

    public function getFormAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->getRequest()->isXmlHttpRequest()){

            $request = $this->getRequest();
            $form = new Default_Form_FormaPago(null, $this->path);

            if($this->_request->getParam('id')) {

                $forma = new Default_Model_FormaPago();
                $where = $forma->getAdapter()->quoteInto("id=?", (int)$this->_request->getParam('id'));
                $row = $forma->fetchRow($where)->toArray();
                $form->populate($row);
                $form->setAction('/forma-pago/edit');
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar forma de pago";

            } else {

                $this->view->title = "Crear forma de pago";

            }
            $this->view->form = $form;
            $this->renderScript('forma-pago/form.phtml');
        }
    }

    public function newAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $form = new Default_Form_FormaPago(null, $this->path);
        
        
        if ($this->getRequest()->isPost()) {

            if ($form->isValid($request->getPost())) {
                
                try {
                    
                    $forma_pago = new Default_Model_FormaPago();
                    $row = $forma_pago->createRow();
                    $row->nombre = $form->getValue('nombre');
                    $row->porcentaje_recargo = $form->getValue('porcentaje_recargo');
                    $row->detallar = $form->getValue('detallar');
                    $row->save();
                    
                    $mSession->mensajes[] = 'La forma de pago fue creada de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear la forma de pago.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                }

                $this->_forward('index', 'forma-pago');
                
            } else {
                $this->view->title = "Crear forma de pago";
                $form->populate($request->getPost());
                $this->view->form = $form;
                $this->renderScript('forma-pago/form.phtml');
            }
            
        }
        
        $this->view->form = $form;
    }

    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $forma = new Default_Model_FormaPago();

        $request = $this->getRequest();
        $form = new Default_Form_FormaPago(null, $this->path);
        $form->setAction($this->path . '/edit');
        $form->submit->setLabel("guardar cambios");

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {
                    
                    $where = $forma->getAdapter()->quoteInto("id=?", (int)$form->getValue('id'));
                    $row = $forma->fetchRow($where);
                    $row->nombre = $form->getValue('nombre');
                    $row->porcentaje_recargo = $form->getValue('porcentaje_recargo');
                    $row->detallar = $form->getValue('detallar');
                    $row->save();

                    $mSession->mensajes[] = 'El registro fue editado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar el registro.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    
                }

                $this->_forward('index', 'forma-pago');

            } else {
                $this->view->title = "Editar forma de pago";
                $form->populate($request->getPost());
                $this->view->form = $form;
                $this->renderScript('forma-pago/form.phtml');
            }
        } else {

            if ($this->_request->getParam('id')) {
                $where = $forma->getAdapter()->quoteInto("id=?", (int)$this->_request->getParam('id'));
                $registro = $forma->fetchRow($where);
                $form->populate($registro->toArray());
            }
        }
        $this->view->form = $form;
    }

    public function deleteAction()
    {
        if($this->_getParam('id')){
            $mSession = new Zend_Session_Namespace('expressauto');
            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            try {

                $model = new Default_Model_FormaPago();
                $where = $model->getAdapter()->quoteInto("id = ?" , (int)$this->_getParam('id'));
                $model->delete($where);

                $mSession->mensajes[] = 'La forma de pago fue eliminada de forma exitosa.';
                $mSession->claseMensaje = 'confirmacion';
                
                $this->_forward('index','forma-pago');

            } catch (Exception $e) {

                $mSession->tipo_error = 1;
                $mSession->errores[] = $e->getMessage();

                $this->_forward('error-delete-registro','error');

            }
        }
    }
}