<?php
class ItemCotizacionController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();

        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
    }
    
    public function init()
    {
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/item-cotizacion';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }

    public function getFormAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            
            if($this->_getParam('id') &&
               $this->_getParam('table') && 
               $this->_helper->validateRecordExists('items_cotizaciones','id', $this->_getParam('id'))) {

                $table = $this->_getParam('table');
                $request = $this->getRequest();
                $form = new Default_Form_ItemCotizacion($table);

                if($table=='articulos'){

                    $form->buscador->setLabel('Buscar artículo');
                    $form->buscador->setAttrib('onkeypress', 'ajaxSearchArticulo($(this), "#codigo", "#valor_neto", "#nombre", "#descripcion")');
                }

                if($table=='servicios'){
                    $form->vehiculo->setRequired(true);
                    $form->buscador->setLabel('Buscar servicio');
                    $form->buscador->setAttrib('onkeypress', 'ajaxSearchServicio($(this), "#codigo", "#valor_neto", "#nombre", "#descripcion")');
                }

                if($table=='productos'){

                    $form->buscador->setLabel('Buscar producto');
                    $form->buscador->setAttrib('onkeypress', 'ajaxSearchProducto($(this), "#codigo", "#valor_neto", "#nombre", "#descripcion")');
                }

                $item = new Default_Model_ItemCotizacion();
                $where = $item->getAdapter()->quoteInto("id=?", (int)$this->_getParam('id'));
                $row = $item->fetchRow($where)->toArray();
                $form->populate($row);
                $form->setAction('/item-cotizacion/edit/0/' . $table . '/0');
                $form->submit->setLabel('Guardar cambios');
                $form->valor_neto->setAttrib('disabled','disabled');
                
                echo $form;
                
            } elseif($this->_getParam('from_id') && 
                     $this->_getParam('table') &&
                     $this->_helper->validateRecordExists('cotizaciones','id', $this->_getParam('from_id'))) {

                $table = $this->_getParam('table');

                $request = $this->getRequest();
                $form = new Default_Form_ItemCotizacion($table);
                $form->valor_neto->setAttrib('disabled','disabled');
                
                if($table=='articulos'){

                    $form->buscador->setLabel('Buscar artículo');
                    $form->buscador->setAttrib('onkeypress', 'ajaxSearchArticulo($(this), "#codigo", "#valor_neto", "#nombre", "#descripcion")');
                }
                
                if($table=='servicios'){
                    $form->vehiculo->setRequired(true);
                    $form->buscador->setLabel('Buscar servicio');
                    $form->buscador->setAttrib('onkeypress', 'ajaxSearchServicio($(this), "#codigo", "#valor_neto", "#nombre", "#descripcion")');
                }
                
                if($table=='productos'){

                    $form->buscador->setLabel('Buscar producto');
                    $form->buscador->setAttrib('onkeypress', 'ajaxSearchProducto($(this), "#codigo", "#valor_neto", "#nombre", "#descripcion")');
                }

                $form->cotizacion_id->setValue($this->_getParam('from_id'));
                echo $form;
            }
        }
    }

    public function newAction()
    {
        if($this->_getParam('table')) {

            $table = $this->_getParam('table');
            $request = $this->getRequest();
            $form = new Default_Form_ItemCotizacion($table);

            if($table=='servicios') {
                $form->vehiculo->setRequired(true);
            }
            
            if ($this->getRequest()->isPost()) {
                if ($form->isValid($request->getPost())) {
                    try { 
                        $item = new Default_Model_ItemCotizacion();
                        $row = $item->createRow();
                        $row->cotizacion_id = $form->getValue('cotizacion_id');
                        if($form->getValue('vehiculo')!=''){
                            $row->vehiculo = strtoupper($form->getValue('vehiculo'));
                        } else {
                            $row->vehiculo = NULL;
                        }
                        $row->codigo = $form->getValue('codigo');
                        $row->nombre = $form->getValue('nombre');
                        $row->descripcion = $form->getValue('descripcion');
                        $row->cantidad = $form->getValue('cantidad');
                        $row->unidad_medida = $form->getValue('unidad_medida');
                        $row->valor_neto = $form->getValue('valor_neto');
                        $row->descuento =  $this->_calcularDescuento($form->getValue('tipo_descuento'), $form->getValue('descuento'), $form->getValue('valor_neto'));
                        $row->table = $table;
                        $row->save();

                        $form->reset();
                        $form->cotizacion_id->setValue($row->cotizacion_id);
                        $aviso = '<div id="aviso-form" class="confirmacion"><ul>';
                        $aviso .= '<li>El ítem fue agregado de forma satisfactoria. </li>';
                        $aviso .= '</ul></div>';
                        echo $aviso.$form;
                        
                    } catch (Exception $e) {
                        $aviso = '<div id="aviso-form" class="error"><ul><li>Ocurrió un error el intentar agregar el ítem</li></ul></div>';
                    }
                } else {
                    $form->populate($request->getPost());
                    if($table=='articulos'){
                        $form->buscador->setLabel('Buscar artículo');
                        $form->buscador->setAttrib('onkeypress', 'ajaxSearchArticulo($(this), "#codigo", "#neto", "#descripcion")');
                    }
                    if($table=='servicios'){
                        $form->vehiculo->setRequired(true);
                        $form->buscador->setLabel('Buscar servicio');
                        $form->buscador->setAttrib('onkeypress', 'ajaxSearchServicio($(this), "#codigo", "#neto", "#descripcion")');
                    }
                    if($table=='productos'){
                        $form->buscador->setLabel('Buscar producto');
                        $form->buscador->setAttrib('onkeypress', 'ajaxSearchProducto($(this), "#codigo", "#neto", #descripcion")');
                    }
                    echo $form;
                }
            }
        }
    }

    public function editAction()
    {
        if($this->_getParam('table')) {

            $table = $this->_getParam('table');
            $request = $this->getRequest();
            $form = new Default_Form_ItemCotizacion($table);

            if($table=='servicios') {
                $form->vehiculo->setRequired(true);
            }

            if ($this->getRequest()->isPost()) {
                if ($form->isValid($request->getPost())) {

                    try {

                        $id = $form->getValue('id');

                        $item = new Default_Model_ItemCotizacion();
                        $where = $item->getAdapter()->quoteInto("id=?", $id);
                        $row = $item->fetchRow($where);
                        if($form->getValue('vehiculo')!=''){
                            $row->vehiculo = strtoupper($form->getValue('vehiculo'));
                        } else {
                            $row->vehiculo = NULL;
                        }
                        $row->codigo = $form->getValue('codigo');
                        $row->nombre = $form->getValue('nombre');
                        $row->descripcion = $form->getValue('descripcion');
                        $row->cantidad = $form->getValue('cantidad');
                        $row->unidad_medida = $form->getValue('unidad_medida');
                        $row->valor_neto = $form->getValue('valor_neto');
                        $row->descuento =  $this->_calcularDescuento($form->getValue('tipo_descuento'), $form->getValue('descuento'), $form->getValue('valor_neto'));
                        $row->table = $table;
                        $row->save();

                        $aviso = '<div id="aviso-form" class="confirmacion"><ul>';
                        $aviso .= '<li>El ítem fue editado de forma satisfactoria. </li>';
                        $aviso .= '</ul></div>';

                        echo $aviso;

                    } catch (Exception $e) {

                        $aviso = '<div id="aviso-form" class="error"><ul><li>Ocurrió un error el intentar editar el ítem</li></ul></div>';
                    }
                } else {
                    $form->populate($request->getPost());
                    echo $form;
                }
            }
        }
    }

    public function deleteAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $cotizacion_id = $this->_getParam('id');

            if($this->_helper->validateRecordExists('cotizaciones', 'id', $cotizacion_id)){

                $data = $this->_getParam('data');
                $items = explode(",", $data);

                $itemCotizacion = new Default_Model_ItemCotizacion();

                foreach($items as $id){

                    if($this->_helper->validateRecordExists('items_cotizaciones', 'id', $id)){
                        $where = $itemCotizacion->getAdapter()->quoteInto("id=?", $id);
                        $itemCotizacion->delete($where);
                    }
                }
                return true;
            }
        }
    }

    private function _calcularDescuento($tipo, $descuento, $neto)
    {
        if(!isset($tipo) OR !isset($descuento) OR !isset($neto)){
            return false;
        }

        if($tipo=='MONTO') {
            return $descuento;
        }

        if($tipo=='PORCENTAJE'){
            $monto = round($neto * ($descuento/100));
            return $monto;
        }
    }
}