<?php
class ItemNotaVentaController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();

        if (!$auth->hasIdentity()) {
            $this->_redirect('/');
        }
    }
    
    public function init()
    {
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/item-nota-venta';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }

    public function getFormAction()
    {

        if($this->getRequest()->isXmlHttpRequest()){

            if($this->_getParam('id') AND
               $this->_getParam('table') AND
               $this->_helper->validateRecordExists('items_notas_ventas','id', $this->_getParam('id'))) {

                $table = $this->_getParam('table');
                $request = $this->getRequest();
                $form = new Default_Form_ItemNotaVenta($table);

                if($table=='articulos'){

                    $form->buscador->setLabel('Buscar artículo');
                    $form->buscador->setAttrib('onkeypress', 'ajaxSearchArticulo($(this), "#codigo", "#valor_neto", "#nombre", "#descripcion")');
                }

                if($table=='servicios'){

                    $form->vehiculo->setRequired(true);
                    $form->buscador->setLabel('Buscar servicio');
                    $form->buscador->setAttrib('onkeypress', 'ajaxSearchServicio($(this), "#codigo", "#valor_neto", "#nombre", "#descripcion")');
                }

                if($table=='productos'){

                    $form->buscador->setLabel('Buscar producto');
                    $form->buscador->setAttrib('onkeypress', 'ajaxSearchProducto($(this), "#codigo", "#valor_neto", "#nombre", "#descripcion")');
                }

                $item = new Default_Model_ItemNotaVenta();
                $where = $item->getAdapter()->quoteInto("id=?", (int)$this->_getParam('id'));
                $row = $item->fetchRow($where)->toArray();
                $form->populate($row);
                $form->setAction('/item-nota-venta/edit/0/' . $table . '/0');
                $form->submit->setLabel('Guardar cambios');
                $form->valor_neto->setAttrib('disabled','disabled');

                echo $form;

            } elseif($this->_getParam('from_id') AND
                     $this->_getParam('table') AND
                     $this->_helper->validateRecordExists('notas_ventas','id', $this->_getParam('from_id'))) {

                $table = $this->_getParam('table');

                $request = $this->getRequest();
                $form = new Default_Form_ItemNotaVenta($table);
                $form->valor_neto->setAttrib('disabled','disabled');

                if($table=='articulos'){

                    $form->buscador->setLabel('Buscar artículo');
                    $form->buscador->setAttrib('onkeypress', 'ajaxSearchArticulo($(this), "#codigo", "#valor_neto", "#nombre", "#descripcion")');
                }

                if($table=='servicios'){

                    $form->vehiculo->setRequired(true);
                    $form->buscador->setLabel('Buscar servicio');
                    $form->buscador->setAttrib('onkeypress', 'ajaxSearchServicio($(this), "#codigo", "#valor_neto", "#nombre", "#descripcion")');
                }

                if($table=='productos'){

                    $form->buscador->setLabel('Buscar producto');
                    $form->buscador->setAttrib('onkeypress', 'ajaxSearchProducto($(this), "#codigo", "#valor_neto", "#nombre", "#descripcion")');
                }

                $form->nota_id->setValue($this->_request->getParam('from_id'));
                echo $form;
            }
        }
    }

    public function newAction()
    {
        if($this->_getParam('table')) {

            $table = $this->_getParam('table');
            $request = $this->getRequest();
            $form = new Default_Form_ItemNotaVenta($table);

            if($table=='servicios') {
                $form->vehiculo->setRequired(true);
            }

            if ($this->getRequest()->isPost()) {
                if ($form->isValid($request->getPost())) {

                    try {
                        
                        $item = new Default_Model_ItemNotaVenta();
                        $row = $item->createRow();
                        $row->nota_id = $form->getValue('nota_id');
                        if($form->getValue('vehiculo')!=''){
                            $row->vehiculo = strtoupper($form->getValue('vehiculo'));
                        } else {
                            $row->vehiculo = NULL;
                        }
                        $row->codigo = $form->getValue('codigo');
                        $row->nombre = $form->getValue('nombre');
                        $row->descripcion = $form->getValue('descripcion');
                        $row->cantidad = $form->getValue('cantidad');
                        $row->unidad_medida = $form->getValue('unidad_medida');
                        $row->valor_neto = $form->getValue('valor_neto');
                        $row->descuento = $this->_calcularDescuento($form->getValue('tipo_descuento'), $form->getValue('descuento'), $form->getValue('valor_neto'));
                        $row->table = $table;
                        $row->save();

                        $form->reset();
                        $form->nota_id->setValue($row->nota_id);
                        
                        $aviso = '<div id="aviso-form" class="confirmacion"><ul>';
                        $aviso .= '<li>El ítem fue agregado de forma satisfactoria. </li>';
                        $aviso .= '</ul></div>';

                        echo $aviso.$form;

                    } catch (Exception $e) {

                        $aviso = '<div id="aviso-form" class="error"><ul><li>Ocurrió un error el intentar agregar el ítem</li></ul></div>';

                    }

                } else {
                    $form->populate($request->getPost());
                    echo $form;
                }
            }
        }
    }

    public function editAction()
    {
        if($this->_getParam('table')) {

            $table = $this->_getParam('table');
            $request = $this->getRequest();
            $form = new Default_Form_ItemNotaVenta($table);

            if($table=='servicios') {
                $form->vehiculo->setRequired(true);
            }

            if ($this->getRequest()->isPost()) {
                if ($form->isValid($request->getPost())) {

                    try {

                        $id = $form->getValue('id');
                        $item = new Default_Model_ItemNotaVenta();
                        $where = $item->getAdapter()->quoteInto("id=?", $id);
                        $row = $item->fetchRow($where);
                        if($form->getValue('vehiculo')!=''){
                            $row->vehiculo = strtoupper($form->getValue('vehiculo'));
                        } else {
                            $row->vehiculo = NULL;
                        }
                        $row->codigo = $form->getValue('codigo');
                        $row->nombre = $form->getValue('nombre');
                        $row->descripcion = $form->getValue('descripcion');
                        $row->cantidad = $form->getValue('cantidad');
                        $row->unidad_medida = $form->getValue('unidad_medida');
                        $row->valor_neto = $form->getValue('valor_neto');
                        $row->descuento = $this->_calcularDescuento($form->getValue('tipo_descuento'), $form->getValue('descuento'), $form->getValue('valor_neto'));
                        $row->table = $table;
                        $row->save();

                        $aviso = '<div id="aviso-form" class="confirmacion"><ul>';
                        $aviso .= '<li>El ítem fue editado de forma satisfactoria. </li>';
                        $aviso .= '</ul></div>';

                        echo $aviso;

                    } catch (Exception $e) {

                        $aviso = '<div id="aviso-form" class="error"><ul><li>Ocurrió un error el intentar agregar el ítem</li></ul></div>';
                    }
                } else {
                    $form->populate($request->getPost());
                    echo $form;
                }
            }
        }
    }

    public function deleteAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $nota_id = $this->_getParam('id');

            if($this->_helper->validateRecordExists('notas_ventas', 'id', $nota_id)){
                
                $data = $this->_getParam('data');
                $items = explode(",", $data);

                $itemNota = new Default_Model_ItemNotaVenta();

                foreach($items as $id){

                    if($this->_helper->validateRecordExists('items_notas_ventas', 'id', $id)){
                        $where = $itemNota->getAdapter()->quoteInto("id=?", $id);
                        $itemNota->delete($where);
                    }
                }
                return true;
            }
        }
    }

    public function addItemsCotizacionAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $nota_id = $this->_getParam('from_id');
            $cotizacion_id = $this->_getParam('id');

            if($this->_helper->validateRecordExists('notas_ventas', 'id', $nota_id)){

                $data = $this->_getParam('data');
                $items = explode(",", $data);

                foreach($items as $id){

                    if($this->_helper->validateRecordExists('items_cotizaciones', 'id', $id)){

                        $itemCotizacion = new Default_Model_ItemCotizacion();
                        $where = $itemCotizacion->getAdapter()->quoteInto("id=?", $id);
                        $rowItemCotizacion = $itemCotizacion->fetchRow($where);

                        $itemNota                   = new Default_Model_ItemNotaVenta();
                        $rowItemNota                = $itemNota->createRow();
                        $rowItemNota->nota_id       = $nota_id;
                        $rowItemNota->vehiculo      = $rowItemCotizacion->vehiculo;
                        $rowItemNota->codigo        = $rowItemCotizacion->codigo;
                        $rowItemNota->nombre        = $rowItemCotizacion->nombre;
                        $rowItemNota->descripcion   = $rowItemCotizacion->descripcion;
                        $rowItemNota->cantidad      = $rowItemCotizacion->cantidad;
                        $rowItemNota->unidad_medida = $rowItemCotizacion->unidad_medida;
                        $rowItemNota->valor_neto    = $rowItemCotizacion->valor_neto;
                        $rowItemNota->descuento     = $rowItemCotizacion->descuento;
                        $rowItemNota->table         = $rowItemCotizacion->table;
                        $rowItemNota->save();

                    }
                }
                
                if($this->_getParam('archive')==1){
                    $state = Default_Model_Cotizacion::archivar($id, 1);

                    if($state==true){

                        $aviso = '<div id="aviso-form" class="confirmacion"><ul>';
                        $aviso .= '<li>Los ítems fueron agregados de forma satisfactoria y la cotización archivada. </li>';
                        $aviso .= '</ul></div>';
                        echo $aviso;

                    } else {

                        echo $state;

                    }
                } else {

                    $aviso = '<div id="aviso-form" class="confirmacion"><ul>';
                    $aviso .= '<li>Los ítems fueron agregados de forma satisfactoria.</li>';
                    $aviso .= '</ul></div>';
                    echo $aviso;
                    
                }
            }
        }
    }

    private function _calcularDescuento($tipo, $descuento, $neto)
    {
        if(!isset($tipo) OR !isset($descuento) OR !isset($neto)){
            return false;
        }

        if($tipo=='MONTO') {
            return $descuento;
        }

        if($tipo=='PORCENTAJE'){
            $monto = round($neto * ($descuento/100));
            return $monto;
        }
    }

    private function _checkItemsCotizacion($cotizacion_id)
    {
        return true;
    }
}