<?php
class ItemOrdenCompraController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();

        if (!$auth->hasIdentity()) {
            $this->_redirect('/');
        }
    }
    
    public function init()
    {
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/item-orden-compra';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }

    public function getFormAction()
    {

        if($this->getRequest()->isXmlHttpRequest()){

            $request = $this->getRequest();
            $form = new Default_Form_ItemOrdenCompra();

            if($this->_request->getParam('id')) {

                $item = new Default_Model_ItemOrdenCompra();
                $where = $item->getAdapter()->quoteInto("id=?", (int)$this->_request->getParam('id'));
                $row = $item->fetchRow($where)->toArray();
                $form->populate($row);
                $form->setAction('/item-orden-compra/edit');
                $form->submit->setLabel('Guardar cambios');

            } elseif($this->_request->getParam('from_id')) {
                $form->orden_id->setValue($this->_request->getParam('from_id'));
            }
            echo $form;
        }
    }

    public function newAction()
    {
        if($_POST) {

            $request = $this->getRequest();
            $form = new Default_Form_ItemOrdenCompra();

            if ($this->getRequest()->isPost()) {
                if ($form->isValid($request->getPost())) {

                    try {

                        $item = new Default_Model_ItemOrdenCompra();
                        $row = $item->createRow();
                        $row->orden_id = $form->getValue('orden_id');
                        $row->codigo = $form->getValue('codigo');
                        $row->cantidad = $form->getValue('cantidad');
                        $row->unidad_medida = $form->getValue('unidad_medida');
                        $row->valor_neto = $form->getValue('valor_neto');
                        $row->descuento =  $this->_helper->calcularDescuento($form->getValue('tipo_descuento'), $form->getValue('descuento'), $form->getValue('valor_neto'));
                        $row->nombre = $form->getValue('nombre');
                        $row->descripcion = $form->getValue('descripcion');
                        $row->save();

                        $form->reset();
                        $form->orden_id->setValue($row->orden_id);

                        $aviso = '<div id="aviso-form" class="confirmacion"><ul>';
                        $aviso .= '<li>El ítem fue agregado de forma satisfactoria. </li>';
                        $aviso .= '</ul></div>';

                        echo $aviso.$form;

                    } catch (Exception $e) {
                        $aviso = '<div id="aviso-form" class="error"><ul><li>Ocurrió un error el intentar agregar el ítem</li></ul></div>';
                    }

                } else {
                    $form->populate($request->getPost());
                    echo $form;
                }
            }
        }
    }

    public function editAction()
    {
        if($_POST) {

            $request = $this->getRequest();
            $form = new Default_Form_ItemOrdenCompra();

            if ($this->getRequest()->isPost()) {
                if ($form->isValid($request->getPost())) {

                    try {

                        $id = $form->getValue('id');

                        $item = new Default_Model_ItemOrdenCompra();
                        $where = $item->getAdapter()->quoteInto("id=?", $id);
                        $row = $item->fetchRow($where);
                        $row->codigo = $form->getValue('codigo');
                        $row->cantidad = $form->getValue('cantidad');
                        $row->unidad_medida = $form->getValue('unidad_medida');
                        $row->valor_neto = $form->getValue('valor_neto');
                        $row->descuento =  $this->_helper->calcularDescuento($form->getValue('tipo_descuento'), $form->getValue('descuento'), $form->getValue('valor_neto'));
                        $row->nombre = $form->getValue('nombre');
                        $row->descripcion = $form->getValue('descripcion');
                        $row->save();

                        $aviso = '<div id="aviso-form" class="confirmacion"><ul>';
                        $aviso .= '<li>El ítem fue editado de forma satisfactoria. </li>';
                        $aviso .= '</ul></div>';

                        echo $aviso;

                    } catch (Exception $e) {

                        $aviso = '<div id="aviso-form" class="error"><ul><li>Ocurrió un error el intentar editar el ítem</li></ul></div>';
                    }
                } else {
                    $form->populate($request->getPost());
                    echo $form;
                }
            }
        }
    }

    public function deleteAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $orden_id = $this->_getParam('id');

            if($this->_helper->validateRecordExists('ordenes_compras', 'id', $orden_id)){

                $data = $this->_getParam('data');
                $items = explode(",", $data);

                $itemOrden = new Default_Model_ItemOrdenCompra();

                foreach($items as $id){

                    if($this->_helper->validateRecordExists('items_ordenes_compras', 'id', $id)){
                        $where = $itemOrden->getAdapter()->quoteInto("id=?", $id);
                        $itemOrden->delete($where);
                    }
                }
                return true;
            }
        }
    }
}