<?php
class ItemPautaMantencionController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();

        if (!$auth->hasIdentity()) {
            $this->_redirect('/');
        }
    }
    
    public function init()
    {
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/item-pauta-mantencion';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }

    public function getFormAction()
    {

        if($this->getRequest()->isXmlHttpRequest()){
            
            if($this->_getParam('id') AND 
               $this->_helper->validateRecordExists('items_pautas_mantenciones','id', $this->_getParam('id'))) {

                $request = $this->getRequest();
                $form = new Default_Form_ItemPautaMantencion();

                $item = new Default_Model_ItemPautaMantencion();
                $where = $item->getAdapter()->quoteInto("id=?", (int)$this->_getParam('id'));
                $row = $item->fetchRow($where)->toArray();
                $form->populate($row);
                $form->setAction('/item-pauta-mantencion/edit');
                $form->submit->setLabel('Guardar cambios');
                echo $form;
                
            } elseif($this->_getParam('pauta_id') AND
                     $this->_helper->validateRecordExists('pautas_mantenciones','id', $this->_getParam('pauta_id'))) {

                $form = new Default_Form_ItemPautaMantencion();
                $form->pauta_id->setValue($this->_getParam('pauta_id'));
                echo $form;
            }
        }
    }
    
    public function newAction()
    {
        if($_POST) {

            $request = $this->getRequest();
            $form = new Default_Form_ItemPautaMantencion();

            if ($this->getRequest()->isPost()) {
                if ($form->isValid($request->getPost())) {
                    
                    try {

                        $item = new Default_Model_ItemPautaMantencion();
                        $row = $item->createRow();
                        $row->pauta_id = $form->getValue('pauta_id');
                        $row->servicio = $form->getValue('servicio');
                        $row->km_primer_servicio = $form->getValue('km_primer_servicio');
                        $row->km_ciclo_inicio = $form->getValue('km_ciclo_inicio');
                        $row->km_ciclo_intervalo = $form->getValue('km_ciclo_intervalo');
                        $row->km_ciclo_fin = $form->getValue('km_ciclo_fin');
                        $row->save();

                        $form->reset();
                        $form->pauta_id->setValue($row->pauta_id);

                        $aviso = '<div id="aviso-form" class="confirmacion"><ul>';
                        $aviso .= '<li>El ítem fue agregado de forma satisfactoria. </li>';
                        $aviso .= '</ul></div>';

                        echo $aviso.$form;

                    } catch (Exception $e) {
                        $aviso = '<div id="aviso-form" class="error"><ul><li>Ocurrió un error el intentar agregar el ítem</li></ul></div>';
                    }

                } else {
                    $form->populate($request->getPost());
                    echo $form;
                }
            }
        }
    }

    public function editAction()
    {
        if($_POST) {

            $request = $this->getRequest();
            $form = new Default_Form_ItemPautaMantencion();

            if ($this->getRequest()->isPost()) {
                if ($form->isValid($request->getPost())) {

                    try {

                        $id = $form->getValue('id');

                        $item = new Default_Model_ItemPautaMantencion();
                        $where = $item->getAdapter()->quoteInto("id=?", $id);
                        $row = $item->fetchRow($where);
                        $row->servicio = $form->getValue('servicio');
                        $row->km_primer_servicio = $form->getValue('km_primer_servicio');
                        $row->km_ciclo_inicio = $form->getValue('km_ciclo_inicio');
                        $row->km_ciclo_intervalo = $form->getValue('km_ciclo_intervalo');
                        $row->km_ciclo_fin = $form->getValue('km_ciclo_fin');
                        $row->save();

                        $aviso = '<div id="aviso-form" class="confirmacion"><ul>';
                        $aviso .= '<li>El ítem fue editado de forma satisfactoria. </li>';
                        $aviso .= '</ul></div>';

                        echo $aviso;

                    } catch (Exception $e) {

                        $aviso = '<div id="aviso-form" class="error"><ul><li>Ocurrió un error el intentar editar el ítem</li></ul></div>';
                    }
                } else {
                    $form->populate($request->getPost());
                    echo $form;
                }
            }
        }
    }

    public function deleteAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $pauta_id = $this->_getParam('pauta_id');

            if($this->_helper->validateRecordExists('pautas_mantenciones', 'id', $pauta_id)){

                $data = $this->_getParam('data');
                $items = explode(",", $data);

                $itemPauta = new Default_Model_ItemPautaMantencion();

                foreach($items as $id){

                    if($this->_helper->validateRecordExists('items_pautas_mantenciones', 'id', $id)){
                        $where = $itemPauta->getAdapter()->quoteInto("id=?", $id);
                        $itemPauta->delete($where);
                    }
                }
                return true;
            }
        }
    }
}