<?php
class OrdenCompraController extends Zend_Controller_Action
{
    public function init()
    {
        $action = $this->getRequest()->getActionName();
        if($action != 'export-pdf' AND $action != 'create-pdf'){
            $auth = Zend_Auth::getInstance();
            if (!$auth->hasIdentity()) {
                $this->_redirect('/index/exit');
            }
        }
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/orden-compra';
        $propietario = new Default_Model_Propietario();
        $this->view->propietario = $propietario->fetchRow();
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->preferencias = Default_Model_OrdenCompra::_getPrefs();
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }
    
    public function indexAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $currentPage = $this->_getParam('page', 1);

            $orden = new Default_Model_VistaOrdenesCompras();
            $ordenes = $orden->fetchAll();

            $paginador = Zend_Paginator::factory($ordenes);
            $paginador->setItemCountPerPage($this->paginacion['cant_items'])
                      ->setPageRange($this->paginacion['cant_pages'])
                      ->setCurrentPageNumber($currentPage);

            Zend_View_Helper_PaginationControl::setDefaultViewPartial('pagination_control.phtml');

            $this->view->ordenes = $paginador;
            $this->view->title = 'Órdenes de compra';
            $this->renderScript('orden-compra/index.phtml');
        }
    }

    public function getFormAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $request = $this->getRequest();
            $form = new Default_Form_OrdenCompra(null, $this->path);

            if($this->_request->getParam('id')) {

                $id = (int)$this->_request->getParam('id');
                $orden = new Default_Model_OrdenCompra();
                $where = $orden->getAdapter()->quoteInto("id=?", $id);
                $row = $orden->fetchRow($where)->toArray();
                $form->populate($row);
                $form->setAction('/orden-compra/edit');
                $rut = App_Rut::format($form->proveedor->getValue());
                $form->proveedor->setValue($rut);
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar orden de compra Nº $id";

            } else {

                $this->view->title = "Crear orden de compra";
                $form->fecha->setValue(date("Y-m-d"));
                $form->emitida_por->setValue($this->usuario->empleado);
                if($this->_request->getParam('from_id')) {

                    $rut = App_Rut::format($this->_request->getParam('from_id'));
                    $form->proveedor->setValue($rut);

                }

            }
            $this->view->form = $form;
            $this->renderScript('orden-compra/form.phtml');
        }
    }

    public function getFormToConvertSolicitudAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $request = $this->getRequest();
            $form = new Default_Form_OrdenCompra(null, $this->path);

            if($this->_request->getParam('id')) {

                $id = (int)$this->_request->getParam('id');
                $orden = new Default_Model_OrdenCompra();
                $where = $orden->getAdapter()->quoteInto("id=?", $id);
                $row = $orden->fetchRow($where)->toArray();
                $form->populate($row);
                $form->setAction('/orden-compra/edit');
                $rut = App_Rut::format($form->proveedor->getValue());
                $form->proveedor->setValue($rut);
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar orden de compra Nº $id";

            } else {

                $this->view->title = "Crear orden de compra";
                $form->fecha->setValue(date("Y-m-d"));
                $form->emitida_por->setValue($this->usuario->empleado);
                if($this->_request->getParam('rut')) {

                    $rut = App_Rut::format($this->_request->getParam('rut'));
                    $form->proveedor->setValue($rut);

                }

            }
            $this->view->form = $form;
            $this->renderScript('orden-compra/form.phtml');
        }
    }

    public function viewAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $id = (int)$this->_getParam('id', 0);

            $orden = new Default_Model_VistaOrdenesCompras();
            $where = $orden->getAdapter()->quoteInto("id=?", $id);
            $row = $orden->fetchRow($where);

            $items = new Default_Model_ItemOrdenCompra();
            $where_items = $items->getAdapter()->quoteInto("orden_id=?", $id);

            $envio = new Default_Model_EnvioDocumento();
            $where_envio = "documento_id='$id' AND tipo='orden-compra'";
            $order_envio = "id DESC";
            $count_envio = '1';
            $rows_envios = $envio->fetchAll($where_envio, $order_envio, $count_envio)->toArray();


            $this->view->items = $items->fetchAll($where_items);
            $this->view->title = "Orden de compra Nº $id";
            $this->view->envios = $rows_envios;

            if(false==$row) {
                $this->_forward('index','orden-compra');
            } else {

                $this->view->orden = $row;

                if($row->estado=='BORRADOR') {

                    $this->view->title .= " : Borrador";
                    $this->renderScript('orden-compra/view-borrador.phtml');

                } elseif($row->estado=='PENDIENTE') {

                    $this->view->title .= " : Pendiente aprobación";
                    
                    if($this->_getParam('check')=='a') {
                        $this->renderScript('orden-compra/review.phtml');
                    } else {
                        $this->renderScript('orden-compra/view-pendiente.phtml');
                    }

                } elseif($row->estado=='EMITIDA') {

                    $this->view->title .= " : Emitida";
                    $this->renderScript('orden-compra/view-emitida.phtml');

                } elseif($row->estado=='RECHAZADA') {

                    $this->view->title .= " : Rechazada";
                    $this->renderScript('orden-compra/view-rechazada.phtml');
                } 
            }
        }
    }

    public function newAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_OrdenCompra(null, $this->path);
        $this->view->title = 'Crear orden de compra';

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {

                    $orden = new Default_Model_OrdenCompra();
                    $row = $orden->createRow();
                    $row->creador = $this->usuario->rut;
                    $row->proveedor = App_Rut::cleanToDb($form->getValue('proveedor'));
                    $row->fecha = $form->getValue('fecha');
                    $row->validez = $form->getValue('validez');
                    $row->atencion_a = $form->getValue('atencion_a');
                    $row->emitida_por = $form->getValue('emitida_por');
                    $row->condiciones_pago = $form->getValue('condiciones_pago');
                    $row->descuento_global = $form->getValue('descuento_global');
                    $row->proveedor_paga_flete = $form->getValue('proveedor_paga_flete');
                    $row->iva = $this->view->getPref('IVA');
                    $row->referencia = $form->getValue('referencia');
                    if($form->getValue('observaciones')) {
                        $row->observaciones = $form->getValue('observaciones');
                    } else {
                        $row->observaciones = NULL;
                    }
                    $row->estado = 'BORRADOR';
                    $row->save();
                    $id = $row->id;
                    $mSession->mensajes[] = 'La orden de compra fue creada de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                    $this->_forward('view','orden-compra', null, array('id'=>$id));

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear la solicitud de compra.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_forward('new','orden-compra');
                }
            } else {
                $this->view->form = $form;
                $form->populate($request->getPost());
                $this->renderScript('orden-compra/form.phtml');
            }
        }
    }

    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $orden = new Default_Model_OrdenCompra();

        $request = $this->getRequest();
        $form = new Default_Form_OrdenCompra();

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    $id = (int)$form->getValue('id');
                    $where = $orden->getAdapter()->quoteInto("id=?", $id);
                    $row = $orden->fetchRow($where);
                    $row->creador = $this->usuario->rut;
                    $row->proveedor = App_Rut::cleanToDb($form->getValue('proveedor'));
                    $row->fecha = $form->getValue('fecha');
                    $row->validez = $form->getValue('validez');
                    $row->atencion_a = $form->getValue('atencion_a');
                    $row->emitida_por = $form->getValue('emitida_por');
                    $row->condiciones_pago = $form->getValue('condiciones_pago');
                    $row->descuento_global = $form->getValue('descuento_global');
                    $row->proveedor_paga_flete = $form->getValue('proveedor_paga_flete');
                    $row->iva = $this->view->getPref('IVA');
                    $row->referencia = $form->getValue('referencia');
                    if($form->getValue('observaciones')) {
                        $row->observaciones = $form->getValue('observaciones');
                    } else {
                        $row->observaciones = NULL;
                    }
                    $row->save();

                    $mSession->mensajes[] = 'La orden de compra fue editada de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                    $this->_forward('view', 'orden-compra', null, array('id'=> $id));

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar la orden de compra.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_forward('index','orden-compra');
                }

            } else {

                $form->populate($request->getPost());
                $this->view->form = $form;
                $form->setAction('/orden-compra/edit');
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar orden";
                $this->renderScript('orden-compra/form.phtml');
            }
        }
    }

    public function getFormRejectAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->getRequest()->isXmlHttpRequest()){

            $orden = new Default_Model_OrdenCompra();
            $id = $orden->getAdapter()->quote($this->_request->getParam('id'));
            $row = $orden->fetchRow('id='. $id);

            if(false!=$row) {

                $request = $this->getRequest();
                $form = new Default_Form_RechazarDocumento(null, $this->path);
                $form->setAction('/orden-compra/rechazar');
                $form->submit->setLabel('Rechazar orden de compra');
                $form->id->setValue($row->id);
                $this->view->title = "Rechazar orden de compra";
                $this->view->form = $form;
                $this->renderScript('orden-compra/rechazar.phtml');

            }
        } 
    }
   
    public function finishAction()
    {
        if($this->getRequest()->isXmlHttpRequest() AND 
           $this->_getParam('id') AND
           $this->_helper->validateRecordExists('ordenes_compras', 'id', $this->_getParam('id'))){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $id = (int)$this->_getParam('id');
            $v_orden = new Default_Model_VistaOrdenesCompras();
            $where = $v_orden->getAdapter()->quoteInto("id=?", $id);
            $v_row = $v_orden->fetchRow($where);

             if($v_row->estado=='BORRADOR') {
                 if(NULL!=$v_row->total_neto && $v_row->total_neto!==0) {

                    $orden = new Default_Model_OrdenCompra();
                    $row = $orden->fetchRow($where);

                    if($v_row->total_neto >= $this->preferencias['OC_MONTO_APROB']) {
                         
                        $row->estado = 'PENDIENTE';
                        $row->iva = $this->view->getPref('IVA');

                        $modelAutorizacion = new Default_Model_AutorizacionDocumento();
                        $rowAutorizacion = $modelAutorizacion->createRow();
                        $rowAutorizacion->documento_controller = 'orden-compra';
                        $rowAutorizacion->documento_id = $id;
                        $rowAutorizacion->documento_nombre = 'Orden de compra';
                        $rowAutorizacion->save();

                        $mSession->mensajes[] = 'La orden de compra fue emitida de forma exitosa pero quedó a la espera de aprobación.';
                        $mSession->claseMensaje = 'advertencia';
                        
                    } else {
                        $row->estado = 'EMITIDA';
                        $row->iva = $this->view->getPref('IVA');

                        $mSession->mensajes[] = 'La orden de compra fue emitida de forma exitosa';
                        $mSession->claseMensaje = 'confirmacion';
                    }

                    $row->save();
                    
                    
                }  else {

                    $mSession->mensajes[] = 'Debe agregar ítems a la orden de compra';
                    $mSession->claseMensaje = 'error';
                }
            }
            $this->_forward('view','orden-compra', null, array('id' => $row->id));
        }
    }

    public function aprobarAction()
    {
        if($this->getRequest()->isXmlHttpRequest() &&
           $this->_getParam('id') &&
           $this->_helper->validateRecordExists('vista_ordenes_compras', 'id', $this->_getParam('id'))){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }
            
            $orden = new Default_Model_OrdenCompra();
            $id = (int)$this->_getParam('id');
            $where = $orden->getAdapter()->quoteInto("id=?", $id);
            $row = $orden->fetchRow($where);

            if($row->estado=='PENDIENTE') {

                $row->estado = 'EMITIDA';
                $row->save();

                $autorizacion = new Default_Model_AutorizacionDocumento();
                $whereAutorizacion = "documento_controller='orden-compra' AND documento_id='$id'";
                $rowAutorizacion = $autorizacion->fetchRow($whereAutorizacion);
                $rowAutorizacion->estado = 1;
                $rowAutorizacion->autorizado_por = $this->usuario->rut;
                $rowAutorizacion->autorizacion = date("Y-m-d H:i:s");
                $rowAutorizacion->save();

            }
            $mSession->mensajes[] = 'La orden de compra fue </strong>aprobada</strong> de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_forward('autorizaciones','admin');
        }
    }

    public function rechazarAction()
    {
        if($this->getRequest()->isXmlHttpRequest() &&
           $this->_getParam('id') &&
           $this->_helper->validateRecordExists('vista_ordenes_compras', 'id', $this->_getParam('id'))){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $orden = new Default_Model_OrdenCompra();
            $id = (int)$this->_getParam('id');
            $where = $orden->getAdapter()->quoteInto("id=?", $id);
            $row = $orden->fetchRow($where);

            if($row->estado=='PENDIENTE') {

                $row->estado = 'RECHAZADA';
                $row->save();

                $autorizacion = new Default_Model_AutorizacionDocumento();
                $whereAutorizacion = "documento_controller='orden-compra' AND documento_id='$id'";
                $rowAutorizacion = $autorizacion->fetchRow($whereAutorizacion);
                $rowAutorizacion->estado = 1;
                $rowAutorizacion->autorizado_por = $this->usuario->rut;
                $rowAutorizacion->autorizacion = date("Y-m-d H:i:s");
                $rowAutorizacion->save();

            }
            $mSession->mensajes[] = 'La orden de compra fue </strong>rechazada</strong> de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_forward('autorizaciones','admin');

        }
    }

    public function deleteAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $id = $this->_getParam('id');
            $orden = new Default_Model_OrdenCompra();
            $where = $orden->getAdapter()->quoteInto('id = ?' , $id);
            $orden->delete($where);
            $mSession->mensajes[] = 'La orden de compra fue eliminada de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_forward('index','orden-compra');

        } else {
            $this->_forward('logout', 'index');
        }
    }

    public function findAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->getRequest()->isXmlHttpRequest()){

            $formularios = array(
                new Default_Form_BuscarNumero(null, $this->path),
                new Default_Form_ConsultaOrdenCompra(null, $this->path),
            );

            $request = $this->getRequest();
            $this->view->formularios = $formularios;
            $this->view->title = 'Órdenes de compra : Buscar';
            $this->renderScript('orden-compra/find.phtml');
            
        } else {
            $this->_forward('logout','index');
        }
    }

    public function detalleAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            if($this->_getParam('id') AND
                $this->_helper->validateRecordExists('ordenes_compras','id', $this->_getParam('id'))){

                $id = $this->_getParam('id');

                $orden = new Default_Model_VistaOrdenesCompras();
                $where = $orden->getAdapter()->quoteInto("id=?", $id);
                $row = $orden->fetchRow($where);

                $items = new Default_Model_ItemOrdenCompra();
                $where_items = $items->getAdapter()->quoteInto("orden_id=?", $id);

                $this->view->items = $items->fetchAll($where_items);
                $this->view->orden = $row;

               $this->renderScript('orden-compra/detalle.phtml');
            }
        }
    }

    public function listByProveedorAction()
    {
        if($this->getRequest()->isXmlHttpRequest() && 
           $this->_getParam('id') &&
           $this->_helper->validateRecordExists('proveedores', 'rut', App_Rut::cleanToDb($this->_getParam('id')))){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $rut = App_Rut::cleanToDb($this->_getParam('id'));
            $currentPage = $this->_getParam('page', 1);

            $model = new Default_Model_VistaOrdenesCompras();
            $where = $model->getAdapter()->quoteInto('proveedor_id=?', $rut);
            $ordenes = $model->fetchAll($where);

            $paginador = Zend_Paginator::factory($ordenes);
            $paginador->setItemCountPerPage($this->paginacion['cant_items'])
                      ->setPageRange($this->paginacion['cant_pages'])
                      ->setCurrentPageNumber($currentPage);

            Zend_View_Helper_PaginationControl::setDefaultViewPartial('pagination_control_extra.phtml');

            $this->view->ordenes = $paginador;
            $this->renderScript('orden-compra/list-by-proveedor.phtml');
        }
    }

    public function printAction()
    {
        if($this->_getParam('id') AND
           $this->_helper->validateRecordExists('vista_ordenes_compras','id', $this->_getParam('id'))){

            $this->_helper->layout->disableLayout(false);
            $this->_helper->viewRenderer->setNoRender(false);
            $this->_helper->layout->setLayout('print');

            $id = (int)$this->_getParam('id');
            $orden = new Default_Model_VistaOrdenesCompras();
            $where = $orden->getAdapter()->quoteInto("id=?", $id);
            $row = $orden->fetchRow($where);

            if(false!==$row AND $row['estado']=='EMITIDA') {

                $item = new Default_Model_ItemOrdenCompra();
                $where_items = $item->getAdapter()->quoteInto("orden_id=?",$id);
                $items = $item->fetchAll($where_items);

                $this->view->title = "Orden de compra Nº $id";
                $this->view->orden = $row;
                $this->view->items = $items;
                $this->view->condiciones_generales = Default_Model_CondicionGeneral::getTexto('ORDEN_COMPRA');
            }
        }
    }

    public function mailAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_SendAttach(null, $this->path);

        if($this->getRequest()->isXmlHttpRequest() AND
           $this->_getParam('id') AND
           $this->_helper->validateRecordExists('vista_ordenes_compras', 'id', $this->_getParam('id'))){

            $documento = 'orden-compra';
            $id = (int)$this->_getParam('id');
            $name = $documento . '-' . $id .'.pdf';
            $back = '/' . $documento . '/view/' . $id;

            $formValues = array(
                'archivo'       => $name,
                'id'            => $id,
                'documento'     => $documento,
                'asunto'        => 'ExpressAuto S.p.A. - Orden de compra Nº ' . $id,
                'texto_mensaje' => 'Adjunto orden de compra',
                'back'          => $back
            );


            $form->copia->setLabel('Enviar una copia a mi casilla ('.  $this->usuario->mail .')');
            $form->populate($formValues);

            $this->view->form = $form;
            $this->view->title = "Enviar documento adjunto por mail";
            $this->renderScript('archivos-comunes/form.phtml');
        }
    }

    public function sendAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_SendAttach(null, $this->path);
        $form->copia->setLabel('Enviar una copia a mi casilla ('.  $this->usuario->mail .')');

        if ($this->getRequest()->isPost()) {

            if ($form->isValid($request->getPost())) {

                try {

                    $mail = new App_HtmlMailerDocument('UTF-8');
                    $mail->setFrom($this->usuario->mail, $this->usuario->empleado);
                    $mail->setType(Zend_Mime::MULTIPART_RELATED);
                    $mail->setSubject($form->getValue('asunto'))
                         ->setViewParam('nombre', $form->getValue('nombre'))
                         ->setViewParam('usuario', $this->usuario->empleado)
                         ->setViewParam('mensaje', $form->getValue('texto_mensaje'));

                    $mail->addTo($form->getValue('mail'), $form->getValue('nombre'));

                    if($form->copia->getValue()==1){
                        $mail->addBcc($this->usuario->mail);
                    }

                    $path =  '/orden-compra/create-pdf/' . $form->getValue('id');
                    $pdf = new App_Pdf($path);
                    $attach = $mail->createAttachment($pdf->getContent());
                    $attach->filename = $form->getValue('archivo');

                    $mail->sendHtmlTemplate('send-attach.phtml');

                    $envio = new Default_Model_EnvioDocumento();
                    $row = $envio->createRow();
                    $row->creador = $this->usuario->rut;
                    $row->tipo = 'orden-compra';
                    $row->documento_id = $form->getValue('id');
                    $row->nombre = $form->getValue('nombre');
                    $row->mail = $form->getValue('mail');
                    $row->save();

                    $mSession->mensajes[] = 'El mensaje fue enviado de forma satisfactoria.';
                    $mSession->claseMensaje = 'confirmacion';

                    $this->_forward('view', 'orden-compra', null, array('id' => $form->getValue('id')));

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar enviar el mensaje, por favor inténtelo más tarde.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect($form->getValue('back'));
                }

            } else {

                $form->populate($request->getPost());
                $this->view->form = $form;
                $this->renderScript('archivos-comunes/form.phtml');
            }
        }
    }

    public function pdfAction()
    {
        if($this->_getParam('id') && 
           $this->_helper->validateRecordExists('vista_ordenes_compras','id', $this->_getParam('id'))){
            $documento = 'orden-compra';
            $id = (int)$this->_getParam('id');
            $path = '/orden-compra/create-pdf/'. $id;
            $name = $documento . '-' . $id .'.pdf';
            $pdf = new App_Pdf($path);
            $pdf->setName($name);
            $pdf->download();
        }
    }

    public function createPdfAction()
    {
        $this->_helper->layout->disableLayout(false);
        $this->_helper->viewRenderer->setNoRender(false);
        $this->_helper->layout->setLayout('pdf');
        $id = (int)$this->_getParam('id');
        $orden = new Default_Model_VistaOrdenesCompras();
        $where = $orden->getAdapter()->quoteInto("id=?", $id);
        $row = $orden->fetchRow($where);

        if(false!==$row AND $row['estado']=='EMITIDA') {
            $item = new Default_Model_ItemOrdenCompra();
            $where_items = $item->getAdapter()->quoteInto("orden_id=?",$id);
            $items = $item->fetchAll($where_items);
            $this->view->title = "Orden de compra Nº $id";
            $this->view->orden = $row;
            $this->view->items = $items;
            $this->view->condiciones_generales = Default_Model_CondicionGeneral::getTexto('ORDEN_COMPRA');
        }
    }
}