<?php
class OrdenServicioInformeController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
    }
    
    public function init()
    {
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/orden-servicio-informe';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }

    public function getFormAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            
            if($this->_getParam('from_id') &&
               $this->_helper->validateRecordExists('ordenes_servicios','id', $this->_getParam('from_id'))) {

                $request = $this->getRequest();
                $form = new Default_Form_OrdenServicioInforme();
                $form->orden_id->setValue((int)$this->_getParam('from_id'));

                if($this->_getParam('type_user')==1){
                    $form->type_user->setValue(1);
                }


                $informe = new Default_Model_OrdenServicioInforme();
                $where = $informe->getAdapter()->quoteInto("orden_id=?", (int)$this->_getParam('from_id'));
                $order = "id DESC";
                $row = $informe->fetchRow($where, $order);

                if(NULL!==$row){
                    $form->populate($row->toArray());
                    $form->submit->setLabel('Guardar cambios');
                }
                echo $form;
            } 
        }
    }

    public function newAction()
    {
        $request = $this->getRequest();
        $form = new Default_Form_OrdenServicioInforme();

        if ($this->getRequest()->isPost()) {

            if ($form->isValid($request->getPost())) {

                try {

                    $informe = new Default_Model_OrdenServicioInforme();
                    $row = $informe->createRow();
                    $row->orden_id = $form->getValue('orden_id');
                    $row->creador = $this->usuario->rut;
                    $row->informe = $form->getValue('informe');
                    $row->save();

                    $aviso = '<div id="aviso-form" class="confirmacion"><ul>';
                    $aviso .= '<li>El informe de servicio fue guardado de forma exitosa.</li>';
                    $aviso .= '</ul></div>';

                    if($form->getValue('type_user')=='1'){
                        $this->_forward('view-small', 'orden-servicio', null,
                            array(
                                'id' => $row->orden_id,
                                'type_user' => 1
                            )
                        );
                    } else {
                        echo $aviso;
                    }

                } catch (Exception $e) {
                    $aviso = '<div id="aviso-form" class="error"><ul><li>Ocurrió un error al crear el informe</li></ul></div>';
                }

            } else {

                $form->populate($request->getPost());
                echo $form;
                
            }
        }
    }
}