<?php
class PautaMantencionController extends Zend_Controller_Action
{
    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/pauta-mantencion';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }

    public function indexAction()
    {
       if($this->getRequest()->isXmlHttpRequest()){

           $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $currentPage = $this->_getParam('page', 1);

            $pauta = new Default_Model_VistaPautasMantenciones();
            $pautas = $pauta->fetchAll();

            $paginador = Zend_Paginator::factory($pautas);
            $paginador->setItemCountPerPage($this->paginacion['cant_items'])
                      ->setPageRange($this->paginacion['cant_pages'])
                      ->setCurrentPageNumber($currentPage);

            Zend_View_Helper_PaginationControl::setDefaultViewPartial('pagination_control.phtml');

            $this->view->pautas = $paginador;
            $this->view->title = 'Pautas de mantenimiento';
            $this->renderScript('pauta-mantencion/index.phtml');
       }
        
    }

    public function getFormAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->getRequest()->isXmlHttpRequest()){

            $request = $this->getRequest();
            $form = new Default_Form_PautaMantencion(null, $this->path);

            if($this->_request->getParam('id')) {

                $pauta = new Default_Model_PautaMantencion();
                $id = $pauta->getAdapter()->quote($this->_request->getParam('id'));
                $row = $pauta->fetchRow("id=$id")->toArray();
                $form->populate($row);
                $form->setAction('/pauta-mantencion/edit');
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar pauta de mantenimiento";

            } else {

                $this->view->title = "Crear pauta de mantenimiento";

            }
            $this->view->form = $form;
            $this->renderScript('pauta-mantencion/form.phtml');
        }
    }

    public function getFormLotesAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->getRequest()->isXmlHttpRequest()){

            $request = $this->getRequest();
            $form = new Default_Form_PautasMantenciones(null, $this->path);
            $this->view->title = "Agregar pautas de mantenciones por lotes";
            $this->view->form = $form;
            $this->renderScript('pauta-mantencion/form-lotes.phtml');
        }
    }

    public function newAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_PautaMantencion(null, $this->path);
        $this->view->title = "Crear pauta";

        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {

                try {

                    $pauta = new Default_Model_PautaMantencion();
                    $row = $pauta->createRow();
                    $row->creador = $this->usuario->rut;
                    $row->marca_id = $form->getValue('marca_id');
                    $row->modelos_referencia = $form->getValue('modelos_referencia');
                    if($form->getValue('observaciones')!=''){
                        $row->observaciones = $form->getValue('observaciones');
                    } else {
                        $row->observaciones = NULL;
                    }
                    $row->save();

                    $mSession->mensajes[] = 'El registro fue creado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear el registro.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';

                }
                
                $this->_redirect($this->path . '/view/id/' . $row->id);

            } else {
                $this->view->form = $form;
                $form->populate($request->getPost());
                $this->renderScript('pauta-mantencion/form.phtml');
            }
        }
    }
    
    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $pauta = new Default_Model_PautaMantencion();

        $request = $this->getRequest();
        $form = new Default_Form_PautaMantencion(null, $this->path);

        if ($this->getRequest()->isPost()) {

            if ($form->isValid($request->getPost())) {

                try {

                    $id = (int)$form->getValue('id');
                    $where = $pauta->getAdapter()->quoteInto("id=?", $id);
                    $row = $pauta->fetchRow($where);
                    $row->creador = $this->usuario->rut;
                    $row->marca_id = $form->getValue('marca_id');
                    $row->modelos_referencia = $form->getValue('modelos_referencia');
                    if($form->getValue('observaciones')!=''){
                        $row->observaciones = $form->getValue('observaciones');
                    } else {
                        $row->observaciones = NULL;
                    }
                    $row->save();

                    $mSession->mensajes[] = 'La pauta fue editada de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_forward('view', 'pauta-mantencion', null, array('id'=> $id));


                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar la pauta.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';

                    $this->_forward('index','pauta-mantencion');
                }

            } else {

                $form->populate($request->getPost());
                $this->view->form = $form;
                $form->setAction('/pauta-mantencion/edit');
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar pauta de mantenimiento";
                $this->renderScript('pauta-mantencion/form.phtml');
            }
        }
    }
    
    public function deleteAction()
    {
        if($this->getRequest()->isXmlHttpRequest() AND 
           $this->_getParam('id') AND
           $this->_helper->validateRecordExists('pautas_mantenciones', 'id', $this->_getParam('id'))){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $model = new Default_Model_PautaMantencion();
            $where = $model->getAdapter()->quoteInto("id = ?" , (int)$this->_getParam('id'));
            $model->delete($where);
            $mSession->mensajes[] = 'La pauta de mantención fue eliminada de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_forward('index','pauta-mantencion');
        }
    }

    public function viewAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }
            
            if($this->_getParam('id') AND
               $this->_helper->validateRecordExists('pautas_mantenciones','id', $this->_getParam('id'))){
                
                $id = (int)$this->_getParam('id');
                $pauta = new Default_Model_VistaPautasMantenciones();
                $where = $pauta->getAdapter()->quoteInto("id=?", $id);
                $row = $pauta->fetchRow($where);

                $item = new Default_Model_VistaItemsPautasMantenciones();
                $where_items = $item->getAdapter()->quoteInto("pauta_id=?", $id);
                $items = $item->fetchAll($where_items);

                $this->view->title = 'Pauta de mantenimiento';
                $this->view->pauta = $row;
                $this->view->items = $items;
                $this->renderScript('pauta-mantencion/view.phtml');
            }

        }
    }

    public function detalleAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            if($this->_getParam('id') AND
               $this->_helper->validateRecordExists('pautas_mantenciones','id', $this->_getParam('id'))){

                $id = (int)$this->_getParam('id');

                $pauta = new Default_Model_VistaPautasMantenciones();
                $where = $pauta->getAdapter()->quoteInto("id=?", $id);
                $row = $pauta->fetchRow($where);

                $item = new Default_Model_VistaItemsPautasMantenciones();
                $where_items = $item->getAdapter()->quoteInto("pauta_id=?", $id);
                $items = $item->fetchAll($where_items);

                $this->view->pauta = $row;
                $this->view->items = $items;
                $this->renderScript('pauta-mantencion/detalle.phtml');
            }

        }
    }

    /*
    public function listAsignadasAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $pauta = new VistaPautasModelos();
        $this->view->pautas = $pauta->fetchAll();
    }

    public function listNoAsignadasAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->titulo_pagina = "Pautas de mantención > No asignadas a ningún modelo de vehículo";
        $pauta = new VistaPautasMantenciones();
        $this->view->pautas = $pauta->fetchAll("asignaciones='NULL'");
    }
*/

    public function modalListAllAction()
    {
        if($this->getRequest()->isXmlHttpRequest() AND
           $this->_getParam('patente') AND
           $this->_helper->validateRecordExists('vehiculos', 'patente', $this->_getParam('patente'))){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $patente = $this->_getParam('patente');

            $pauta = new Default_Model_VistaPautasMantenciones();
            $pautas = $pauta->fetchAll();

            $this->view->patente = $patente;
            $this->view->pautas = $pautas;
            $this->renderScript('pauta-mantencion/modal-list-all.phtml');
        }
    }

    public function modalListAllToModelAction()
    {
        if($this->getRequest()->isXmlHttpRequest() AND
           $this->_getParam('modelo_id') AND
           $this->_helper->validateRecordExists('modelos_vehiculos', 'id', $this->_getParam('modelo_id'))){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $modelo_id = $this->_getParam('modelo_id');

            $pauta = new Default_Model_VistaPautasMantenciones();
            $pautas = $pauta->fetchAll();

            $this->view->modelo_id = $modelo_id;
            $this->view->pautas = $pautas;
            $this->renderScript('pauta-mantencion/modal-list-all-to-model.phtml');
        }
    }
}