<?php
class PreferenciasController extends Zend_Controller_Action
{
    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/preferencias';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }
    
    public function indexAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            
            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $currentPage = $this->_getParam('page', 1);

            $preferencia = new Default_Model_Preferencia();
            $preferencias = $preferencia->fetchAll();

            $paginador = Zend_Paginator::factory($preferencias);
            $paginador->setItemCountPerPage($this->paginacion['cant_items'])
                      ->setPageRange($this->paginacion['cant_pages'])
                      ->setCurrentPageNumber($currentPage);

            Zend_View_Helper_PaginationControl::setDefaultViewPartial('pagination_control.phtml');

            $this->view->preferencias = $paginador;
            $this->view->title = 'Preferencias';
            $this->renderScript('preferencias/index.phtml');
        }
    }

    public function getFormAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->_request->getParam('id')) {

            
            $preferencia = new Default_Model_Preferencia();
            $where = $preferencia->getAdapter()->quoteInto("id=?", $this->_request->getParam('id'));
            $row = $preferencia->fetchRow($where)->toArray();

            $request = $this->getRequest();
            $form = new Default_Form_Preferencia(null, $this->path, $row['tipo']);
            $form->populate($row);
            
            $this->view->preferencia = $row;
            $this->view->title = "Editar preferencia";
            $this->view->form = $form;
            $this->renderScript('preferencias/form.phtml');
        }
    }

    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $preferencia = new Default_Model_Preferencia();
        $where = $preferencia->getAdapter()->quoteInto("id=?", $this->getRequest()->getParam('id'));
        $row = $preferencia->fetchRow($where)->toArray();

        $request = $this->getRequest();
        $form = new Default_Form_Preferencia(null, $this->path, $row['tipo']);
        $form->submit->setLabel("Guardar cambios");

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {

                    $where = $preferencia->getAdapter()->quoteInto("id=?", (int)$form->getValue('id'));
                    $row = $preferencia->fetchRow($where);
                    $row->valor = $form->getValue('valor');
                    $row->save();

                    $mSession->mensajes[] = 'La preferencia fue guardada de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar guardar los cambios.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                }

                $this->_forward('index', 'preferencias');

            } else {
                $this->view->title = 'Editar preferencia';
                $form->populate($request->getPost());
                $this->view->form = $form;
                $this->renderScript('preferencias/form.phtml');
            }
        }
    }
}