<?php
class PrintController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
    }

    public function init()
    {
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/print';
        $propietario = new Default_Model_Propietario();
        $this->view->propietario = $propietario->fetchRow()->toArray();
        $this->_helper->layout->setLayout('print');
    }

    public function pagoRecibidoAction()
    {
        if($this->_getParam('id') AND
           $this->_helper->validateRecordExists('pagos_recibidos','id', $this->_getParam('id'))){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $id = (int)$this->_getParam('id');
            $pago = new Default_Model_VistaPagosRecibidos();
            $where = $pago->getAdapter()->quoteInto("id=?", $id);
            $row = $pago->fetchRow($where)->toArray();

            if(false!==$row AND $row['estado']=='TERMINADO') {

                if($row['detallar']!='NO'){
                    if($row['detallar']=='DOCUMENTO') {
                        $this->view->documentoBancario = Default_Model_VistaPagosRecibidos::getDocumentoBancario($id);
                    } elseif($row['detallar']=='CODIGO') {
                        $this->view->codigoTransaccion = Default_Model_VistaPagosRecibidos::getCodigoTransaccion($id);
                    }
                }

                $this->view->title = "Recepción de pago Nº $id";
                $this->view->pago = $row;
                $this->view->condiciones_generales = Default_Model_CondicionGeneral::getTexto('PAGO_RECIBIDO');
            }
        }
    }

    public function informeServiciosAction()
    {
        if($this->_getParam('id') AND
           $this->_helper->validateRecordExists('notas_ventas','id', $this->_getParam('id'))){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $id = (int)$this->_getParam('id');
            $nota = new Default_Model_VistaNotasVentas();
            $whereNota = $nota->getAdapter()->quoteInto("id=?", $id);
            $rowNota = $nota->fetchRow($whereNota);

            if(false!==$rowNota AND $rowNota->estado=='TERMINADA') {

                $orden = new Default_Model_VistaOrdenesServicios();
                $whereOrden = $orden->getAdapter()->quoteInto("nota_id=?", $id);
                $rowsOrdenes = $orden->fetchAll($whereOrden);

                $this->view->title = "Informe servicios Nº $id";
                $this->view->nota = $rowNota;
                $this->view->condiciones_generales = Default_Model_CondicionGeneral::getTexto('INFORME_SERVICIOS');
                $this->view->ordenes = $rowsOrdenes;

            }
        }
    }

    public function notaVentaAction()
    {
        if($this->_getParam('id') AND
           $this->_helper->validateRecordExists('vista_notas_ventas','id', $this->_getParam('id'))){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $id = (int)$this->_getParam('id');

            $nota = new Default_Model_VistaNotasVentas();
            $where = $nota->getAdapter()->quoteInto("id=?", $id);
            $row = $nota->fetchRow($where)->toArray();

            if(false!==$row AND ($row['estado']=='EN PROCESO' OR $row['estado']=='TERMINADA')) {

                $item = new Default_Model_ItemNotaVenta();
                $where_items = $item->getAdapter()->quoteInto("nota_id=?",$id);
                $items = $item->fetchAll($where_items)->toArray();

                $this->view->title = "Nota de Venta Nº $id";
                $this->view->nota = $row;
                $this->view->items = $items;


            }
        }
    }

    public function notaCompraAction()
    {
        if($this->_getParam('id') AND
           $this->_helper->validateRecordExists('vista_notas_compras','id', $this->_getParam('id'))){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $id = (int)$this->_getParam('id');

            $nota = new Default_Model_VistaNotasCompras();
            $where = $nota->getAdapter()->quoteInto("id=?", $id);
            $row = $nota->fetchRow($where)->toArray();

            if(false!==$row AND $row['estado']=='EMITIDA') {

                $item = new Default_Model_ItemNotaCompra();
                $where_items = $item->getAdapter()->quoteInto("nota_id=?",$id);
                $items = $item->fetchAll($where_items)->toArray();

                $this->view->title = "Nota de Compra Nº $id";
                $this->view->nota = $row;
                $this->view->items = $items;
            }
        }
    }
}