<?php
class PropietarioController extends Zend_Controller_Action
{
    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/propietario';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }
    
    public function indexAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');
            if($mSession->mensajes!='') {
                
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }
            $propietario = new Default_Model_Propietario();
            $this->view->propietario = $propietario->fetchRow();
            $this->view->title = "Información propietario sistema";
            $this->renderScript('propietario/view.phtml');
        }
    }

    public function getFormAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $request = $this->getRequest();
            $form = new Default_Form_Propietario(null, $this->path);

            $propietario = new Default_Model_Propietario();
            $row = $propietario->fetchRow()->toArray();
            $form->populate($row);
            $this->view->title = "Editar propietario";
            $this->view->form = $form;
            $this->renderScript('propietario/form.phtml');
        }
    }

    public function editAction()
    {
        
        
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $propietario = new Default_Model_Propietario();
        
        $request = $this->getRequest();
        $form = new Default_Form_Propietario();
        
        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {

                try {
                    
                    $row = $propietario->fetchRow();
                    $row->razon_social = $form->getValue('razon_social');
                    $row->rut = App_Rut::cleanToDb($form->getValue('rut'));
                    $row->direccion = $form->getValue('direccion');
                    $row->comuna = $form->getValue('comuna');
                    $row->ciudad = $form->getValue('ciudad');
                    $row->telefono = $form->getValue('telefono');
                    $row->giro = $form->getValue('giro');
                    $row->web = $form->getValue('web');
                    $row->mail = $form->getValue('mail');
                    $row->fax = $form->getValue('fax');
                    $row->save();
                    
                    $mSession->mensajes[] = 'La información del propietario fue editado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                    $this->_forward('index', 'propietario');

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar la información del propietario.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_forward('index','propietario');
                }
            } else {
                
                $form->populate($request->getPost());
                $this->view->form = $form;
                $this->view->title = "Editar propietario";
                $this->renderScript('propietario/form.phtml');
            }
        }
        
    }
}