<?php
class RecepcionVehiculoController extends Zend_Controller_Action
{
    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/recepcion-vehiculo';
        $propietario = new Default_Model_Propietario();
        $this->view->propietario = $propietario->fetchRow();
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }
    
    public function indexAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
                unset($mSession->recepcion);
            }

            $currentPage = $this->_getParam('page', 1);
            
            $recepcion = new Default_Model_VistaRecepcionesVehiculos();
            $recepciones = $recepcion->fetchAll();

            $paginador = Zend_Paginator::factory($recepciones);
            $paginador->setItemCountPerPage($this->paginacion['cant_items'])
                      ->setPageRange($this->paginacion['cant_pages'])
                      ->setCurrentPageNumber($currentPage);

            Zend_View_Helper_PaginationControl::setDefaultViewPartial('pagination_control.phtml');

            $this->view->recepciones = $paginador;
            $this->view->title = "Recepciones de vehículos";
            $this->renderScript('recepcion-vehiculo/index.phtml');
        }

    }

    public function getFormAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
            unset($mSession->recepcion);
        }

        if($this->getRequest()->isXmlHttpRequest()){
            $request = $this->getRequest();
            $form = new Default_Form_RecepcionVehiculoSintomas(null, $this->path);

            if($this->_request->getParam('id')) {

                $recepcion = new Default_Model_RecepcionVehiculo();
                $id = (int)$this->_request->getParam('id');
                $where= $recepcion->getAdapter()->quoteInto("id=?", $id);
                $row = $recepcion->fetchRow($where)->toArray();
                $form->populate($row);
                $form->setAction('/recepcion-vehiculo/edit-estado');
                $this->view->title = "Editar recepción de vehículo Nº $id";

            } else {
                $this->view->title = "Recepción de vehículo: Síntomas";
                if($this->_request->getParam('from_id')) {
                    $patente = $this->_getParam('from_id');
                    $form->vehiculo->setValue($patente);
                }
            }
            $this->view->form = $form;
            $this->renderScript('recepcion-vehiculo/form.phtml');
        }
    }

    public function estadoAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $formSintomas = new Default_Form_RecepcionVehiculoSintomas(null, $this->path);

        
        if ($this->getRequest()->isPost()) {
            
            if ($formSintomas->isValid($request->getPost())) {

                try {
                    
                    $recepcion = array();
                    $recepcion['vehiculo'] = strtoupper($formSintomas->getValue('vehiculo'));
                    $recepcion['entregado_por'] = $formSintomas->getValue('entregado_por');
                    $recepcion['p_suspension'] = $formSintomas->getValue('p_suspension');
                    $recepcion['p_transmision'] = $formSintomas->getValue('p_transmision');
                    $recepcion['p_motor'] = $formSintomas->getValue('p_motor');
                    $recepcion['p_direccion'] = $formSintomas->getValue('p_direccion');
                    $recepcion['p_luces'] = $formSintomas->getValue('p_luces');
                    $recepcion['p_calefaccion'] = $formSintomas->getValue('p_calefaccion');
                    $recepcion['p_tablero'] = $formSintomas->getValue('p_tablero');
                    $recepcion['p_frenos'] = $formSintomas->getValue('p_frenos');
                    if($formSintomas->getValue('otros_sintomas')!='') {
                        $recepcion['otros_sintomas'] = $formSintomas->getValue('otros_sintomas');
                    }
                    if($formSintomas->getValue('otro_taller')!='') {
                        $recepcion['otro_taller'] = $formSintomas->getValue('otro_taller');
                    }
                    $mSession->recepcion = $recepcion;
                    $this->view->title = 'Recepción de vehículo: Estado';
                    $formEstado = new Default_Form_RecepcionVehiculoEstado(null, $this->path);
                    $this->view->form = $formEstado;
                    $this->renderScript('recepcion-vehiculo/form.phtml');

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear la recpeción del vehículo.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_forward('index','recepcion-vehiculo');
                    
                }
            } else {

                $formSintomas->populate($request->getPost());
                $this->view->title = 'Recepción de vehículo: Síntomas';
                $this->view->form = $formSintomas;
                $this->renderScript('recepcion-vehiculo/form.phtml');
                
            }
        }
    }

    public function newAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_RecepcionVehiculoEstado(null, $this->path);
        $this->view->title = 'Recepción de vehículo: Estado';

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {
                    $mSession->recepcion['creador'] = $this->usuario->rut;
                    $mSession->recepcion['entregado_por'] = ucwords($form->getValue('entregado_por'));
                    $mSession->recepcion['km_ingreso'] = $form->getValue('km_ingreso');
                    $mSession->recepcion['nivel_combustible'] = $form->getValue('nivel_combustible');
                    $mSession->recepcion['panel_radio'] = $form->getValue('panel_radio');
                    $mSession->recepcion['gata'] = $form->getValue('gata');
                    $mSession->recepcion['extintor'] = $form->getValue('extintor');
                    $mSession->recepcion['botiquin'] = $form->getValue('botiquin');
                    $mSession->recepcion['neumatico_repuesto'] = $form->getValue('neumatico_repuesto');
                    $mSession->recepcion['detalles_carroceria'] = $form->getValue('detalles_carroceria');
                    if($form->getValue('observaciones')!='') {
                        $mSession->recepcion['observaciones'] = $form->getValue('observaciones');
                    } else {
                        $mSession->recepcion['observaciones'] = NULL;
                    }

                    $recepcion = new Default_Model_RecepcionVehiculo();
                    $row = $recepcion->createRow($mSession->recepcion);
                    $row->save();

                    unset($mSession->recepcion);
                    $mSession->mensajes[] = 'La recepción fue creada de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                    $this->_forward('view','recepcion-vehiculo', null, array( 'id' => $row->id ));

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear la recpeción del vehículo.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_forward('index','recepcion-vehiculo');
                }
            } else {
                $this->view->form = $form;
                $form->populate($request->getPost());
                $this->renderScript('recepcion-vehiculo/form.phtml');
            }
        }
    }

    public function viewAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $recepcion = new Default_Model_VistaRecepcionesVehiculos();

            $id = (int)$this->_getParam('id');
            $where = $recepcion->getAdapter()->quoteInto("id=?", $id);
            $row = $recepcion->fetchRow($where);
            $this->view->title = "Recepción de vehículo Nº $id";

            if(false==$row) {
                $this->_forward('index','recepcion-vehiculo');
            } else {

                $this->view->recepcion = $row;

                $vehiculo = new Default_Model_VistaVehiculos();
                $cliente = new Default_Model_VistaClientes();

                $where_v = $vehiculo->getAdapter()->quoteInto("patente=?", $row->vehiculo);
                $row_vehiculo = $vehiculo->fetchRow($where_v);

                $where_c = $cliente->getAdapter()->quoteInto("rut=?", $row_vehiculo->cliente_id);
                $row_cliente = $cliente->fetchRow($where_c);

                $this->view->vehiculo = $row_vehiculo;
                $this->view->cliente = $row_cliente;


                if($row->estado=='BORRADOR') {
                    $this->renderScript('recepcion-vehiculo/view-draft.phtml');
                } else {
                    $this->renderScript('recepcion-vehiculo/view.phtml');
                }
            }
        }
    }

    public function viewSmallAction()
    {
        if($this->getRequest()->isXmlHttpRequest() && 
           $this->_getParam('id') &&
           $this->_helper->validateRecordExists('recepciones_vehiculos', 'id', $this->_getParam('id'))){

            $recepcion = new Default_Model_VistaRecepcionesVehiculos();

            $id = (int)$this->_getParam('id');
            $where = $recepcion->getAdapter()->quoteInto("id=?", $id);
            $row = $recepcion->fetchRow($where);
            $this->view->recepcion = $row;
            $vehiculo = new Default_Model_VistaVehiculos();
            $where_v = $vehiculo->getAdapter()->quoteInto("patente=?", $row->vehiculo);
            $row_vehiculo = $vehiculo->fetchRow($where_v);
            $this->view->vehiculo = $row_vehiculo;
            $this->renderScript('recepcion-vehiculo/view-small.phtml');
        }
    }

    public function editEstadoAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $formSintomas = new Default_Form_RecepcionVehiculoSintomas(null, $this->path);
        $formSintomas->id->setRequired(true);

        if ($this->getRequest()->isPost()) {
            if ($formSintomas->isValid($request->getPost())) {
                try {
                    $recepcion = array();
                    $recepcion['id'] = $formSintomas->getValue('id');
                    $recepcion['vehiculo'] = strtoupper($formSintomas->getValue('vehiculo'));
                    $recepcion['entregado_por'] = $formSintomas->getValue('entregado_por');
                    $recepcion['p_suspension'] = $formSintomas->getValue('p_suspension');
                    $recepcion['p_transmision'] = $formSintomas->getValue('p_transmision');
                    $recepcion['p_motor'] = $formSintomas->getValue('p_motor');
                    $recepcion['p_direccion'] = $formSintomas->getValue('p_direccion');
                    $recepcion['p_luces'] = $formSintomas->getValue('p_luces');
                    $recepcion['p_calefaccion'] = $formSintomas->getValue('p_calefaccion');
                    $recepcion['p_tablero'] = $formSintomas->getValue('p_tablero');
                    $recepcion['p_frenos'] = $formSintomas->getValue('p_frenos');
                    if($formSintomas->getValue('otros_sintomas')!='') {
                        $recepcion['otros_sintomas'] = $formSintomas->getValue('otros_sintomas');
                    }

                    $mSession->recepcion = $recepcion;

                    $this->view->title = 'Recepción de vehículo: Estado';
                    
                    $model = new Default_Model_RecepcionVehiculo();
                    $where = $model->getAdapter()->quoteInto("id=?", $recepcion['id']);
                    $row = $model->fetchRow($where)->toArray();
                    
                    $formEstado = new Default_Form_RecepcionVehiculoEstado(null, $this->path);
                    $formEstado->populate($row);
                    $formEstado->setAction('/recepcion-vehiculo/edit');
                    $this->view->form = $formEstado;
                     
                    $this->renderScript('recepcion-vehiculo/form.phtml');

                } catch (Exception $e) {
                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear la recpeción del vehículo.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_forward('index','recepcion-vehiculo');
                }
            } else {
                $this->view->title = 'Recepción de vehículo: Síntomas';
                $this->view->form = $formSintomas;
                $form->populate($request->getPost());
                $this->renderScript('recepcion-vehiculo/form.phtml');
            }
        }
    }

    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_RecepcionVehiculoEstado(null, $this->path);
        $form->id->setRequired(true);
        
        $this->view->title = 'Recepción de vehículo: Estado';

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {
                    $mSession->recepcion['creador'] = $this->usuario->rut;
                    $mSession->recepcion['entregado_por'] = $form->getValue('entregado_por');
                    $mSession->recepcion['km_ingreso'] = $form->getValue('km_ingreso');
                    $mSession->recepcion['nivel_combustible'] = $form->getValue('nivel_combustible');
                    $mSession->recepcion['panel_radio'] = $form->getValue('panel_radio');
                    $mSession->recepcion['gata'] = $form->getValue('gata');
                    $mSession->recepcion['extintor'] = $form->getValue('extintor');
                    $mSession->recepcion['botiquin'] = $form->getValue('botiquin');
                    $mSession->recepcion['neumatico_repuesto'] = $form->getValue('neumatico_repuesto');
                    $mSession->recepcion['detalles_carroceria'] = $form->getValue('detalles_carroceria');
                    if($form->getValue('observaciones')!='') {
                        $mSession->recepcion['observaciones'] = $form->getValue('observaciones');
                    } else {
                        $mSession->recepcion['observaciones'] = NULL;
                    }

                    $recepcion = new Default_Model_RecepcionVehiculo();
                    $recepcion->update($mSession->recepcion, "id=". $mSession->recepcion['id']);

                    unset($mSession->recepcion);

                    $mSession->mensajes[] = 'La recepción fue editada de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                    $this->_forward('view','recepcion-vehiculo', null, array( 'id' => $mSession->recepcion['id']));

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear la recpeción del vehículo.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_forward('index','recepcion-vehiculo');
                }
            } else {
                $this->view->form = $form;
                $form->populate($request->getPost());
                $this->renderScript('recepcion-vehiculo/form.phtml');
            }
        }
    }

    public function deleteAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');
            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }
            $recepcion = new Default_Model_RecepcionVehiculo();
            $id = (int)$this->_getParam('id');
            $where = $recepcion->getAdapter()->quoteInto("id=?", $id);
            $recepcion->delete($where);
            $mSession->mensajes[] = 'La recepción fue eliminada de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_forward('index','recepcion-vehiculo');
        }
    }

    public function finishAction()
    {
        if($this->getRequest()->isXmlHttpRequest() AND $this->_getParam('id')){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }
            $recepcion = new Default_Model_RecepcionVehiculo();
            $id = (int)$this->_getParam('id');
            $where = $recepcion->getAdapter()->quoteInto("id=?", $id);
            $row = $recepcion->fetchRow($where);
            $row->estado = 'TERMINADA';
            $row->save();

            $mSession->mensajes[] = 'La recepción concluyó de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_forward('view','recepcion-vehiculo', null, array('id' => $row->id));
        }
    }

    public function listByVehiculoAction()
    {
        if($this->getRequest()->isXmlHttpRequest() &&
           $this->_getParam('id') && 
           $this->_helper->validateRecordExists('vehiculos', 'patente', $this->_getParam('id'))){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }
            
            $patente = strtoupper($this->_getParam('id'));
            $currentPage = $this->_getParam('page', 1);

            $model = new Default_Model_VistaRecepcionesVehiculos();
            $where = $model->getAdapter()->quoteInto('vehiculo=?', $patente);
            $recepciones = $model->fetchAll($where);

            $paginador = Zend_Paginator::factory($recepciones);
            $paginador->setItemCountPerPage($this->paginacion['cant_items'])
                      ->setPageRange($this->paginacion['cant_pages'])
                      ->setCurrentPageNumber($currentPage);

            Zend_View_Helper_PaginationControl::setDefaultViewPartial('pagination_control_extra.phtml');
            
            $this->view->recepciones = $paginador;
            $this->renderScript('recepcion-vehiculo/list-by-vehiculo.phtml');
        } else {
            var_dump($this->_getAllParams());
        }
       
    }

    public function printAction()
    {
        if($this->_getParam('id') AND
           $this->_helper->validateRecordExists('vista_recepciones_vehiculos','id', $this->_getParam('id'))){

            $this->_helper->layout->disableLayout(false);
            $this->_helper->viewRenderer->setNoRender(false);
            $this->_helper->layout->setLayout('print');

            $id = (int)$this->_getParam('id');
            $recepcion = new Default_Model_VistaRecepcionesVehiculos();
            $where = $recepcion->getAdapter()->quoteInto("id=?", $id);
            $row = $recepcion->fetchRow($where);

            if(false!==$row AND $row['estado']=='TERMINADA') {

                $this->view->title = "Recepción Nº $id";
                $this->view->recepcion = $row;
                $this->view->condiciones_generales = Default_Model_CondicionGeneral::getTexto('RECEPCION_VEHICULO');

                $vehiculo = new Default_Model_VistaVehiculos();
                $cliente = new Default_Model_VistaClientes();

                $where_v = $vehiculo->getAdapter()->quoteInto("patente=?", $row['vehiculo']);
                $row_vehiculo = $vehiculo->fetchRow($where_v);

                $where_c = $cliente->getAdapter()->quoteInto("rut=?", $row_vehiculo['cliente_id']);
                $row_cliente = $cliente->fetchRow($where_c);

                $this->view->vehiculo = $row_vehiculo;
                $this->view->cliente = $row_cliente;

            }
        }
    }
}