<?php
class SolicitudCompraController extends Zend_Controller_Action
{
    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/');
        }
        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/solicitud-compra';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }
    
    public function indexAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $currentPage = $this->_getParam('page', 1);

            $solicitud = new Default_Model_VistaSolicitudesCompras();
            $order = 'id DESC';
            $solicitudes = $solicitud->fetchAll(null, $order);

            $paginador = Zend_Paginator::factory($solicitudes);
            $paginador->setItemCountPerPage($this->paginacion['cant_items'])
                      ->setPageRange($this->paginacion['cant_pages'])
                      ->setCurrentPageNumber($currentPage);

            Zend_View_Helper_PaginationControl::setDefaultViewPartial('pagination_control.phtml');

            $this->view->solicitudes = $paginador;
            $this->view->title = 'Solicitudes de compra';
            $this->renderScript('solicitud-compra/index.phtml');
        }  
    }

    public function userAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $currentPage = $this->_getParam('page', 1);

            $solicitud = new Default_Model_VistaSolicitudesCompras();
            $where = "creador='" . $this->usuario->rut . "'";
            $order = 'id DESC';
            $solicitudes = $solicitud->fetchAll($where, $order);

            $paginador = Zend_Paginator::factory($solicitudes);
            $paginador->setItemCountPerPage($this->paginacion['cant_items'])
                      ->setPageRange($this->paginacion['cant_pages'])
                      ->setCurrentPageNumber($currentPage);

            Zend_View_Helper_PaginationControl::setDefaultViewPartial('pagination_control.phtml');

            $this->view->solicitudes = $paginador;
            $this->view->title = 'Solicitudes de compra';
            $this->renderScript('solicitud-compra/user.phtml');
        }
    }

    public function listPendientesAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $currentPage = $this->_getParam('page', 1);

            $solicitud = new Default_Model_VistaSolicitudesCompras();
            $where = "estado='PENDIENTE'";
            $order = "id DESC";
            $solicitudes = $solicitud->fetchAll($where, $order);

            $paginador = Zend_Paginator::factory($solicitudes);
            $paginador->setItemCountPerPage($this->paginacion['cant_items'])
                      ->setPageRange($this->paginacion['cant_pages'])
                      ->setCurrentPageNumber($currentPage);

            Zend_View_Helper_PaginationControl::setDefaultViewPartial('pagination_control.phtml');

            $this->view->solicitudes = $paginador;
            $this->view->title = 'Solicitudes de compra pendientes';
            $this->renderScript('solicitud-compra/list-pendientes.phtml');
        }
    }

    public function getFormAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->getRequest()->isXmlHttpRequest()){

            $request = $this->getRequest();
            $form = new Default_Form_SolicitudCompra(null, $this->path);
            $form->proveedor->setAttrib('disabled','disabled');

            if($this->_request->getParam('id')) {

                $id = (int)$this->_request->getParam('id');
                $solicitud = new Default_Model_SolicitudCompra();
                $where = $solicitud->getAdapter()->quoteInto("id=?", $id);
                $row = $solicitud->fetchRow($where)->toArray();
                $form->populate($row);
                $form->setAction('/solicitud-compra/edit');
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar solicitud de compra Nº $id";

            } else {

                $this->view->title = "Crear solicitud de compra";
            }
            $this->view->form = $form;
            $this->renderScript('solicitud-compra/form.phtml');
        } 
    }

    public function newAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_SolicitudCompra(null, $this->path);
        $this->view->title = 'Crear solicitud de compra';

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {

                    if($form->getValue("observaciones")!=''){
                        $observaciones = $form->getValue('observaciones');
                    } else {
                        $observaciones = NULL;
                    }

                    
                    $solicitud = new Default_Model_SolicitudCompra();
                    $row = $solicitud->createRow();
                    $row->creador = $this->usuario->rut;
                    $row->prioridad = $form->getValue('prioridad');
                    $row->estado = 'BORRADOR';
                    $row->motivo = $form->getValue('motivo');
                    $row->proveedor = $form->getValue('buscador');
                    if($form->getValue('rut')!='') {
                        $row->rut = $form->getValue('rut');
                    } else {
                        $row->rut = NULL;
                    }
                    $row->iva = $this->view->getPref('IVA');
                    $row->observaciones = $observaciones;
                    $row->save();
                    $id = $row->id;
                    $mSession->mensajes[] = 'La solicitud de compra fue creada de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                    $this->_forward('view','solicitud-compra', null, array('id'=>$id));

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear la solicitud de compra.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_forward('index','solicitud-compra');
                }
            } else {
                $this->view->form = $form;
                $form->populate($request->getPost());
                $this->renderScript('solicitud-compra/form.phtml');
            }
        }
    }

    public function getFormRejectAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->getRequest()->isXmlHttpRequest()){

            $solicitud = new Default_Model_SolicitudCompra();
            $where = $solicitud->getAdapter()->quoteInto("id=?", $this->_request->getParam('id'));
            $row = $solicitud->fetchRow($where);

            if(false!=$row) {

                $request = $this->getRequest();
                $form = new Default_Form_RechazarDocumento(null, $this->path);
                $form->setAction('/solicitud-compra/rechazar');
                $form->submit->setLabel('Rechazar solicitud de compra');
                $form->id->setValue($row->id);
                $this->view->title = "Rechazar solicitud de compra";
                $this->view->form = $form;
                $this->renderScript('solicitud-compra/rechazar.phtml');
            } 
        } 
    }

    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_SolicitudCompra();

        if ($this->getRequest()->isPost()) {

            if ($form->isValid($request->getPost())) {

                try {

                    $id = $form->getValue('id');
                    $solicitud = new Default_Model_SolicitudCompra();
                    $row = $solicitud->fetchRow('id='.$id);
                    $row->creador = $this->usuario->rut;
                    $row->prioridad = $form->getValue('prioridad');
                    $row->estado = 'BORRADOR';
                    $row->motivo = $form->getValue('motivo');
                    $row->proveedor = $form->getValue('buscador');
                    if($form->getValue('rut')!='') {
                        $row->rut = $form->getValue('rut');
                    } else {
                        $row->rut = NULL;
                    }
                    $row->iva = $this->view->getPref('IVA');
                    $row->observaciones = $observaciones;
                    $row->save();

                    $mSession->mensajes[] = 'La solicitud de compra fue editada de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                    $this->_forward('view', 'solicitud-compra', null, array('id'=> $id));

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar la solicitud de compra.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_forward('edit','solicitud-compra');
                }

            } else {

                $form->populate($request->getPost());
                $this->view->form = $form;
                $form->setAction('/solicitud-compra/edit');
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar solicitud";
                $this->renderScript('solicitud-compra/form.phtml');
            }
        }
    }

    public function deleteAction()
    {
        if($this->_getParam('id')){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }
            $solicitud = new Default_Model_SolicitudCompra();
            $where = $solicitud->getAdapter()->quoteInto('id = ?' , $this->_getParam('id'));
            $solicitud->delete($where);
            $mSession->mensajes[] = 'La solicitud de compra fue eliminada de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_forward('index','solicitud-compra');
        }
    }

    public function finishAction()
    {
        if($this->getRequest()->isXmlHttpRequest() AND $this->_getParam('id')){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }
            $id = (int)$this->_getParam('id');
            $solicitud = new Default_Model_SolicitudCompra();
            $where = $solicitud->getAdapter()->quoteInto("id=?", $id);
            $row = $solicitud->fetchRow($where);
            $row->estado = 'PENDIENTE';
            $row->save();
            $mSession->mensajes[] = 'La solicitud de compra fue emitida de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_forward('view','solicitud-compra', null, array('id' => $id));
        }
    }

    public function approveAction()
    {
        if($this->getRequest()->isXmlHttpRequest() AND $this->_getParam('id')){

            $mSession = new Zend_Session_Namespace('expressauto');
            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }
            $id = (int)$this->_getParam('id');
            $solicitud = new Default_Model_SolicitudCompra();
            $where = $solicitud->getAdapter()->quoteInto("id=?", $id);
            $row = $solicitud->fetchRow($where);
            $row->estado = 'APROBADA';
            $row->save();
            $mSession->mensajes[] = 'La solicitud de compra fue </strong>aprobada</strong> de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_forward('view','solicitud-compra', null, array('id' => $id));
        } 
    }

    public function rechazarAction()
    {
        $request = $this->getRequest();
        $form = new Default_Form_RechazarDocumento(null, $this->path);

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                $mSession = new Zend_Session_Namespace('expressauto');

                if($mSession->mensajes!='') {
                    $this->view->mensajes = $mSession->mensajes;
                    $this->view->claseMensaje = $mSession->claseMensaje;
                    $mSession->mensajes = '';
                    $mSession->claseMensaje = '';
                }

                if($form->getValue("observaciones")!=''){
                    $observaciones = $form->getValue('observaciones');
                } else {
                    $observaciones = NULL;
                }

                $rechazo = new Default_Model_RechazoSolicitudCompra();
                $row = $rechazo->createRow();
                $row->creador = $this->usuario->rut;
                $row->solicitud_id = $form->getValue('id');
                $row->observaciones = $observaciones;
                $row->save();

                $mSession->mensajes[] = 'La solicitud de compra fue </strong>rechazada</strong> de forma exitosa.';
                $mSession->claseMensaje = 'confirmacion';
                
                $this->_forward('index','solicitud-compra');

            } else {
                
                $this->view->form = $form;
                $form->populate($request->getPost());
                $this->renderScript('solicitud-compra/form.phtml');
            }
        }
    }

    public function viewAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $id = (int)$this->_getParam('id', 0);
            $solicitud = new Default_Model_VistaSolicitudesCompras();
            $where = $solicitud->getAdapter()->quoteInto("id=?", $id);
            $row = $solicitud->fetchRow($where);
            
            $this->view->title = "Solicitud de compra Nº $id";
            $this->view->solicitud = $row;

            if($row->estado=='BORRADOR') {

                $this->renderScript('solicitud-compra/view-borrador.phtml');

            } elseif($row->estado=='PENDIENTE') {

                $this->view->title .= ': Pendiente';
                $this->renderScript('solicitud-compra/view-simple.phtml');

            } elseif($row->estado=='RECHAZADA') {

                $this->view->title .= ': Rechazada';
                $rechazo = new Default_Model_RechazoSolicitudCompra();
                $this->view->rechazo = $rechazo->fetchRow('solicitud_id=' . $row->id);
                $this->renderScript('solicitud-compra/view.phtml');

            } else {
                $this->renderScript('solicitud-compra/view.phtml');
            }
        }
    }

    public function reviewAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }
            $id = (int)$this->_getParam('id', 0);
            $solicitud = new Default_Model_VistaSolicitudesCompras();
            $row = $solicitud->fetchRow('id=' . $id);
            $this->view->title = "Solicitud de compra Nº $id";

            if(false==$row) {
                $this->_forward('index','solicitud-compra');
            } else {
                $this->view->solicitud = $row;
                $this->renderScript('solicitud-compra/review.phtml');
            }
        }
    }

}