<?php
class SoporteController extends Zend_Controller_Action
{
    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }

        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }

    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $this->view->title = "Soporte";
        $this->view->titulo_pagina = "Soporte - Reportar error";

        $form = new ReporteErrorForm();

        if ($this->_request->isPost()) {
            $formData = $this->_request->getPost();
            if ($form->isValid($formData)) {

                try {

                    $reportado_por = $this->view->usuario->nombres .' '.$this->view->usuario->apellidos;
                    $prioridad = $form->getValue('prioridad');
                    $modulo = $form->getValue('modulo');
                    $descripcion = $form->getValue('descripcion');
                    $fecha = new Zend_Date();
                    
                    $asunto = 'Reporte de error en sistema';
                    $asunto = utf8_decode($asunto);

                    $body = '
                    <h2>Reporte de error en sistema ExpressAuto</h2>
                    <hr />
                    <strong>Reportado por</strong> <br />
                    '.$reportado_por.'
                    <br />
                    <br />
                    <strong>Fecha reporte</strong> <br />
                    '.$fecha->toString('dd MMMM yyyy').'
                    <br />
                    <br />
                    <strong>Prioridad / Urgencia</strong><br />
                    '. $prioridad .'
                    <br />
                    <br />
                    <strong>Módulo</strong><br />
                    '. $modulo .'
                    <br />
                    <br />
                    <strong>Descripción</strong><br />
                    '. nl2br($descripcion).'
                    <br />
                    <hr />
                    <h5 style="margin:10px 0;font-weight:normal;color:#999;">Este email fue enviado desde el módulo de soporte del sistema en cuestión.</h5>';
                    
                    $body = utf8_decode($body);

                    $config = array('auth' => 'login',
                                    'username' => 'claudio@webcode.cl',
                                    'password' => '123456abc');

                    $transport = new Zend_Mail_Transport_Smtp('mail.webcode.cl', $config);

                    $mail = new Zend_Mail();
                    $mail->setBodyHtml($body);
                    $mail->setFrom('soporte@expressauto.cl', 'ExpressAuto');
                    $mail->addTo('claudiosalazarb@gmail.com');
                    $mail->setSubject($asunto);
                    $mail->send($transport);

                    $mSession->mensajes[] = 'El mensaje fue enviado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar enviar el mensaje.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';

                }

                $this->_redirect('/soporte');

            } else {
                $form->populate($formData);
            }
        }
        $this->view->form = $form;
    }
}