<?php
class TerminoContratoEmpleadoController extends Zend_Controller_Action
{
    public function init()
    {
         $auth = Zend_Auth::getInstance();

        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }

        $this->path = '/termino-contrato-empleado';
        $this->view->title = 'Términos de Contratos de Empleados';

        $usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->usuario = $empleado->fetchRow('id='.$usuario->empleado_id);
        
        $header = Zend_Controller_Action_HelperBroker::getStaticHelper('Auth')->chooseMenu($usuario->tipo_usuario_id);
        $response = $this->getResponse();
        $response->insert('header', $this->view->render($header));
    }

    public function indexAction()
    {
        $this->_redirect($this->path . '/list');
    }

    public function newAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->titulo_pagina = "Términos contratos empleados > Nuevo registro";

        $form = new TerminoContratoEmpleadoForm(null, $this->path);

        if ($this->_request->isPost()) {
            $formData = $this->_request->getPost();
            if ($form->isValid($formData)) {

                try {
                    
                    $termino = new TerminoContratoEmpleado();
                    $row = $termino->createRow();
                    $row->contrato_id = $form->getValue('contrato_id');
                    $row->fecha = $form->getValue('fecha');
                    $row->motivo = $form->getValue('motivo');
                    $row->save();
                    $id = $row->id;
                    
                    $mSession->mensajes[] = 'Se dio término al contrato de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar dar término al contrato.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    
                }
                
                $this->_redirect($this->path . '/view/id/'.$id);
                
            } else {

                $form->populate($formData);
            
            }
        }

        $id = (int)$this->_request->getParam('id', 0);
        $form->contrato_id->setValue($id);
        $this->view->form = $form;
    }


    public function viewAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->titulo_pagina = "Términos contratos empleados > Ver registro";

        $id = (int)$this->_request->getParam('id', 0);
        $termino = new VistaTerminosContratosEmpleados();
        $this->view->termino = $contrato->fetchRow('id='.$id);
        if($this->view->contrato==false){
            $this->_redirect($this->path . '/list');
        }
    }

    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->titulo_pagina = "Términos contratos empleados > Editar registro";

        $form = new TerminoContratoEmpleadoForm(null, $this->path);
        $form->setAction($this->view->baseUrl(). $this->path . '/edit');
        $form->submit->setLabel("guardar cambios");

        if ($this->_request->isPost()) {
            $formData = $this->_request->getPost();
            if ($form->isValid($formData)) {

                try {

                    $termino = new TerminoContratoEmpleado();

                    $id = (int)$form->getValue('id');

                    $row = $contrato->fetchRow('id='.$id);
                    $row->fecha = $form->getValue('fecha');
                    $row->motivo = $form->getValue('motivo');
                    $row->save();

                    $mSession->mensajes[] = 'El registro fue editado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar el registro.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';

                }

                $this->_redirect($this->path . '/view/id/'.$id);

            } else {
                $form->populate($formData);
            }
        } else {
            $id = (int)$this->_request->getParam('id', 0);
            if ($id > 0) {
                $termino = new TerminoContratoEmpleado();
                $registro = $termino->fetchRow('id='.$id);
                $form->populate($registro->toArray());
            }
        }
        $this->view->form = $form;
    }
}