<?php
class UsuarioWebController extends Zend_Controller_Action
{
    public function init()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/exit');
        }
        $this->usuario = $this->view->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->path = '/usuario-web';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }

    public function getFormAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->getRequest()->isXmlHttpRequest()) {
            
            $request = $this->getRequest();

            if($this->_getParam('from_id') AND
               $this->_helper->validateRecordExists('clientes', 'rut', App_Rut::cleanToDb($this->_getParam('from_id')))){

                $this->view->title = "Agregar usuario";

                $rut = App_Rut::cleanToDb($this->_getParam('from_id'));

                $modelCliente = new Default_Model_VistaClientes();
                $whereCliente = $modelCliente->getAdapter()->quoteInto("rut=?", $rut);
                $cliente = $modelCliente->fetchRow($whereCliente);
                
                if($cliente->tipo_acceso_web=='MONOUSUARIO' AND $cliente->num_usuarios > 0) {

                    $mSession->mensajes[] = 'No se pueden agregar más usuarios.';
                    $mSession->claseMensaje = 'error';
                    $this->_forward('view', 'cliente', null, array('rut' => $rut));

                } else {

                    $form = new Default_Form_UsuarioWeb(null, $this->path, '/cliente/view/'. $rut);
                    $form->cliente->setValue($rut);
                    $form->cliente->setAttrib('disabled', 'disabled');
                    $form->tipo->setAttrib('disabled', 'disabled');
                }

            } elseif($this->_getParam('id')) {

                $this->view->title = "Editar usuario";

                $id = (int)$this->_getParam('id');
                $form = new Default_Form_UsuarioWeb(null, $this->path);
                
                $usuario = new Default_Model_UsuarioWeb();
                $where = $usuario->getAdapter()->quoteInto("id=?", $id);
                $row = $usuario->fetchRow($where)->toArray();
                $form->populate($row);
                $form->setAction('/usuario-web/edit');
                $form->cliente->setAttrib('disabled', 'disabled');
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar usuario";

            } 
            $this->view->form = $form;
            $this->renderScript('usuario-web/form.phtml');
        }
    }

    public function newAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_UsuarioWeb(null, $this->path);
        $this->view->title = "Agregar cliente";

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                try {

                    $rut = App_Rut::cleanToDb($form->getValue('cliente'));
                    $semilla = $rut . 'suma';
                    $suma = md5($semilla);

                    $usuario = new Default_Model_UsuarioWeb();
                    $row = $usuario->createRow();

                    $row->cliente = $rut;
                    $row->nombre = $form->getValue('nombre');
                    $row->mail = $form->getValue('mail');
                    $row->telefono = $form->getValue('telefono');
                    $row->tipo = $form->getValue('tipo');
                    $row->clave = '000000';
                    $row->super_admin = 0; //$this->_getSuperAdminValue($rut);
                    $row->save();

                    $enlace = 'http://www.expressauto.cl/registro/d/' . $row->id  . '/' . $row->cliente . '/' . $suma ;
                    $mail = new App_HtmlMailer('UTF-8');
                    $mail->setSubject('Confirmación de registro')
                         ->addTo($row->mail)
                         ->setViewParam('enlace', $enlace)
                         ->setViewParam('nombre', $form->getValue('nombre'))
                         ->sendHtmlTemplate('confirmacion-registro.phtml');

                    $mSession->mensajes[] = 'El usuario fue creado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_forward('view','cliente', null, array('id' => $rut));

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear el usuario.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_forward('index','cliente');
                }
            } else {

                $this->view->form = $form;
                $form->populate($request->getPost());
                $form->cliente->setAttrib('disabled', 'disabled');
                $this->renderScript('usuario-web/form.phtml');
            }
        }
    }
    
    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $usuario = new Default_Model_UsuarioWeb();

        $request = $this->getRequest();
        $form = new Default_Form_UsuarioWeb();

        if ($this->getRequest()->isPost()) {

            if ($form->isValid($request->getPost())) {

                try {

                    $id = (int)$form->getValue('id');
                    $where = $usuario->getAdapter()->quoteInto("id=?",$id);
                    $row = $usuario->fetchRow($where);
                    $row->nombre = $form->getValue('nombre');
                    $row->mail = $form->getValue('mail');
                    $row->movil = $form->getValue('movil');
                    $row->telefono = $form->getValue('telefono');
                    $row->fax = $form->getValue('fax');
                    $row->tipo = $form->getValue('tipo');
                    $row->save();

                    $mSession->mensajes[] = 'El usuario web fue editado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';

                    $this->_forward('view', 'cliente', null, array('id'=> $row->cliente));

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar el registro.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                }
            } else {
                $form->populate($request->getPost());
                $this->view->form = $form;
                $form->setAction('/usuario-web/edit');
                $form->submit->setLabel('Guardar cambios');
                $this->view->title = "Editar usuario web";
                $this->renderScript('usuario-web/form.phtml');
            }
        }
    }

    public function deshabilitarAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            if($this->_getParam('id')) {

                $id = (int)$this->_getParam('id');

                $usuario = new Default_Model_UsuarioWeb();
                $where = $usuario->getAdapter()->quoteInto("id=?", (int)$this->_getParam('id'));

                try {

                    $row = $usuario->fetchRow($where);
                    $row->estado = 'DESHABILITADO';
                    $row->save();
                    $mSession->mensajes[] = 'El usuario ha sido deshabilitado para acceder al módulo de clientes.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch(Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar deshabilitar '
                                          . 'el acceso del usuario al módulo de clientes.';
                    $mSession->claseMensaje = 'error';
                    
                }
                $this->_forward('view', 'cliente', null, array('id' => $row->cliente));
            }
        }
    }

    public function habilitarAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            if($this->_getParam('id') AND
               $this->_helper->validateRecordExists('usuarios_web', 'id', (int)$this->_getParam('id'))) {

                $usuario = new Default_Model_UsuarioWeb();
                $where = $usuario->getAdapter()->quoteInto("id=?", (int)$this->_getParam('id'));

                try {

                    $row = $usuario->fetchRow($where);
                    $row->estado = 'HABILITADO';
                    $row->save();

                    $mSession->mensajes[] = 'El usuario ha sido habilitado de forma exitosa para acceder al módulo de clientes.';
                    $mSession->claseMensaje = 'confirmacion';

                } catch(Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar habilitar el usuario.';
                    $mSession->claseMensaje = 'error';

                }
                $this->_forward('view', 'cliente', null, array('id' => $row->cliente));
            }
        }
    }

    public function deleteAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');
            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $model = new Default_Model_UsuarioWeb();
            $id = (int)$this->_getParam('id');
            $where = $model->getAdapter()->quoteInto('id=?',$id);

            $usuario = $model->fetchRow($where);
            $rutCliente = $usuario->cliente;
            
            $model->delete($where);

            $mSession->mensajes[] = 'El usuario web fue eliminado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_forward('view','cliente', null, array('id' => $rutCliente));
        }
    }

    public function enviarEnlaceAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            if($this->_getParam('id') AND
               $this->_helper->validateRecordExists('usuarios_web', 'id', (int)$this->_getParam('id'))) {

                $usuario = new Default_Model_UsuarioWeb();
                $where = $usuario->getAdapter()->quoteInto("id=?", (int)$this->_getParam('id'));

                try {

                    $row = $usuario->fetchRow($where);
                    $clave = $this->_generatePassword($row->nombre);
                    $row->clave = md5($clave);
                    $row->save();

                    $hash = md5('npsswd' . md5($row->nombre));

                    $mail = new App_HtmlMailerDocument('UTF-8');
                    $mail->setFrom('no-responder@expressauto.cl', 'Web Expressauto');
                    $mail->setSubject('Renovación de clave')
                         ->setViewParam('usuario', $row)
                         ->setViewParam('hash', $hash);

                    $mail->addTo($row->mail, $row->nombre);
                    $mail->sendHtmlTemplate('enviar-enlace.phtml');

                    $mSession->mensajes[] = 'El proceso de renovación de clave se ha iniciado de forma satisfactoria.';
                    $mSession->claseMensaje = 'confirmacion';

                    $this->_forward('view', 'cliente', null, array('id' => $row->cliente));

                } catch(Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar iniciar el proceso de renovación de clave.';
                    $mSession->claseMensaje = 'error';

                    $this->_forward('index', 'cliente');
                }
            }
        }
    }

    private function _generatePassword($semilla)
    {
        $md5 = md5($semilla);
        $clave = substr($md5, 1, 8);
        return $clave;
    }
    
    /*
    

    public function cambiarClaveAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_CambiarClave(null, $this->path);
        $this->view->title = 'Cambiar clave';

        if($this->getRequest()->isPost()){
            if($form->isValid($request->getPost())){
                if($this->usuario->rut==$form->getValue('usuario')){

                    try {

                        $usuario = new Default_Model_Empleado();
                        $where = $usuario->getAdapter()->quoteInto("rut=?", $form->getValue('usuario'));
                        $row = $usuario->fetchRow($where);

                        if($row->acceso_sistema=='HABILITADO') {

                            if($row->clave==md5($form->getValue('clave_actual'))){

                                $row->clave = md5($form->getValue('clave_nueva'));
                                $row->save();
                                $mSession->mensajes[] = 'Su clave fue cambiada de forma satisfactoria';
                                $mSession->claseMensaje = 'confirmacion';

                            } else {
                                $mSession->mensajes[] = 'La clave actual ingresada no es válida';
                                $mSession->claseMensaje = 'error';
                            }
                        } else {
                            $mSession->mensajes[] = 'El usuario no se encuentra habilitado';
                            $mSession->claseMensaje = 'error';
                        }
                    } catch (Exception $e) {

                        $mSession->mensajes[] = 'Ocurrió un error al intentar cambiar la clave, por favor inténtelo más tarde.';
                        $mSession->claseMensaje = 'error';

                    }
                    $this->_forward('preferencias', 'usuario');
                }

            } else {
                $form->populate($request->getPost());
                $this->view->form = $form;
                $this->renderScript('usuario/cambiar-clave.phtml');
            }
        }
    }

    public function preferenciasAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_CambiarClave(null, $this->path);
        $this->view->title = 'Cambiar clave';
        $form->usuario->setValue($this->usuario->rut);
        $this->view->form = $form;
        $this->renderScript('usuario/cambiar-clave.phtml');
    }
    */
}