<?php
class VentasController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/index/logout');
        }
    }
    
    public function init()
    {
        $this->path = '/ventas';
        $this->paginacion = Zend_Registry::get('paginacion');
        $this->view->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->modulo = 2;
        
        
        $modelCajaChica = new Default_Model_VistaCajasChicas();
        $whereCajaChica = $modelCajaChica->getAdapter()->quoteInto('id=?', $this->view->usuario->rut);
        $this->view->cajaChica = $modelCajaChica->fetchRow($whereCajaChica);

        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render("header.phtml"));
            $response->insert('tools', $this->view->render("tools/ventas.phtml"));
            $response->insert('menu' , $this->view->render("menu-ventas.phtml"));
        } else {
            $this->_helper->layout->disableLayout(true);
            $this->_helper->viewRenderer->setNoRender(true);
        }
    }
    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->title = 'Gestión de ventas y clientes';

        if($this->getRequest()->isXmlHttpRequest()){
            $this->renderScript('ventas/index.phtml');
        }
    }

    public function informesAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('expressauto');

            if($mSession->mensajes!='') {
                $this->view->mensajes = $mSession->mensajes;
                $this->view->claseMensaje = $mSession->claseMensaje;
                $mSession->mensajes = '';
                $mSession->claseMensaje = '';
            }

            $this->view->title = 'Informes';
            $this->renderScript('ventas/informes.phtml');
        }
    }
}