<?php
class Default_Form_Acceso extends Zend_Form 
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);
        
        $usuario = new Zend_Form_Element_Text('usuario');
        $usuario->setLabel('Usuario')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
              
        $clave = new Zend_Form_Element_Password('clave');
        $clave->setLabel('Clave')
              ->setRequired(true)
              ->addFilter('StripTags');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Ingresar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(array($usuario, $clave, $submit));
        $this->addDisplayGroup(array('usuario', 'clave'),'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(array('submit'), 'submitButtons');

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido',
                'name'      => 'acceso',
                'action'    => '/'
            ));

    } 
}