<?php
class Default_Form_AnotacionVehiculo extends Zend_Form
{
    public function __construct($options = null, $path = null, $history = '/vehiculo')
    { 
        parent::__construct($options);

        $optionsVehiculo = array('table' => 'vehiculos', 'field' => 'patente');
        $validadorVehiculo = new Zend_Validate_Db_RecordExists($optionsVehiculo);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $type_user = new Zend_Form_Element_Hidden('type_user');
        $type_user->addValidator('Int')
                  ->setValue(0)
                  ->setDecorators(array('ViewHelper'));

        $vehiculo = new Zend_Form_Element_Hidden('vehiculo');
        $vehiculo->setRequired(true)
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->addValidator($validadorVehiculo);

        $detalles = new Zend_Form_Element_Textarea('detalles');
        $detalles->setLabel('Detalles anotación')
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->setAttrib("style","width:600px;height:250px;margin:7px 0;")
                 ->setRequired(true);

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Agregar anotación')
               ->setAttrib('class','anotacion-modelo')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(array($id, $vehiculo, $detalles, $type_user, $submit));
        $this->addDisplayGroup(array('detalles'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset'
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel', 'id', 'vehiculo', 'type_user'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'anotacion-vehiculo',
                'action'    => $path . '/new'
            ));
    } 
} 
