<?php
class Default_Form_ArticuloProducto extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);


        $options = array('table' => 'articulos', 'field' => 'codigo');
        $validadorArticulo = new Zend_Validate_Db_RecordExists($options);
        $validadorArticulo->setMessage("Código inválido. Verifique que el artículo existe y está disponible para la venta");


        $validadorFloat = new App_Validate_Float();

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $buscador = new Zend_Form_Element_Text('buscador');
        $buscador->setLabel('Buscar artículo')
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->setRequired(false)
                 ->setAttrib('onkeypress', 'ajaxSearchArticulo($(this), "#articulo", "#descripcion")');

        $producto = new Zend_Form_Element_Hidden('producto');
        $producto->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->setRequired(true)
                 ->setDecorators(array('ViewHelper'));

        $articulo = new Zend_Form_Element_Text('articulo');
        $articulo->setLabel('Código del articulo')
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->setRequired(true)
                 ->addValidator($validadorArticulo);

        $unidades = new Zend_Form_Element_Text('unidades');
        $unidades->setLabel('Unidades')
                 ->setRequired(true)
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->addValidator($validadorFloat);

        $descripcion = new Zend_Form_Element_Textarea('descripcion');
        $descripcion->setLabel('Descripción del artículo')
                    ->setRequired(true)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->setAttrib('style', 'width:400px;height:77px;');

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Agregar al producto')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $producto, $unidades,
                $descripcion, $submit,
                $articulo, $buscador
            ));

        $this->addDisplayGroup(
            array(
                'buscador'
            ),
            'busquedaInputs'
        );

        $busquedaInputs = $this->getDisplayGroup('busquedaInputs');
        $busquedaInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-busqueda'))
            ));
            
        $this->addDisplayGroup(
            array(
               'articulo', 'unidades'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            ));

        $this->addDisplayGroup(
            array(
                'descripcion'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            ));
        
        $this->addDisplayGroup(
            array('submit', 'id', 'producto'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'item',
                'action'    => '/articulo-producto/new'
            ));
    } 
} 
