<?php
class Default_Form_AsignacionOrdenServicio extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/orden-servicio')
    { 
        parent::__construct($options);

        $optionsOrden = array('table' => 'ordenes_servicios', 'field' => 'id');
        $validadorOrden = new Zend_Validate_Db_RecordExists($optionsOrden);

        $id = new Zend_Form_Element_Hidden('id');
        $id->setRequired(true)
           ->addFilter('StripTags')
           ->addFilter('StringTrim')
           ->addValidator($validadorOrden)
           ->setDecorators(array('ViewHelper'));

        $asignada_a = new Zend_Form_Element_Select('asignada_a');
        $asignada_a->setLabel('Asignar a')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addMultiOption('','Asignar a:')
               ->addMultiOptions(Default_Model_Empleado::getEmpleadosTaller())
               ->setDecorators(array('ViewHelper'));
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Asignar orden')
               ->setAttrib('class','asignacion-orden')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $asignada_a, $submit
            ));


        $this->addDisplayGroup(
            array(
                 'asignada_a', 'submit', 'id'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset'
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'asignacion-orden',
                'action'    => $path . '/start'
            ));
    } 
} 
