<?php
class Default_Form_BuscarCodigo extends Zend_Form
{ 
    public function __construct($options = null, $path = null)
    {
        parent::__construct($options);

        $this->setAttribs(
            array(
                'action'    => $path,
                'class'     => 'inline',
                'name'      => 'find_codigo'
            ));

        $codigo = new Zend_Form_Element_Text('codigo');
        $codigo->setRequired(false)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->setDescription('test');

        $buscar = new Zend_Form_Element_Button('buscar');
        $buscar->setAttribs(array('class' => 'ui-button ui-state-default ui-corner-all'));

        $this->addElements(array($codigo, $buscar));
        $this->addDisplayGroup(array('codigo', 'buscar'), 'code',
            array('legend' => 'Buscar por código')
        );
        
        $this->clearDecorators();
        $this->addDecorators(
            array(
                array('FormElements'),
                array('Form'),
            ));

        $this->setElementDecorators(
            array(
                array('ViewHelper'),
                array('Errors'),
                array('Descriptions')
            ));

        $this->setDisplayGroupDecorators(array(
            'FormElements',
            'Fieldset'
        ));
    } 
} 
