<?php
class Default_Form_BuscarContacto extends Zend_Form 
{ 
    public function __construct($options = null, $path = null ) 
    { 
        parent::__construct($options);
        
        $buscar_por = new Zend_Form_Element_Select('buscar_por');
        $buscar_por->setRequired(true)
                   ->addFilter('StripTags')
                   ->addFilter('StringTrim')
                   ->addValidator('NotEmpty')
                   ->addMultiOption('nombre','por nombre')
                   ->addMultiOption('mail','por email')
                   ->addMultiOption('ciudad','por ciudad')
                   ->addMultiOption('direccion','por dirección')
                   ->addMultiOption('etiquetas','por etiqueta');
                   
           
        $clave = new Zend_Form_Element_Text('clave');
        $clave->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('NotEmpty')
              ->setValue('Palabra(s) clave');

        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('buscar');
        
        $this->addElements(
            array(
                $buscar_por, $clave, $submit
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->addAttribs(
                 array(
                    'class'     => 'buscar_inline',
                    'name'      => 'find_contacto',
                    'action'    => $path . '/find'
                ));
             
               
        $this->setElementDecorators(array(
            array('ViewHelper'),
            array('Errors'),
            array('Description'),
        ));
    } 
} 
