<?php
class Default_Form_BuscarNumero extends Zend_Form
{ 
    public function __construct($options = null, $path = null)
    {
        parent::__construct($options);

        $this->setAttribs(
            array(
                'action'    => $path,
                'class'     => 'inline',
                'name'      => 'findNum'
            ));

        $numero = new Zend_Form_Element_Text('numero');
        $numero->setRequired(false)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->setDescription('test');

        $buscar = new Zend_Form_Element_Button('buscar');
        $buscar->setLabel('Buscar Nº');
        $buscar->setAttribs(array('class' => 'ui-button ui-state-default submit-inputs ui-corner-all'));

        $this->addElements(array($numero, $buscar));
        $this->addDisplayGroup(array('numero', 'buscar'), 'code',
            array('legend' => 'Buscar por Nº de documento')
        );
        
        $this->clearDecorators();
        $this->addDecorators(
            array(
                array('FormElements'),
                array('Form'),
            ));

        $this->setElementDecorators(
            array(
                array('ViewHelper'),
                array('Errors'),
            ));

        $this->setDisplayGroupDecorators(array(
            'FormElements',
            'Fieldset'
        ));
    } 
} 
