<?php
class Default_Form_BuscarTarea extends Zend_Form 
{ 
    public function __construct($options = null, $path = null ) 
    { 
        parent::__construct($options);

        $buscar_en = new Zend_Form_Element_Select('buscar_en');
        $buscar_en->setRequired(true)
                  ->addFilter('StripTags') 
                  ->addFilter('StringTrim')
                  ->addValidator('NotEmpty')
                  ->addMultiOption('t','en terminadas')
                  ->addMultiOption('p','en pendientes');
            
        $clave = new Zend_Form_Element_Text('clave');
        $clave->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('NotEmpty')
              ->setValue('Palabra(s) clave');

        $year = new Zend_Form_Element_Text('year');
        $year->setRequired(false)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->setValue('Año')
              ->setAttrib('class','year_inline');

        $month = new Zend_Form_Element_Text('month');
        $month->setRequired(false)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->setValue('Mes')
              ->setAttrib('class','month_inline'); 

        $day = new Zend_Form_Element_Text('day');
        $day->setRequired(false)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->setValue('Día')
              ->setAttrib('class','day_inline');  
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('buscar');
        
        $this->addElements(
            array(
                $buscar_en, $clave, $year,
                $month, $day, $submit
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->addAttribs(
                 array(
                    'class'     => 'buscar_inline',
                    'name'      => 'find_tarea',
                    'action'    => $path . '/find'
                 ))
                ->setElementDecorators(
                    array(
                        array('ViewHelper'),
                        array('Errors'),
                        array('Description'),
                    )
                );
    } 
} 
