<?php
class Default_Form_CajaChica extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/caja-chica')
    {
        parent::__construct($options);

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $descripcionMontoMinimo = 'Este parámetro permitirá, si el usuario lo desea, '
                                . 'generar una alerta cuando el saldo disponible sea '
                                . 'inferior al monto indicado en este campo.';

        $descripcionDescripcion = "Por favor indique una referencia acerca del uso que se le dará "
                                . "a esta caja chica. Esto le ayudará a indentificarlas "
                                . "en caso de tener dos cajas asigandas a la misma persona. ";


        $responsable = new Zend_Form_Element_Select('responsable');
        $responsable->setLabel('Asignada a')
                    ->setRequired(true)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->addMultiOption('', '-- Seleccionar --')
                    ->addMultiOptions(Default_Model_Empleado::getEmpleadosCajaChica());

        $monto_minimo = new Zend_Form_Element_Text('monto_minimo');
        $monto_minimo->setRequired(true)
                     ->setLabel('Monto mínimo')
                     ->setAttrib('class', 'tooltip')
                     ->setDescription($descripcionMontoMinimo)
                     ->addValidator('Int');
             
        $descripcion = new Zend_Form_Element_Textarea('descripcion');
        $descripcion->setLabel('Descripción')
                    ->setRequired(false)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->setAttrib('class', 'tooltip')
                    ->setDescription($descripcionDescripcion);
             
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Crear caja chica')
               ->setAttrib('class','caja-chica')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));

        $this->addElements(
            array(
                $responsable, $descripcion,
                $monto_minimo, $submit,
                $cancel, $back
            ));

        $this->addDisplayGroup(
            array(
                'responsable','monto_minimo', 'descripcion'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'caja-chica',
                'action'    => $path . '/new'
            ));

    } 
} 
