<?php
class Default_Form_CategoriaArticulo extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/status/base')
    { 
        parent::__construct($options);

        $id = new Zend_Form_Element_Text('id');
        $id->setLabel('ID Categoría')
           ->setRequired(true)
           ->addValidator('Int');

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $padre_id = new Zend_Form_Element_Select('padre_id');
        $padre_id->setLabel('Categoría Padre')
                 ->setRequired(true)
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->addMultiOption('0','Ninguna')
                 ->addMultiOptions(Default_Model_CategoriaArticulo::getPairsToSelect());
              
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre categoría')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim');
              
        $descripcion = new Zend_Form_Element_Textarea('descripcion');
        $descripcion->setLabel('Descripción')
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim');
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Crear categoría de artículos')
               ->setAttrib('class','categoria-articulo')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $padre_id, $nombre,
                $descripcion, $submit, $cancel,
                $back
            ));

        $this->addDisplayGroup(
            array(
                'id', 'padre_id', 'nombre', 'descripcion'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'categoria-articulo',
                'action'    => $path . '/new'
            ));

    } 
} 
