<?php
class Default_Form_CierreMesRemuneracion extends Zend_Form
{ 
    public function __construct($options = null, $path = null)
    { 
        parent::__construct($options);

        $validator = new Zend_Validate_Db_NoRecordExists('remuneraciones_cierres', 'mes');

        $periodo_i = new Zend_Form_Element_Text('periodo_i');
        $periodo_i->setLabel('Inicio período')
                  ->setRequired(true)
                  ->addFilter('StripTags')
                  ->addFilter('StringTrim')
                  ->addValidator('Date');

        $periodo_t = new Zend_Form_Element_Text('periodo_t');
        $periodo_t->setLabel('Término período')
                  ->setRequired(true)
                  ->addFilter('StripTags')
                  ->addFilter('StringTrim')
                  ->addValidator('Date');

        $mes = new Zend_Form_Element_Text('mes');
        $mes->setLabel('Mes')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator($validator);
              
        $horas_mes = new Zend_Form_Element_text('total_horas_mes');
        $horas_mes->setLabel('Horas período')
                  ->setRequired(true)
                  ->addFilter('StripTags')
                  ->addFilter('StringTrim')
                  ->addValidator('Int');
        /*
        $monto_total = new Zend_Form_Element_Text('monto_total');
        $monto_total->setLabel('Pozo total')
                    ->setRequired(true)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->addValidator('Int');*/

        $descuentos_perdidas_existencias = new Zend_Form_Element_Text('descuentos_perdidas_existencias');
        $descuentos_perdidas_existencias->setLabel('Desc. por pérdidas')
                                        ->setRequired(true)
                                        ->addFilter('StripTags')
                                        ->addFilter('StringTrim')
                                        ->addValidator('Int');

        $descuentos_danos_vehiculos = new Zend_Form_Element_Text('descuentos_danos_vehiculos');
        $descuentos_danos_vehiculos->setLabel('Desc. por daños a vehículos')
                                   ->setRequired(true)
                                   ->addFilter('StripTags')
                                   ->addFilter('StringTrim')
                                   ->addValidator('Int');

        $descuentos_otros = new Zend_Form_Element_Text('descuentos_otros');
        $descuentos_otros->setLabel('Desc. adicionales')
                         ->setRequired(true)
                         ->addFilter('StripTags')
                         ->addFilter('StringTrim')
                         ->addValidator('Int');
        /*
        $monto_final = new Zend_Form_Element_Text('monto_final');
        $monto_final->setLabel('Pozo final')
                    ->setRequired(true)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->addValidator('Int');
        */
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Confirmar todas las cifras y cerrar el mes');
        $submit->setAttribs(array('class' => 'ui-button ui-state-default submit-inputs ui-corner-all'));
        
        $this->addElements(
            array(
                $mes, $periodo_i, $periodo_t, $horas_mes,
                $descuentos_perdidas_existencias,
                $descuentos_danos_vehiculos, $descuentos_otros,
                $submit
            ));

        $this->addDisplayGroup(
            array(
                'mes', 'periodo_i', 'periodo_t', 'total_horas_mes',
                'descuentos_perdidas_existencias',
                'descuentos_danos_vehiculos', 'descuentos_otros',
                'submit'
            ),
            'inputs',
            array(
                'legend'=>'Ingrese toda la información requerida y revise los montos propuestos'
            )
        );

        $inputs = $this->getDisplayGroup('inputs');
        $inputs->setDecorators(
            array(
                'FormElements',
                'Fieldset'
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'inline',
                'name'      => 'cierre-mes',
                'action'    => $path . '/new'
            ));

    } 
} 
