<?php
class Default_Form_CodigoTransaccionTarjeta extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/pago-recibido')
    { 
        parent::__construct($options);

        $optionsPago = array('table' => 'pagos_recibidos', 'field' => 'id');
        $validadorPago = new Zend_Validate_Db_RecordExists($optionsPago);

        $optionsCodigo = array('table' => 'codigos_transacciones_tarjetas', 'field' => 'codigo_transaccion');
        $validadorCodigo = new Zend_Validate_Db_NoRecordExists($optionsCodigo);

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $pago_id = new Zend_Form_Element_Hidden('pago_id');
        $pago_id->setRequired(true)
                ->addValidator('Int')
                ->addValidator($validadorPago);

        $codigo_transaccion = new Zend_Form_Element_Text('codigo_transaccion');
        $codigo_transaccion->setLabel('Código transbank')
                     ->setRequired(true)
                     ->addFilter('StripTags')
                     ->addFilter('StringTrim')
                     ->addValidator('Int')
                     ->addValidator($validadorCodigo);

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Registrar código')
               ->setAttrib('class','pago-recibido')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $pago_id, $codigo_transaccion, $submit, $cancel, $back
            ));

        $this->addDisplayGroup(
            array(
                'codigo_transaccion'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back', 'pago_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'codigo-transaccion',
                'action'    => $path . '/new'
            ));

    } 
} 
