<?php
class Default_Form_ComisionVenta extends Zend_Form
{ 
    public function __construct($options = null, $path = null)
    {
        parent::__construct($options);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int');

        $desde = new Zend_Form_Element_Text('desde');
        $desde->setLabel('Desde')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('Int');
              
        $hasta = new Zend_Form_Element_Text('hasta');
        $hasta->setLabel('Hasta')
              ->setRequired(false)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('Int');
            
        $valor = new Zend_Form_Element_Text('valor');
        $valor->setLabel('Porcentaje de comisión (%)')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator('Float');

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Agregar');
        $submit->setAttribs(array('class' => 'ui-button ui-state-default submit-inputs ui-corner-all'));
        
        $this->addElements(
                array(
                    $desde, $hasta, $valor,  $submit
                    )
                );

        $this->addDisplayGroup(
            array(
                'desde','hasta','valor', 'submit'
            ),
            'infoInputs',
            array(
                'legend'=>'Ingrese toda la información requerida'
            )
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset'
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'inline',
                'name'      => 'comisiones',
                'action'    => $path . '/add-comision'
            ));

    } 
} 
