<?php
class Default_Form_CondicionGeneral extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/condiciones-generales')
    { 
        parent::__construct($options);

        $documento = new Zend_Form_Element_Hidden('documento');
        $documento->setRequired(true)
                  ->setDecorators(array('ViewHelper'));

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));
              
        $condiciones = new Zend_Form_Element_Textarea('condiciones');
        $condiciones->setLabel('Texto condiciones')
                    ->setRequired(true)
                    ->addFilter('StringTrim');
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Guardar cambios')
               ->setAttrib('class','preferencia')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(array($condiciones, $submit, $cancel, $back, $documento));

        $this->addDisplayGroup(array('condiciones'),'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left-ancho'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back', 'documento'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'condicion-general',
                'action'    => $path . '/edit'
            ));
    } 
} 
