<?php
class Default_Form_ConsultaCotizacion extends Zend_Form
{ 
    public function __construct($options = null, $path = null)
    { 
        parent::__construct($options);

        $razon_social = new Zend_Form_Element_Text('razon_social');
        $razon_social->setLabel('Razón social')
                     ->setRequired(false)
                     ->addFilter('StripTags')
                     ->addFilter('StringTrim');

        $rut = new Zend_Form_Element_Text('rut');
        $rut->setLabel('R.U.T.')
            ->setRequired(false)
            ->addFilter('StripTags')
            ->addFilter('StringTrim');

        $direccion = new Zend_Form_Element_Text('direccion');
        $direccion->setLabel('Dirección')
                  ->setRequired(false)
                  ->addFilter('StripTags')
                  ->addFilter('StringTrim');

        $ciudad = new Zend_Form_Element_Text('ciudad');
        $ciudad->setLabel('Ciudad')
            ->setRequired(false)
            ->addFilter('StripTags')
            ->addFilter('StringTrim');

        $telefono = new Zend_Form_Element_Text('telefono');
        $telefono->setLabel('Teléfono')
            ->setRequired(false)
            ->addFilter('StripTags')
            ->addFilter('StringTrim');

        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Email')
             ->setRequired(false)
             ->addFilter('StripTags')
             ->addFilter('StringTrim');

        $atencion_a = new Zend_Form_Element_Text('atencion_a');
        $atencion_a->setLabel('Atención a')
            ->setRequired(false)
            ->addFilter('StripTags')
            ->addFilter('StringTrim');

        $emitida_por = new Zend_Form_Element_Text('emitida_por');
        $emitida_por->setLabel('Emitida por')
            ->setRequired(false)
            ->addFilter('StripTags')
            ->addFilter('StringTrim');

        $patente = new Zend_Form_Element_Text('patente');
        $patente->setLabel('Patente')
                ->setRequired(false)
                ->addFilter('StripTags')
                ->addFilter('StringTrim');

        $dstart = new Zend_Form_Element_Text('dstart');
        $dstart->setLabel('Fecha inicio')
                ->setRequired(false)
                ->addFilter('StripTags')
                ->addFilter('StringTrim');

        $dend = new Zend_Form_Element_Text('dend');
        $dend->setLabel('Fecha término')
                ->setRequired(false)
                ->addFilter('StripTags')
                ->addFilter('StringTrim');

        $submitDoc = new Zend_Form_Element_Button('submitDoc');
        $submitDoc->setLabel('Buscar');
        $submitDoc->setAttribs(array('class' => 'ui-button ui-state-default submit-inputs ui-corner-all'));

        
        $this->addElements(
            array(
                $razon_social, $rut, $direccion,
                $ciudad, $telefono, $mail,
                $atencion_a, $emitida_por, $dstart,
                $dend, $patente, $submit
            ));

        $this->addDisplayGroup(
            array(
                'razon_social','rut','direccion',
                'ciudad', 'submitDoc'
            ),
            'infoInputs1',
            array(
                'legend'=>'Busque por uno o más criterios'
            )
        );

        $infoInputs1 = $this->getDisplayGroup('infoInputs1');
        $infoInputs1->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array(
                'telefono', 'mail', 'atencion_a',
                'emitida_por'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left2'))
            )
        );

        $this->addDisplayGroup(
            array(
                'dstart', 'dend', 'patente'
            ),
            'infoInputs3'
        );

        $infoInputs3 = $this->getDisplayGroup('infoInputs3');
        $infoInputs3->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left2'))
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido',
                'name'      => 'findDoc',
                'action'    => $path . '/find'
            ));

    } 
} 
