<?php
class Default_Form_ConsultaOrdenCompra extends Zend_Form
{ 
    public function __construct($options = null, $path = null)
    {
        $validador_rut = new App_Validate_ValidRut();

        parent::__construct($options);

        $proveedor = new Zend_Form_Element_Text('proveedor');
        $proveedor->setLabel('R.U.T. Proveedor')
                  ->setRequired(false)
                  ->addFilter('StripTags')
                  ->addFilter('StringTrim')
                  ->addValidator($validador_rut);

        $atencion_a = new Zend_Form_Element_Text('atencion_a');
        $atencion_a->setLabel('Atención a')
            ->setRequired(false)
            ->addFilter('StripTags')
            ->addFilter('StringTrim');

        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Email')
            ->addFilter('StripTags')
            ->addFilter('StringTrim')
            ->addValidator('EmailAddress');

        $emitida_por = new Zend_Form_Element_Text('emitida_por');
        $emitida_por->setLabel('Emitida por')
            ->setRequired(false)
            ->addFilter('StripTags')
            ->addFilter('StringTrim');

        $referencia = new Zend_Form_Element_Text('referencia');
        $referencia->setLabel('Doc. referencia')
                   ->addFilter('StripTags')
                   ->addFilter('StringTrim');

        $f_inicio= new Zend_Form_Element_Text('f_inicio');
        $f_inicio->setLabel('A partir de')
                ->setRequired(false);

        $f_termino= new Zend_Form_Element_Text('f_termino');
        $f_termino->setLabel('Hasta')
                ->setRequired(false);

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Buscar');
        $submit->setAttribs(array('class' => 'ui-button ui-state-default submit-inputs ui-corner-all'));
        
        $this->addElements(
            array(
                $proveedor, $atencion_a, $mail,
                $emitida_por, $referencia,
                $f_inicio, $f_termino, $submit
            )); 

        $this->addDisplayGroup(
            array(
                'proveedor', 'atencion_a',
                'mail', 'emitida_por',
                'referencia', 'submit'
            ),
            'infoInputs',
            array('legend'=>'Busque por uno o más de los siguientes criterios')
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','style'=>'width:50%;float:left;'))
            )
        );

        $this->addDisplayGroup(
            array('f_inicio','f_termino'), 'dateInputs', array(
                'legend' => 'Limite a un rango de fechas'
            ));


        $dateInputs = $this->getDisplayGroup('dateInputs');
        $dateInputs->setDecorators(array(
            'FormElements',
            'Fieldset',
            array('HtmlTag', array('tag'=>'div','style'=>'width:48%;float:right;'))
        ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(
                array(
                    'class'     => 'inline',
                    'name'      => 'consulta_orden_compra',
                    'action'    => $path . '/find'
                ));
    } 
} 
