<?php
class Default_Form_ConsultaProveedor extends Zend_Form
{ 
    public function __construct($options = null, $path = null)
    {
        $validador_rut = new App_Validate_ValidRut();

        parent::__construct($options);

        $razon_social = new Zend_Form_Element_Text('razon_social');
        $razon_social->setLabel('Razón social')
              ->setRequired(false)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator('NotEmpty');

        $rut = new Zend_Form_Element_Text('rut');
        $rut->setLabel('R.U.T.')
              ->setRequired(false)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator('NotEmpty');

        $direccion = new Zend_Form_Element_Text('direccion');
        $direccion->setLabel('Dirección')
              ->setRequired(false)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator('NotEmpty');

        $comuna = new Zend_Form_Element_Text('comuna');
        $comuna->setLabel('Comuna')
              ->setRequired(false)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator('NotEmpty');

        $ciudad = new Zend_Form_Element_Text('ciudad');
        $ciudad->setLabel('Ciudad')
              ->setRequired(false)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator('NotEmpty');

        $giro = new Zend_Form_Element_Text('giro');
        $giro->setLabel('Giro')
              ->setRequired(false)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator('NotEmpty');

        $nivel_deuda = new Zend_Form_Element_Select('nivel_deuda');
        $nivel_deuda->setLabel('Nivel de deuda')
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->setRequired(false)
                    ->addMultiOption('0','Todos')
                    ->addMultiOption('1','Sin deuda')
                    ->addMultiOption('2','Con deuda')
                    ->addMultiOption('3','Con deuda vencida');

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Buscar');
        $submit->setAttribs(array('class' => 'ui-button ui-state-default submit-inputs ui-corner-all'));

        
        $this->addElements(
            array(
                $razon_social, $rut, $direccion,
                $comuna, $ciudad, $giro,
                $nivel_deuda, $submit
            ));

        $this->addDisplayGroup(
            array(
                'razon_social', 'rut', 'direccion',
                'comuna', 'ciudad', 'giro'
            ),
            'infoInputs',
            array('legend'=>'Busque por una o más de los siguientes criterios')
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset'
                )
            );

        $this->addDisplayGroup(
            array('nivel_deuda', 'submit'),
            'deudaInput',
            array('legend' => 'Filtre la búsqueda según el nivel de endeudamiento con el proveedor')
        );

        $deudaInput = $this->getDisplayGroup('deudaInput');
        $deudaInput->setDecorators(
            array(
                'FormElements',
                'Fieldset'
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(
                array(
                    'class'     => 'inline',
                    'name'      => 'consulta_proveedor',
                    'action'    => $path . '/proveedor'
                )
            );
    } 
} 
