<?php
class Default_Form_ConsultaVehiculo extends Zend_Form
{ 
    public function __construct($options = null, $path = null)
    { 
        parent::__construct($options);

        $categoria_id = new Zend_Form_Element_Select('categoria_id');
        $categoria_id->setLabel('Categoría')
               ->setRequired(false)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addValidator('NotEmpty')
               ->addMultiOption('','-- Seleccionar --')
               ->addMultiOptions(Default_Model_CategoriaVehiculo::getPairsToSelect());

        $marca_id = new Zend_Form_Element_Select('marca_id');
        $marca_id->setLabel('Marca')
               ->setRequired(false)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addValidator('NotEmpty')
               ->addMultiOption('','-- Seleccionar --')
               ->addMultiOptions(Default_Model_MarcaVehiculo::getPairsToSelect());

        $tipo_combustible = new Zend_Form_Element_Select('tipo_combustible');
        $tipo_combustible->setLabel('Tipo combustible')
                         ->setRequired(false)
                         ->addFilter('StripTags')
                         ->addFilter('StringTrim')
                         ->addValidator('NotEmpty')
                         ->addMultiOption('','-- Seleccionar --')
                         ->addMultiOption('GASOLINA','GASOLINA')
                         ->addMultiOption('DIESEL','DIESEL')
                         ->addMultiOption('ETANOL','ETANOL')
                         ->addMultiOption('ALCOHOL','ALCOHOL');

        $ystart = new Zend_Form_Element_Text('ystart');
        $ystart->setLabel('Año inicio')
                ->setRequired(false)
                ->addFilter('StripTags')
                ->addFilter('StringTrim')
                ->addValidator('NotEmpty');

        $yend = new Zend_Form_Element_Text('yend');
        $yend->setLabel('Año término')
                ->setRequired(false)
                ->addFilter('StripTags')
                ->addFilter('StringTrim')
                ->addValidator('NotEmpty');

        $patente = new Zend_Form_Element_Text('patente');
        $patente->setLabel('Patente')
                ->setRequired(false)
                ->addFilter('StripTags')
                ->addFilter('StringTrim')
                ->addValidator('NotEmpty');

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Buscar');
        
        $this->addElements(
            array(
                $categoria_id, $marca_id,
                $tipo_combustible, $ystart,
                $yend, $patente, $submit
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Fieldset')
             ->addDecorator('Form')
             ->setAttribs(
                 array(
                    'class'     => 'normal',
                    'name'      => 'consulta_vehiculo',
                    'action'    => $path . '/vehiculo'
                ))
             ->setElementDecorators(array(
                array('ViewHelper'),
                array('Errors'),
                array('Description'),
                array('Label', array('separator'=>' ')),
                array('HtmlTag', array('tag' => 'div', 'class'=>'campo_ingreso')),
            ));

        $submit->setDecorators(array(
            array('ViewHelper'),
            array('Description'),
            array('HtmlTag', array('tag' => 'div', 'class'=>'campo_submit')),
        ));

    } 
} 
