<?php
class Default_Form_Contacto extends Zend_Form
{ 
    public function __construct($options = null, $path = null )
    { 
        parent::__construct($options);
             
        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int');

        $referencia_id = new Zend_Form_Element_Hidden('referencia_id');
        $referencia_id->addValidator('Int')
                      ->addFilter('StringTrim')
                      ->addFilter('StripTags');

        $tabla = new Zend_Form_Element_Hidden('tabla');
        $tabla->addValidator('Alpha')
              ->addFilter('StringTrim')
              ->addFilter('StripTags');

        $categoria_id = new Zend_Form_Element_Select('categoria_id');
        $categoria_id->setLabel('Categoría')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addMultiOption('','-- Seleccionar --')
              ->addMultiOptions(Default_Model_CategoriaContacto::getPairsToSelect());
             
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');     
             
        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Email')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('EmailAddress');
         
        $telefono = new Zend_Form_Element_Text('telefono');
        $telefono->setLabel('Teléfono')
              ->setRequired(false)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim') 
              ->addValidator('NotEmpty'); 
        
        $movil = new Zend_Form_Element_Text('movil');
        $movil->setLabel('Tel. Móvil')
              ->setRequired(false)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
        
        $fax = new Zend_Form_Element_Text('fax');
        $fax->setLabel('Fax')
              ->setRequired(false)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim'); 

        $direccion = new Zend_Form_Element_Text('direccion');
        $direccion->setLabel('Dirección')
              ->setRequired(false)
              ->addFilter('StripTags')
              ->addFilter('StringTrim');

        $ciudad = new Zend_Form_Element_Text('ciudad');
        $ciudad->setLabel('Ciudad')
              ->setRequired(false)
              ->addFilter('StripTags')
              ->addFilter('StringTrim');

        $observaciones = new Zend_Form_Element_Textarea('observaciones');
        $observaciones->setLabel('Observaciones')
              ->setRequired(false)
              ->addFilter('StripTags')
              ->addFilter('StringTrim');

        $etiquetas = new Zend_Form_Element_Text('etiquetas');
        $etiquetas->setLabel('Etiquetas')
              ->setRequired(false)
              ->addFilter('StripTags')
              ->addFilter('StringTrim');
            
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Crear contacto');
        $submit->setAttribs(array('class' => 'ui-button ui-state-default submit-inputs ui-corner-all'));
        
        $this->addElements(
            array(
                $id, $referencia_id, $tabla, $categoria_id,
                $nombre, $mail, $telefono, $movil,
                $fax, $direccion, $ciudad, $etiquetas,
                $observaciones, $submit
            ));
            
        $this->addDisplayGroup(
            array(
                'id', 'referencia_id', 'tabla',
                'categoria_id', 'nombre', 'mail',
                'telefono', 'movil', 'fax',
                'direccion', 'ciudad', 'etiquetas',
                'observaciones', 'submit'
            ),
            'infoInputs', 
            array('legend'=>'Por favor ingrese toda la información requerida')
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
            )
        );

        /* alternative decoration */

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'inline',
                'name'      => 'contacto',
                'action'    => $path . '/new'));

        $this->id->clearDecorators();
        $this->tabla->clearDecorators();
        $this->referencia_id->clearDecorators();

    } 
} 
