<?php
class Default_Form_CostoRefArticulo extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/costo-articulo')
    { 
        parent::__construct($options);

        $dataArticulos = array(
            'table' => 'articulos',
            'field' => 'codigo'
        );

        $validadorCodigo = new Zend_Validate_Db_RecordExists($dataArticulos);

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $articulo = new Zend_Form_Element_Text('articulo');
        $articulo->setLabel('Código artículo')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addFilter('StringToUpper')
               ->addValidator($validadorCodigo);

        $costo = new Zend_Form_Element_Text('costo');
        $costo->setLabel('Costo unitario neto referencial')
                     ->setRequired(true)
                     ->addFilter('StripTags')
                     ->addFilter('StringTrim')
                     ->addValidator('Int');

        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Ingresar costo referencial')
               ->setAttrib('class','articulo')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $articulo, $costo, $submit, $cancel, $back
            ));

        $this->addDisplayGroup(
            array(
                'articulo', 'costo'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'costo-articulo',
                'action'    => $path . '/new-ref'
            ));

    } 
} 
