<?php
class Default_Form_Vehiculo extends Zend_Form 
{ 
    public function __construct($options = null, $path = null)
    { 
        parent::__construct($options);
        
        $id = new Zend_form_Element_Hidden('id');
        $id->addValidator('Int');

        $patente = new Zend_Form_Element_Text('patente');
        $patente->setLabel('Placa patente')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim') 
              ->addValidator('NotEmpty');
              
        $color = new Zend_Form_Element_Text('color');
        $color->setLabel('Color carrocería')
            ->setRequired(true)
            ->addFilter('StripTags') 
            ->addFilter('StringTrim') 
            ->addValidator('NotEmpty');
             
        $marca = new Zend_Form_Element_Text('marca');
        $marca->setLabel('Marca')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim') 
              ->addValidator('NotEmpty');     
             
        $modelo = new Zend_Form_Element_Text('modelo');
        $modelo->setLabel('Modelo')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim') 
              ->addValidator('NotEmpty'); 
         
        $anio = new Zend_Form_Element_Text('anio');
        $anio->setLabel('Año')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim') 
              ->addValidator('NotEmpty'); 
            
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('ingresar proveedor');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('cancelar');

        
        $this->addElements(
            array(
                $id, $patente, $marca,
                $modelo, $anio, $color, 
                $submit, $cancel
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(
                 array(
                    'class'     => 'normal',
                    'name'      => 'detalles_vehiculo',
                    'action'    => $path . '/new'
            ))
             ->setElementDecorators(array(
                array('ViewHelper'),
                array('Errors'),
                array('Description'),
                array('Label', array('separator'=>' ')),
                array('HtmlTag', array('tag' => 'div', 'class'=>'input')),
            ));  
               
        $submit->setDecorators(array(
            array('ViewHelper'),
            array('Description'),
            array('HtmlTag', array('tag' => 'div', 'class'=>'submit')),
        ));

        $cancel->setDecorators(array(
            array('ViewHelper'),
            array('Description'),
            array('HtmlTag', array('tag' => 'div', 'class'=>'campo_cancel')),
        ));

    } 
} 
