<?php
class Default_Form_DocumentoBancarioRecibido extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/pago-recibido')
    { 
        parent::__construct($options);

        $pago_id = new Zend_Form_Element_Hidden('pago_id');
        $pago_id->setRequired(true)
                ->addValidator('Int')
                ->setDecorators(array('ViewHelper'));

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $tipo_id = new Zend_Form_Element_Select('tipo_id');
        $tipo_id->setLabel('Tipo de documento')
                ->setRequired(true)
                ->addFilter('StripTags')
                ->addFilter('StringTrim')
                ->addMultiOption('', '-- Seleccionar --')
                ->addMultiOptions(Default_Model_TipoDocumentoBancario::getPairsToSelect());

        $fecha_cobro = new Zend_Form_Element_Text('fecha_cobro');
        $fecha_cobro->setLabel('Fecha de cobro')
                    ->setRequired(true)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->addValidator('Date')
                    ->setAttrib('class', 'show-calendar');

        $banco = new Zend_Form_Element_Select('banco');
        $banco->setLabel('Banco')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addMultiOption('','-- Seleccionar --')
               ->addMultiOptions(Default_Model_Banco::getPairsToSelect());

        $cuenta = new Zend_Form_Element_Text('cuenta');
        $cuenta->setLabel('Cuenta')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim');

        $serie = new Zend_Form_Element_Text('serie');
        $serie->setLabel('Nº Serie')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim');

        $titular = new Zend_Form_Element_Text('titular');
        $titular->setLabel('Titular')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim');

        $monto = new Zend_Form_Element_Text('monto');
        $monto->setLabel('Monto')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator('Int');

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Registrar documento')
               ->setAttrib('class','documento-bancario-recibido')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $pago_id, $tipo_id, $fecha_cobro,
                $banco, $cuenta, $serie, $titular,
                $submit, $cancel, $back
            ));

        $this->addDisplayGroup(
            array(
                'tipo_id', 'fecha_cobro', 'banco', 'cuenta', 'serie', 'titular', 'monto'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            ));

        $this->addDisplayGroup(
            array('submit', 'cancel','back','pago_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'documento-bancario-recibido',
                'action'    => $path . '/new'
            ));

    } 
} 
