<?php
class Default_Form_Envase extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/status/base')
    { 
        parent::__construct($options);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $tipo_id = new Zend_Form_Element_Select('tipo_id');
        $tipo_id->setLabel('Tipo de envase')
                ->setRequired(true)
                ->addMultiOption('', '-- Seleccionar --')
                ->addMultiOptions(Default_Model_TipoEnvase::getPairsToSelect());

        $unidad_id = new Zend_Form_Element_Select('unidad_id');
        $unidad_id->setLabel('Unidad de medida')
                ->setRequired(true)
                ->addMultiOption('', '-- Seleccionar --')
                ->addMultiOptions(Default_Model_UnidadMedida::getPairsToSelect());
              
        $cantidad = new Zend_Form_Element_Text('cantidad');
        $cantidad->setLabel('Cantidad por envase')
                 ->setRequired(true)
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim');
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Crear envase')
               ->setAttrib('class','almacen')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $tipo_id, $cantidad, $unidad_id,
                $submit, $cancel, $back
            ));


        $this->addDisplayGroup(
            array(
                'tipo_id', 'unidad_id', 'cantidad'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'envase',
                'action'    => $path . '/new'
            ));

    } 
} 
