<?php
class Default_Form_EquivalenciaArticulo extends Zend_Form
{
    public function __construct($options = null, $path = null, $history = '/equivalencia-articulo')
    { 
        parent::__construct($options);

        $validator_codigo = new Zend_Validate_Db_RecordExists('articulos', 'codigo');

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $codigo1 = new Zend_Form_Element_Text('codigo1');
        $codigo1->setLabel('Código artículo 1')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addValidator($validator_codigo);

        $codigo2 = new Zend_Form_Element_Text('codigo2');
        $codigo2->setLabel('Código artículo 2')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addValidator($validator_codigo);

        $observaciones = new Zend_Form_Element_Textarea('observaciones');
        $observaciones->setLabel('Observaciones')
               ->addFilter('StripTags')
               ->addFilter('StringTrim');
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Crear equivalencia')
               ->setAttrib('class','equivalencia-articulo')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));

        $this->addElements(
            array(
                $id, $codigo1, $codigo2,
                $observaciones, $submit,
                $cancel, $back
            ));

        $this->addDisplayGroup(
            array(
                'codigo1', 'codigo2',
                'observaciones'
            ),
            'infoInputs',
            array(
                'legend' => 'Ingrese la información requerida'
            ));

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
        ));

        $this->addDisplayGroup(
            array('submit', 'cancel','back', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'equivalencia-articulo',
                'action'    => $path . '/new'
            ));
    } 
} 
