<?php
class Default_Form_FacturaProveedor extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/status/compras')
    { 
        parent::__construct($options);

        $validador_rut = new App_Validate_ValidRut();
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $tipo = new Zend_Form_Element_Select('tipo');
        $tipo->setLabel('Tipo')
            ->setRequired(true)
            ->addFilter('StripTags')
            ->addFilter('StringTrim')
            ->addMultiOption('','-- Seleccionar')
            ->addMultiOption('ELECTRONICA', 'ELECTRONICA')
            ->addMultiOption('NORMAL','NORMAL');

        $proveedor = new Zend_Form_Element_Text('proveedor');
        $proveedor->setLabel('R.U.T. Proveedor')
            ->setRequired(true)
            ->addFilter('StripTags')
            ->addFilter('StringTrim')
            ->addValidator($validador_rut);
        
        $numero = new Zend_Form_Element_Text('numero');
        $numero->setLabel('Nº Factura')
            ->setRequired(true)
            ->addFilter('StripTags')
            ->addFilter('StringTrim')
            ->addValidator('Int');

        $neto = new Zend_Form_Element_Text('neto');
        $neto->setLabel('Total neto')
            ->setRequired(true)
            ->addFilter('StripTags')
            ->addFilter('StringTrim')
            ->addValidator('Int');

        $iva = new Zend_Form_Element_Text('iva');
        $iva->setLabel('Total I.V.A.')
            ->setRequired(true)
            ->addFilter('StripTags')
            ->addFilter('StringTrim')
            ->addValidator('Int');

           
        $fecha_e = new Zend_Form_Element_Text('fecha_e');
        $fecha_e->setLabel('Fecha emisión')
            ->setRequired(true)
            ->addFilter('StripTags')
            ->addFilter('StringTrim')
            ->addValidator('Date');

        $vence_en = new Zend_Form_Element_Text('vence_en');
        $vence_en->setLabel('Vence en (días)')
            ->setRequired(true)
            ->addFilter('StripTags')
            ->addFilter('StringTrim')
            ->addValidator('Int');
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Ingresar factura de proveedor')
               ->setAttrib('class','factura-proveedor')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $tipo, $proveedor, $numero,
                $neto, $iva, $fecha_e, $vence_en,
                $submit, $cancel, $back
            ));

        $this->addDisplayGroup(
            array(
                'proveedor', 'numero',
                'fecha_e', 'tipo'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array(
                'neto', 'iva', 'vence_en'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'envase',
                'action'    => $path . '/new'
            ));
    } 
} 
