<?php
class Default_Form_FormaPago extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/forma-pago')
    { 
        parent::__construct($options);

        $validadorLocale = new App_Validate_Float();
        $validadorRango = new Zend_Validate_Between(array('min' => '0', 'max' => '100'));

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));
              
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim');

        $porcentaje_recargo = new Zend_Form_Element_Text('porcentaje_recargo');
        $porcentaje_recargo->setLabel('Recargo (%)')
                           ->setRequired(true)
                           ->addValidator($validadorRango)
                           ->addValidator($validadorLocale);

        $detallar = new Zend_Form_Element_Select('detallar');
        $detallar->setLabel('Detallar')
               ->setRequired(true)
               ->addMultiOption('','-- Seleccionar --')
               ->addMultiOption('NO', 'NO')
               ->addMultiOption('DOCUMENTO', 'DOCUMENTO')
               ->addMultiOption('CODIGO', 'CODIGO');

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Crear forma de pago')
               ->setAttrib('class','almacen')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $nombre, $porcentaje_recargo, $detallar,
                $submit, $cancel, $back
            ));

        $this->addDisplayGroup(
            array(
                'nombre', 'porcentaje_recargo', 'detallar'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'forma-pago',
                'action'    => $path . '/new'
            ));
    } 
} 
