<?php
class Default_Form_InfoAdicionalModeloVehiculo extends Zend_Form
{
    public function __construct($options = null, $path = null, $history = '/')
    { 
        parent::__construct($options);

        $optionsModelo = array('table' => 'modelos_vehiculos', 'field' => 'id');
        $validadorModelo = new Zend_Validate_Db_RecordExists($optionsModelo);

        $descripcionNombre = 'POr ejemplo: "Filtro de Aire", "Bujías"';

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $modelo_id = new Zend_Form_Element_Hidden('modelo_id');
        $modelo_id->setRequired(true)
                  ->addFilter('StripTags')
                  ->addFilter('StringTrim')
                  ->addValidator($validadorModelo);

        $nombre = new Zend_Form_Element_Textarea('nombre');
        $nombre->setLabel('Nombre')
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->setRequired(true)
                 ->setAttrib("class", "tooltip")
                 ->setDescription($descripcionNombre);

        $detalles = new Zend_Form_Element_Textarea('detalles');
        $detalles->setLabel('Detalles anotación')
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->setRequired(true);

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Agregar anotación')
               ->setAttrib('class','info-adicional-modelo')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $modelo_id, $nombre, $detalles,
                $submit));

        $this->addDisplayGroup(
            array(
                'nombre', 'detalles'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'id', 'modelo_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'info-adicional-modelo-vehiculo',
                'action'    => $path . '/new'
            ));
    } 
} 
