<?php
class Default_Form_IngresoCajaChica extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/caja-chica')
    { 
        parent::__construct($options);

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $caja_id = new Zend_Form_Element_Select('caja_id');
        $caja_id->setLabel('Caja chica')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addMultiOption('','-- Seleccionar --')
               ->addMultiOptions(Default_Model_VistaCajasChicas::getPairsToSelect());   

        $cantidad = new Zend_Form_Element_Text('cantidad');
        $cantidad->setLabel('Monto entregado ($)')
                 ->setRequired(true)
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->addValidator('Int')
                 ->setAttrib('class', 'tooltip')
                 ->setDescription('Número sin puntos ni signos');
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Registrar ingreso')
               ->setAttrib('class','caja-chica')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $caja_id, $cantidad, $submit, $cancel, $back, $id
            ));

        $this->addDisplayGroup(
            array(
                'caja_id', 'cantidad'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'ingreso-caja-chica',
                'action'    => $path . '/new'
            ));
    } 
} 
