<?php
class Default_Form_ItemNotaCompra extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);

        $validadorCodigo = new Zend_Validate_Db_RecordExists(array(
            'table' => $table,
            'field' => 'codigo'
        ));

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $nota_id = new Zend_Form_Element_Hidden('nota_id');
        $nota_id->addValidator('Int')
                      ->setDecorators(array('ViewHelper'));

        $buscador = new Zend_Form_Element_Text('buscador');
        $buscador->setLabel('Buscar servicio')
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->setRequired(false)
                 ->setAttrib('onkeypress', 'ajaxSearchServicio($(this), "#codigo", "#descripcion")');

        $codigo = new Zend_Form_Element_Text('codigo');
        $codigo->setLabel('Código')
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->setRequired(false);

        $valor_neto = new Zend_Form_Element_Text('valor_neto');
        $valor_neto->setLabel('Valor Unitario Neto')
                   ->setRequired(true)
                   ->addFilter('StripTags')
                   ->addFilter('StringTrim')
                   ->addvalidator('Int');

        $cantidad = new Zend_Form_Element_Text('cantidad');
        $cantidad->setLabel('Cantidad')
                 ->setRequired(true)
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->addValidator('Int');

        $descripcion = new Zend_Form_Element_Textarea('descripcion');
        $descripcion->setLabel('Descripción')
                    ->setRequired(true)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->setAttrib('style', 'width:400px;height:77px;');

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Agregar a la nota')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $nota_id, $buscador, $codigo,
                $valor_neto, $cantidad,
                $descripcion, $submit
            ));
            
        $this->addDisplayGroup(
            array(
                'buscador'
            ),
            'busquedaInputs'
        );

        $busquedaInputs = $this->getDisplayGroup('busquedaInputs');
        $busquedaInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-busqueda'))
            ));

        $this->addDisplayGroup(
            array(
                'codigo', 'valor_neto', 'cantidad'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            ));

        $this->addDisplayGroup(
            array(
                'descripcion'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'id', 'nota_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'item',
                'action'    => '/item-nota-compra/new'
            ));
    } 
} 
