<?php
class Default_Form_ItemOrdenCompra extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);

        $validadorFloat = new App_Validate_Float();

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $buscador = new Zend_Form_Element_Text('buscador');
        $buscador->setLabel('Buscar artículo')
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->setRequired(false)
                 ->setAttrib('onkeypress', 'ajaxSearchArticulo($(this), "#codigo", "#valor_neto", "#descripcion")');

        $orden_id = new Zend_Form_Element_Hidden('orden_id');
        $orden_id->addValidator('Int')
                      ->setDecorators(array('ViewHelper'));

        $codigo = new Zend_Form_Element_Text('codigo');
        $codigo->setLabel('Código')
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->setRequired(false);

        $cantidad = new Zend_Form_Element_Text('cantidad');
        $cantidad->setLabel('Cantidad')
                 ->setRequired(true)
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->addValidator($validadorFloat);

        $unidad_medida = new Zend_Form_Element_Select('unidad_medida');
        $unidad_medida->setLabel('Unidad de medida')
                      ->setRequired(true)
                      ->addFilter('StripTags')
                      ->addFilter('StringTrim')
                      ->addMultiOption('','-- Seleccionar --')
                      ->addMultiOptions(Default_Model_UnidadMedida::getPairsToSelectBasic());

        $valor_neto = new Zend_Form_Element_Text('valor_neto');
        $valor_neto->setLabel('Valor unitario neto')
                      ->setRequired(true)
                      ->addFilter('StripTags')
                      ->addFilter('StringTrim')
                      ->addvalidator('Int');

        $tipo_descuento = new Zend_Form_Element_Radio('tipo_descuento');
        $tipo_descuento->setLabel('Tipo descuento')
                       ->setRequired(true)
                       ->addMultiOption('PORCENTAJE', '% porcentaje')
                       ->addMultiOption('MONTO', '$ monto')
                       ->setValue('PORCENTAJE');

        $descuento = new Zend_Form_Element_Text('descuento');
        $descuento->setLabel('Valor descuento')
                   ->setRequired(true)
                   ->addFilter('StripTags')
                   ->addFilter('StringTrim')
                   ->setValue(0);


        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
                 ->setRequired(true)
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim');

        $descripcion = new Zend_Form_Element_Textarea('descripcion');
        $descripcion->setLabel('Descripción')
                    ->setRequired(false)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->setAttrib("style", "height:80px;");

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Agregar a la orden')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $orden_id, $cantidad,
                $unidad_medida, $valor_neto,
                $descripcion, $submit, $buscador,
                $codigo, $descuento, $nombre, $tipo_descuento
            ));

        $this->addDisplayGroup(
            array(
                'buscador'
            ),
            'busquedaInputs'
        );

        $busquedaInputs = $this->getDisplayGroup('busquedaInputs');
        $busquedaInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-busqueda'))
            ));
            
        $this->addDisplayGroup(
            array(
                 'cantidad', 'valor_neto', 'tipo_descuento' ,'descuento'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            ));

        $this->addDisplayGroup(
            array(
                'unidad_medida','nombre', 'codigo', 'descripcion'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left-ancho'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'id', 'orden_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'item',
                'action'    => '/item-orden-compra/new'
            ));
    } 
} 
