<?php
class Default_Form_ItemPautaMantencion extends Zend_Form
{ 
    public function __construct($options = null)
    { 
        parent::__construct($options);

        $kms_primer_servicio = array(
            '0'         => '0',
            '1000'      => '1.000',
            '2000'      => '2.000',
            '3000'      => '3.000',
            '4000'      => '4.000',
            '5000'      => '5.000',
            '7500'      => '7.500',
            '10000'     => '10.000'
        );

        $kms_ciclo = array(
            '5000'      => '5.000',
            '7500'      => '7.500',
            '10000'     => '10.000',
            '15000'     => '15.000',
            '20000'     => '20.000',
            '25000'     => '25.000',
            '30000'     => '30.000',
            '35000'     => '35.000',
            '40000'     => '40.000',
            '45000'     => '45.000',
            '50000'     => '50.000',
            '55000'     => '55.000',
            '60000'     => '60.000',
            '65000'     => '65.000',
            '70000'     => '70.000',
            '75000'     => '75.000',
            '80000'     => '80.000',
            '85000'     => '85.000',
            '90000'     => '90.000',
            '95000'     => '95.000',
            '100000'    => '100.000',
            '150000'    => '150.000'
        );

        $validadorServicio = new Zend_Validate_Db_RecordExists(array(
            'table' => 'servicios',
            'field' => 'codigo'
        ));

        $validadorPauta = new Zend_Validate_Db_RecordExists(array(
            'table' => 'pautas_mantenciones',
            'field' => 'id'
        ));

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $pauta_id = new Zend_Form_Element_Hidden('pauta_id');
        $pauta_id->addValidator('Int')
                 ->addValidator($validadorPauta)
                 ->setDecorators(array('ViewHelper'));

        $buscador = new Zend_Form_Element_Text('buscador');
        $buscador->setLabel('Buscar servicio')
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->setRequired(false)
                 ->setAttrib('onkeypress', 'ajaxSearchServicioToPauta($(this), "#servicio")');

        $servicio = new Zend_Form_Element_Text('servicio');
        $servicio->setLabel('Código servicio')
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->setRequired(true)
                 ->addValidator($validadorServicio);

        $km_primer_servicio = new Zend_Form_Element_Select('km_primer_servicio');
        $km_primer_servicio->setLabel('Km primer servicio')
                           ->setRequired(true)
                           ->addFilter('StripTags')
                           ->addFilter('StringTrim')
                           ->addValidator('Int')
                           ->addMultiOption('', '-- Seleccionar --')
                           ->addMultiOptions($kms_primer_servicio);

        $km_ciclo_inicio = new Zend_Form_Element_Select('km_ciclo_inicio');
        $km_ciclo_inicio->setLabel('Km inicio del ciclo')
                        ->setRequired(true)
                        ->addFilter('StripTags')
                        ->addFilter('StringTrim')
                        ->addValidator('Int')
                        ->addMultiOption('', '-- Seleccionar --')
                        ->addMultiOptions($kms_ciclo);

        $km_ciclo_intervalo = new Zend_Form_Element_Select('km_ciclo_intervalo');
        $km_ciclo_intervalo->setLabel('Km intervalo')
                           ->setRequired(true)
                           ->addFilter('StripTags')
                           ->addFilter('StringTrim')
                           ->addValidator('Int')
                           ->addMultiOption('', '-- Seleccionar --')
                           ->addMultiOptions($kms_ciclo);

        $km_ciclo_fin = new Zend_Form_Element_Select('km_ciclo_fin');
        $km_ciclo_fin->setLabel('Km fin del ciclo')
                           ->setRequired(true)
                           ->addFilter('StripTags')
                           ->addFilter('StringTrim')
                           ->addValidator('Int')
                           ->addMultiOption('', '-- Seleccionar --')
                           ->addMultiOptions($kms_ciclo);

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Agregar a la pauta')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $pauta_id, $buscador, $servicio, 
                $km_primer_servicio, $km_ciclo_inicio,
                $km_ciclo_intervalo, $km_ciclo_fin,
                $submit
            ));

        $this->addDisplayGroup(
            array(
                'buscador'
            ),
            'busquedaInputs'
        );

        $busquedaInputs = $this->getDisplayGroup('busquedaInputs');
        $busquedaInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-busqueda'))
            ));
            
        $this->addDisplayGroup(
            array(
                'servicio', 'km_primer_servicio'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            ));

        $this->addDisplayGroup(
            array(
                'km_ciclo_inicio', 'km_ciclo_intervalo', 'km_ciclo_fin'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'id', 'pauta_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'item',
                'action'    => "/item-pauta-mantencion/new"
            ));
    } 
} 
