<?php
class Default_Form_ItemServicioCotizacion extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $cotizacion_id = new Zend_Form_Element_Hidden('cotizacion_id');
        $cotizacion_id->addValidator('Int')
                      ->setDecorators(array('ViewHelper'));

        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
                 ->setRequired(true)
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim');

        $cantidad = new Zend_Form_Element_Text('cantidad');
        $cantidad->setLabel('Cantidad')
                 ->setRequired(true)
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->addValidator('Int');

        $unidad_medida = new Zend_Form_Element_Select('unidad_medida');
        $unidad_medida->setLabel('Unidad de medida')
                      ->setRequired(true)
                      ->addFilter('StripTags')
                      ->addFilter('StringTrim')
                      ->addMultiOption('','-- Seleccionar --')
                      ->addMultiOptions(Default_Model_UnidadMedida::getPairsToSelect());

        $neto_unitario = new Zend_Form_Element_Text('neto_unitario');
        $neto_unitario->setLabel('Valor Unitario Neto')
                      ->setRequired(true)
                      ->addFilter('StripTags')
                      ->addFilter('StringTrim')
                      ->addvalidator('Int');

        $descripcion = new Zend_Form_Element_Textarea('descripcion');
        $descripcion->setLabel('Descripción')
                    ->setRequired(false)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim');     

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Agregar a la cotización')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $cotizacion_id, $cantidad, 
                $unidad_medida, $neto_unitario,
                $descripcion, $submit, $nombre
            ));
            
        $this->addDisplayGroup(
            array(
                'cantidad', 'unidad_medida', 'neto_unitario'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            ));

        $this->addDisplayGroup(
            array(
                'nombre', 'descripcion'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left-ancho'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'id', 'cotizacion_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'item',
                'action'    => '/item-cotizacion/new'
            ));
    } 
} 
