<?php
class Default_Form_MarcaVehiculo extends Zend_Form
{
    public function __construct($options = null, $path = null, $history = '/status/base')
    { 
        parent::__construct($options);

        $validadorFloat = new App_Validate_Float();

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));
              
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre marca')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
              
        $cargo_adicional = new Zend_Form_Element_Text('cargo_adicional');
        $cargo_adicional->setLabel('Cargo adicional por dificultad %')
              ->setRequired(true)
              ->addValidator($validadorFloat);
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Agregar marca')
               ->setAttrib('class','marca-vehiculo')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $nombre, $cargo_adicional,
                $submit, $cancel, $back
            ));

        $this->addDisplayGroup(
            array(
                'nombre', 'cargo_adicional'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'marca-vehiculo',
                'action'    => $path . '/new'
            ));
    } 
} 
