<?php
class Default_Form_OrdenServicio extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/orden-servicio')
    { 
        parent::__construct($options);

        $validador_rut = new Zend_Validate_Db_RecordExists(
            array(
                'table' => 'vehiculos',
                'field' => 'patente'
            )
        );

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));
        
        $vehiculo = new Zend_Form_Element_Text('vehiculo');
        $vehiculo->setLabel('Patente del vehículo')
            ->setRequired(true)
            ->addFilter('StripTags')
            ->addFilter('StringTrim')
            ->addValidator($validador_rut);

        $observaciones = new Zend_Form_Element_Textarea('observaciones');
        $observaciones->setLabel('Observaciones')
            ->addFilter('StripTags')
            ->addFilter('StringTrim');
            

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Crear orden de servicio')
               ->setAttrib('class','orden-servicio')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $vehiculo, $observaciones,
                $submit, $cancel, $back
            ));

        $this->addDisplayGroup(
            array(
                'vehiculo', 'observaciones'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left-ancho'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'orden-servicio',
                'action'    => $path . '/new'
            ));
    } 
} 
