<?php
class Default_Form_OrdenServicioInforme extends Zend_Form
{
    public function __construct($options = null)
    {
        parent::__construct($options);

        $validadorOrden = new Zend_Validate_Db_RecordExists(array(
            'table' => 'ordenes_servicios',
            'field' => 'id'
        ));

        $orden_id = new Zend_Form_Element_Hidden('orden_id');
        $orden_id->addValidator('Int')
                 ->addValidator($validadorOrden)
                 ->setDecorators(array('ViewHelper'));

        $type_user = new Zend_Form_Element_Hidden('type_user');
        $type_user->addValidator('Int')
                  ->setValue(0)
                  ->setDecorators(array('ViewHelper'));

        $informe = new Zend_Form_Element_Textarea('informe');
        $informe->setLabel('Informe')
                    ->setRequired(true)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->setAttrib('style', 'width:750px;height:250px;margin:10px 0;');

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Guardar informe')
               ->setDecorators(array('ViewHelper'));

        $this->addElements(array($orden_id, $informe, $submit, $type_user));
        $this->addDisplayGroup(array('informe'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset'
            ));

        $this->addDisplayGroup(
            array('submit', 'orden_id', 'type_user'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'informe-servicio',
                'action'    => "/orden-servicio-informe/new"
            ));
    }
}
