<?php
class Default_Form_OrdenServicioRecomendacion extends Zend_Form
{
    public function __construct($options = null)
    {
        parent::__construct($options);

        $validadorOrden = new Zend_Validate_Db_RecordExists(array(
            'table' => 'ordenes_servicios',
            'field' => 'id'
        ));

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $orden_id = new Zend_Form_Element_Hidden('orden_id');
        $orden_id->addValidator('Int')
                 ->addValidator($validadorOrden)
                 ->setDecorators(array('ViewHelper'));

        $type_user = new Zend_Form_Element_Hidden('type_user');
        $type_user->addValidator('Int')
                ->setValue(0)
                ->setDecorators(array('ViewHelper'));

        $plazo = new Zend_Form_Element_Select('plazo');
        $plazo->setLabel('Prioridad')
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addMultiOption('', '-- Seleccionar')
               ->addMultiOption('ALTA', 'ALTA')
               ->addMultiOption('MEDIA', 'MEDIA')
               ->addMultiOption('BAJA', 'BAJA')
               ->setRequired(true);
        
        $recomendacion = new Zend_Form_Element_Textarea('recomendacion');
        $recomendacion->setLabel('Recomendación')
                    ->setRequired(true)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->setAttrib('style', 'width:750px;height:150px;margin:0 0 10px 0;');

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Agregar recomendación')
               ->setDecorators(array('ViewHelper'));

        $this->addElements(array($id, $orden_id, $plazo, $recomendacion, $submit, $type_user));
        $this->addDisplayGroup(array('plazo', 'recomendacion'),'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset'
            ));

        $this->addDisplayGroup(
            array('submit', 'orden_id', 'id', 'type_user'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'recomendacion',
                'action'    => "/orden-servicio-recomendacion/new"
            ));
    }
}
