<?php
class Default_Form_PautaMantencion extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/pauta-mantencion')
    { 
        parent::__construct($options);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $marca_id = new Zend_Form_Element_Select('marca_id');
        $marca_id->setLabel('Marca vehículo')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addMultiOption('','-- Seleccionar --')
               ->addMultiOptions(Default_Model_MarcaVehiculo::getPairsToSelect());

        $modelos_referencia = new Zend_Form_Element_Textarea('modelos_referencia');
        $modelos_referencia->setLabel('Modelos de referencia')
                           ->setRequired(true)
                           ->addFilter('StripTags')
                           ->addFilter('StringTrim');

        $observaciones = new Zend_Form_Element_Textarea('observaciones');
        $observaciones->setLabel('Observaciones')
               ->addFilter('StripTags')
               ->addFilter('StringTrim');

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Crear pauta')
               ->setAttrib('class','pauta-mantencion')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));

        $this->addElements(
            array(
                $id, $modelos_referencia, $marca_id,
                $observaciones, $submit, $cancel, $back
            ));

        $this->addDisplayGroup(
            array(
                'marca_id', 'modelos_referencia', 'observaciones'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'pauta-mantencion',
                'action'    => $path . '/new'
            ));
    } 
} 
