<?php
class Default_Form_PautasMantenciones extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/status/base')
    { 
        parent::__construct($options);

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $archivo = new Zend_Form_Element_File('archivo');
        $archivo->setLabel('Archivo CSV')
                ->setRequired(false)
                ->addValidator('Count', false, 1)     // sólo 1 archivo
                ->addValidator('Size', false, 307200) // limitado el peso a 300K
                ->addValidator('Extension', false, 'csv'); // archivos cvs para importar directamente 

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Agregar pauta de mantención')
               ->setAttrib('class','pauta-mantencion')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));

        $this->addElements(array($archivo, $submit, $cancel, $back));
        $this->addDisplayGroup(array('archivo'),'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'pautas-mantenciones',
                'action'    => $path . '/new'
            ));
    } 
} 
