<?php
class Default_Form_PermisosUsuario extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/status/config')
    {
        parent::__construct($options);

        $validadorRut = new App_Validate_ValidRut();

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $usuario = new Zend_Form_Element_Text('usuario');
        $usuario->setLabel('R.U.T. Empleado')
                ->setRequired(true)
                ->addValidator($validadorRut);

        $modulo = new Default_Model_Modulo();
        $modulos = $modulo->fetchAll();
        
        
        $r_modulos = array();
        
        foreach($modulos as $row){ //var_dump($row->toArray());
        
            $m[$row->id] = new Zend_Form_Element_Checkbox('m'. $row->id);
            $m[$row->id]->setLabel('Módulo ' . utf8_encode($row->nombre))
                        ->setRequired(true)
                        ->addFilter('StripTags')
                        ->addFilter('StringTrim');

            $r_modulos[] = $m[$row->id];
            $r_n_modulos[] =  'm'. $row->id;
        
        }

        

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Configurar permisos')
               ->setAttrib('class','usuario')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));

        $this->addElements(
            array(
                $usuario, $submit, $cancel, $back
            ));

        $this->addElements($r_modulos);

        $this->addDisplayGroup(
            $r_n_modulos,
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left-ancho'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'permisos-usuario',
                'action'    => $path . '/set-permisos'
            ));

    } 
} 
