<?php
class Default_Form_Preferencia extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $validador = null, $history = '/preferencias')
    { 
        parent::__construct($options);

        switch($validador){
            case "DECIMAL" :
                $validadorVal = new App_Validate_Float();
                break;
            case "INTEGER" :
                $validadorVal = new Zend_Validate_Int();
                break;
        }

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $type = new Zend_Form_Element_Hidden('type');
        $type->setRequired(true)
             ->setValue($validador)
             ->setDecorators(array('ViewHelper'));

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));
              
        $valor = new Zend_Form_Element_Text('valor');
        $valor->setLabel('Valor')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator($validadorVal);
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Guardar cambios')
               ->setAttrib('class','preferencia')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(array($valor, $submit, $cancel, $back, $id, $type));
        $this->addDisplayGroup(array('valor'),'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back', 'id', 'type'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'preferencia',
                'action'    => $path . '/edit'
            ));
    } 
} 
