<?php
class Default_Form_PreferenciasRemBonos extends Zend_Form
{ 
    public function __construct($options = null, $path = null)
    { 
        parent::__construct($options);

        $bp_porcentaje = new Zend_Form_Element_Text('bp_porcentaje');
        $bp_porcentaje->setLabel('% Predet. a distribuir')
                   ->setRequired(true)
                   ->addFilter('StripTags')
                   ->addFilter('StringTrim')
                   ->addValidator('Float');

        $bp_base = new Zend_Form_Element_Select('bp_base');
        $bp_base->setLabel('Base')
             ->setRequired(true)
             ->addFilter('StripTags')
             ->addFilter('StringTrim')
             ->addMultiOption('','-- Seleccionar --')
             ->addMultiOption('VT','Ventas totales')
             ->addMultiOption('VS','Ventas totales servicios')
             ->addMultiOption('MB','Margen bruto')
             ->addMultiOption('MS','Margen bruto servicios');
              
        $bp_dist = new Zend_Form_Element_Select('bp_dist');
        $bp_dist->setLabel('Distribución')
                    ->setRequired(true)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->addMultiOption('','-- Seleccionar --')
                    ->addMultiOption('BPS','Proporcional al sueldo')
                    ->addMultiOption('BPI','Porcentajes iguales');

        $bp_horas_just = new Zend_Form_Element_Select('bp_horas_just');
        $bp_horas_just->setLabel('Horas justificadas a pagar')
                   ->setRequired(true)
                   ->addFilter('StripTags')
                   ->addFilter('StringTrim')
                   ->addMultiOption('','-- Seleccionar --')
                   ->addMultiOption('0','0%')
                   ->addMultiOption('10','10%')
                   ->addMultiOption('20','20%')
                   ->addMultiOption('30','30%')
                   ->addMultiOption('40','40%')
                   ->addMultiOption('50','50%')
                   ->addMultiOption('60','60%')
                   ->addMultiOption('70','70%')
                   ->addMultiOption('80','80%')
                   ->addMultiOption('90','90%')
                   ->addMultiOption('100','100%');

        $cv_base = new Zend_Form_Element_Select('cv_base');
        $cv_base->setLabel('Base')
             ->setRequired(true)
             ->addFilter('StripTags')
             ->addFilter('StringTrim')
             ->addMultiOption('','-- Seleccionar --')
             ->addMultiOption('VT','Ventas totales')
             ->addMultiOption('MB','Margen bruto');

        $cv_dist = new Zend_Form_Element_Select('cv_dist');
        $cv_dist->setLabel('Distribución')
                    ->setRequired(true)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->addMultiOption('','-- Seleccionar --')
                    ->addMultiOption('PT','Comisiones iguales')
                    ->addMultiOption('PP','Comisiones ind.');
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Guardar preferencias');
        $submit->setAttribs(array('class' => 'ui-button ui-state-default submit-inputs ui-corner-all'));
        
        $this->addElements(
            array(
                $bp_porcentaje, $bp_dist, $bp_base,
                $bp_horas_just, $cv_dist, $cv_base,
                $submit
            ));

        $this->addDisplayGroup(
            array(
                'bp_base', 'bp_dist', 'bp_porcentaje',
                'bp_horas_just', 'submit'
                ),
            'bono_produccion',
            array('legend'=>'Bono de producción')
        );

        $this->addDisplayGroup(
            array('cv_base', 'cv_dist'),
            'comision_venta',
            array('legend'=>'Comisiones de ventas')
        );

        $bono_produccion = $this->getDisplayGroup('bono_produccion');
        $bono_produccion->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $comision_venta = $this->getDisplayGroup('comision_venta');
        $comision_venta->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido',
                'name'      => 'preferencias-bonos',
                'action'    => $path . '/set-preferencias-bonos'
            ));
    } 
} 