<?php
class Default_Form_Proveedor extends Zend_Form 
{ 
    public function __construct($options = null, $path = null, $history = '/status/compras')
    {
        parent::__construct($options);

        $validador_rut = new App_Validate_ValidRut();

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $razon_social = new Zend_Form_Element_Text('razon_social');
        $razon_social->setLabel('Razón social')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->setAttrib('class', 'tooltip')
              ->setDescription('Ingrese la Razón Social de la Empresa o el Nombre completo en caso de ser Persona Natural');

        $nombre_fantasia = new Zend_Form_Element_Text('nombre_fantasia');
        $nombre_fantasia->setLabel('Nombre de fantasía')
              ->setRequired(false)
              ->addFilter('StripTags')
              ->addFilter('StringTrim');
             
        $rut = new Zend_Form_Element_Text('rut');
        $rut->setLabel('R.U.T.')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator($validador_rut)
              ->setAttrib('class', 'tooltip')
              ->setDescription('Formato : 12345678-9');
             
        $direccion = new Zend_Form_Element_Text('direccion');
        $direccion->setLabel('Dirección')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim'); 
         
        $comuna = new Zend_Form_Element_Text('comuna');
        $comuna->setLabel('Comuna')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->setAttrib('class', 'autocomplete')
              ->setDescription('/ajax-aux/comunas');
        
        $ciudad = new Zend_Form_Element_Text('ciudad');
        $ciudad->setLabel('Ciudad')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->setAttrib('class', 'autocomplete')
              ->setDescription('/ajax-aux/ciudades');
        
        $telefono = new Zend_Form_Element_Text('telefono');
        $telefono->setLabel('Teléfono')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim'); 
              
        $giro = new Zend_Form_Element_Text('giro');
        $giro->setLabel('Giro')
              ->setRequired(false)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim'); 
              
        $web = new Zend_Form_Element_Text('web');
        $web->setLabel('Sitio Web')
            ->setRequired(false)
            ->addFilter('StripTags') 
            ->addFilter('StringTrim');

        $transporte = new Zend_Form_Element_Text('transporte');
        $transporte->setLabel('Medio de transporte')
              ->setRequired(false)
              ->addFilter('StripTags')
              ->addFilter('StringTrim');
            
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Agregar proveedor')
               ->setAttrib('class','proveedor')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));

        $this->addElements(
            array(
                $razon_social, $rut, $direccion, 
                $comuna, $ciudad, $telefono, $giro,
                $web, $cancel, $back, $submit,
                $nombre_fantasia, $transporte
            ));

        $this->addDisplayGroup(
            array(
                'razon_social', 'rut', 'direccion',
                'comuna', 'ciudad', 'telefono'
            ),
            'infoInputs',
            array(
                'legend'=>'Información de facturación'
            )
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array(
                'nombre_fantasia', 'giro', 'web', 'transporte'
            ),
            'infoInputs2',
            array(
                'legend'=>'Información adicional'
            )
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'envase',
                'action'    => $path . '/new'
            ));
    } 
} 
