<?php
class Default_Form_ReporteError extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);

        $prioridad = new Zend_Form_Element_Select('prioridad');
        $prioridad->setLabel('Urgencia / Prioridad')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addValidator('NotEmpty')
               ->addMultiOption('','-- Seleccionar --')
               ->addMultiOption('Baja','Baja')
               ->addMultiOption('Media','Media')
               ->addMultiOption('Alta','Alta');

        $modulo = new Zend_Form_Element_Select('modulo');
        $modulo->setLabel('Módulo')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addValidator('NotEmpty')
               ->addMultiOption('','-- Seleccionar --')
               ->addMultiOption('Taller','Taller')
               ->addMultiOption('Ventas','Ventas')
               ->addMultiOption('Compras','Compras')
               ->addMultiOption('Inventario','Inventario')
               ->addMultiOption('Contabilidad','Contabilidad')
               ->addMultiOption('Tablas Base','Tablas Base');
              
        $descripcion = new Zend_Form_Element_Textarea('descripcion');
        $descripcion->setLabel('Descripción del error')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addValidator('NotEmpty');              
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('enviar reporte');
        
        $this->addElements(array($prioridad, $modulo, $descripcion, $submit));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Fieldset')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'normal',
                'name'      => 'reporte_error',
                'action'    => '/soporte/index/'
            ))
             ->setElementDecorators(array(
                array('ViewHelper'),
                array('Errors'),
                array('Description'),
                array('Label', array('separator'=>' ')),
                array('HtmlTag', array('tag' => 'div', 'class'=>'campo_ingreso')),
            ));
    
        $submit->setDecorators(array(
            array('ViewHelper'),
            array('Description'),
            array('HtmlTag', array('tag' => 'div', 'class'=>'campo_submit')),
        ));

    } 
} 
