<?php
class Default_Form_SelectCategoria extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $id = 1 )
    { 
        parent::__construct($options);
        
        $this->setName("select_categoria_".$id);
        $this->setAction($path . '/find');
        
        $categoria_id = new Zend_Form_Element_Select('categoria_id'.$id);
        $categoria_id->setLabel('Categoría')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addValidator('NotEmpty')
               ->addMultiOption('','-- Seleccionar --')
               ->addMultiOptions(Default_Model_CategoriaArticulo::getPairsToSelect());

        $this->addElements(array($categoria_id));
 

        /* alternative decoration */

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Fieldset')
             ->addDecorator('Form');

        $this->setElementDecorators(array(
            array('ViewHelper'),
            array('Errors'),
            array('Description'),
            array('Label', array('separator'=>' ')),
            array('HtmlTag', array('tag' => 'div', 'class'=>'campo_ajax_window')),
        ));
    }
} 
