<?php
class Default_Form_SendAttach extends Zend_Form
{ 
    public function __construct($options = null, $path = null)
    { 
        parent::__construct($options);

        $back = new Zend_Form_Element_Hidden('back');
        $back->setDecorators(array('ViewHelper'));

        $id = new Zend_Form_Element_Hidden('id');
        $id->setRequired(true)
           ->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $buscador = new Zend_Form_Element_Text('buscador');
        $buscador->setLabel('Buscar contacto')
                 ->addFilter('StripTags')
                 ->addFilter('StringTrim')
                 ->setRequired(false)
                 ->setAttrib('onkeypress', 'ajaxSearchContactoToMail($(this), "#nombre", "#mail")');

        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
                   ->setRequired(true)
                   ->addFilter('StripTags')
                   ->addFilter('StringTrim');

        $archivo = new Zend_Form_Element_Text('archivo');
        $archivo->setLabel('Archivo adjunto')
                   ->setRequired(true)
                   ->addFilter('StripTags')
                   ->addFilter('StringTrim')
                   ->setAttrib('disabled', 'disabled');

        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Mail')
                   ->setRequired(true)
                   ->addFilter('StripTags')
                   ->addFilter('StringTrim')
                   ->addValidator('EmailAddress');

        $copia = new Zend_Form_Element_Checkbox('copia');
        $copia->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->setAttrib('checked','checked');

        $asunto = new Zend_Form_Element_Text('asunto');
        $asunto->setLabel('Asunto')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim');

        $mensaje = new Zend_Form_Element_Textarea('texto_mensaje');
        $mensaje->setLabel('Mensaje')
                ->setRequired(true)
                ->addFilter('StripTags')
                ->addFilter('StringTrim')
                ->setAttrib('style', 'height:113px;');
            

        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Enviar documento')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $nombre, $mail, $mensaje,
                $submit, $cancel, $back,
                $buscador, $archivo, $copia,
                $id, $asunto
            ));

        $this->addDisplayGroup(
            array(
                'buscador'
            ),
            'busquedaInputs'
        );

        $busquedaInputs = $this->getDisplayGroup('busquedaInputs');
        $busquedaInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-busqueda'))
            ));

        $this->addDisplayGroup(
            array(
                'nombre', 'mail', 'archivo', 'asunto', 'texto_mensaje', 'copia'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left-ancho'))
            ));

        $this->addDisplayGroup(
            array('submit', 'cancel','back', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'envio-documento',
                'action'    => $path . '/send'
            ));

    } 
} 
