<?php
class Default_Form_SendDocumento extends Zend_Form
{ 
    public function __construct($options = null, $path = null)
    {
        parent::__construct($options);

        $atencion_a = new Zend_Form_Element_Text('atencion_a');
        $atencion_a->setLabel('Atención a')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
             
        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Email destinatario')
             ->setRequired(true)
             ->addFilter('StripTags') 
             ->addFilter('StringTrim')
             ->addValidator('EmailAddress');
             
        $mensaje = new Zend_Form_Element_Textarea('mensaje_adicional');
        $mensaje->setLabel('Mensaje')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim'); 

        


        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Enviar');
        $submit->setAttribs(array('class' => 'ui-button ui-state-default submit-inputs ui-corner-all'));

        $this->addElements(
            array(
                $atencion_a, $mail, $mensaje,
                $submit
            ));

        $this->addDisplayGroup(
            array(
                'atencion_a','mail','mensaje_adicional',
                'submit'
            ),
            'infoInputs',
            array(
                'legend'=>'Todos los campos son requeridos'
            )
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido',
                'name'      => 'send',
                'action'    => $path . '/mail'
            ));

    } 
} 
