<?php
class Default_Form_Servicio extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/servicio/index/t/a')
    { 
        parent::__construct($options);

        $validadorFloat = new App_Validate_Float();

        $optionsCodigo = array('table' => 'servicios', 'field' => 'codigo');
        $validadorCodigo = new Zend_Validate_Db_RecordExists($optionsCodigo);

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags')
           ->addFilter('StringTrim')
           ->addFilter('StringToUpper')
           ->addValidator($validadorCodigo)
           ->setDecorators(array('ViewHelper'));

        $codigo = new Zend_Form_Element_Text('codigo');
        $codigo->setLabel('Código')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addFilter('StringToUpper');

        $categoria_id = new Zend_Form_Element_Select('categoria_id');
        $categoria_id->setLabel('Categoría')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addMultiOption('','-- Seleccionar --')
               ->addMultiOptions(Default_Model_CategoriaServicio::getPairsToSelect());

        $area_id = new Zend_Form_Element_Select('area_id');
        $area_id->setLabel('Área de trabajo')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addMultiOption('','-- Seleccionar --')
               ->addMultiOptions(Default_Model_AreaTrabajo::getPairsToSelect());

        $mano_obra_id = new Zend_Form_Element_Select('mano_obra_id');
        $mano_obra_id->setLabel('Tipo de mano de obra')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addMultiOption('','-- Seleccionar --')
               ->addMultiOptions(Default_Model_TipoManoObra::getPairsToSelect());

        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim');

        $horas_trabajo = new Zend_Form_Element_Text('horas_trabajo');
        $horas_trabajo->setLabel('Horas de trabajo')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->addValidator($validadorFloat);

        $descripcion = new Zend_Form_Element_Textarea('descripcion');
        $descripcion->setLabel('Descripción')
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim');
        
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Crear servicio')
               ->setAttrib('class','servicio')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(array(
            $codigo, $categoria_id, $area_id, $id, 
            $mano_obra_id, $nombre, $horas_trabajo,
            $descripcion, $submit, $cancel, $back
        ));
            
        $this->addDisplayGroup(
            array(
                 'codigo', 'nombre', 'categoria_id',
                 'area_id', 'descripcion'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array(
                'mano_obra_id', 'horas_trabajo'

            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel','back', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'servicio',
                'action'    => $path . '/new'
            ));
        
    } 
} 
