<?php
class Default_Form_TarjetaCredito extends Zend_Form
{ 
    public function __construct($options = null, $path = null)
    { 
        parent::__construct($options);
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int');
        
        $cuenta_corriente_id = new Zend_Form_Element_Select('cuenta_corriente_id');
        $cuenta_corriente_id->setLabel('Cuenta corriente')
            ->setRequired(true)
            ->addFilter('StripTags')
            ->addFilter('StringTrim')
            ->addValidator('NotEmpty')
            ->addMultiOption('','-- Seleccionar --')
            ->addMultiOptions(Default_Model_CuentaCorriente::getPairsToSelect());

        $numero = new Zend_Form_Element_Text('numero');
        $numero->setLabel('Número de tarjeta')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim') 
              ->addValidator('NotEmpty')
              ->addValidator('Ccnum');
             
        $cupo = new Zend_Form_Element_Text('cupo');
        $cupo->setLabel('Cupo de la tarjeta')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim') 
              ->addValidator('NotEmpty')
              ->addValidator('Int');
             
        $expira_month = new Zend_Form_Element_Text('expira_month');
        $expira_month->setLabel('Expira : Mes')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim') 
              ->addValidator('NotEmpty')
              ->addValidator('Between', false, array('1','12'));

        $expira_year = new Zend_Form_Element_Text('expira_year');
        $expira_year->setLabel('Expira : Año')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator('NotEmpty')
              ->addValidator('Between', false, array(date("Y"),date("Y")+10));
         
        $tipo = new Zend_Form_Element_Select('tipo');
        $tipo->setLabel('Tipo de tarjeta')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim') 
              ->addValidator('NotEmpty')
              ->addMultiOption('','-- Seleccionar --')
              ->addMultiOption('Mastercard','Mastercard')
              ->addMultiOption('Visa','Visa');
            
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('crear tarjeta de crédito');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('cancelar');
        
        $this->addElements(
            array($id, $cuenta_corriente_id, $tipo,  
                $numero, $cupo, $expira_month,
                $expira_year, $submit, $cancel
            ));
            

        /* alternative decoration */

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Fieldset')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'normal',
                'name'      => 'tarjeta_credito',
                'action'    => $path . '/new'
            ))
             ->setElementDecorators(array(
                array('ViewHelper'),
                array('Errors'),
                array('Description'),
                array('Label', array('separator'=>' ')),
                array('HtmlTag', array('tag' => 'div', 'class'=>'campo_ingreso')),
            ));

        $id->setDecorators(array(
            array('ViewHelper'),
            array('Description'),
            array('HtmlTag', array('tag' => 'div', 'class'=>'campo_hidden')),
        ));

        $submit->setDecorators(array(
            array('ViewHelper'),
            array('Description'),
            array('HtmlTag', array('tag' => 'div', 'class'=>'campo_submit')),
        ));

        $cancel->setDecorators(array(
            array('ViewHelper'),
            array('Description'),
            array('HtmlTag', array('tag' => 'div', 'class'=>'campo_cancel')),
        ));
    } 
} 
