<?php
class Default_Form_Usuario extends Zend_Form
{ 
    public function __construct($options = null, $path = null, $history = '/usuario')
    { 
        parent::__construct($options);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setDecorators(array('ViewHelper'));

        $back = new Zend_Form_Element_Hidden('back');
        $back->setValue($history)
             ->setDecorators(array('ViewHelper'));

        $empleado = new Zend_Form_Element_Select('empleado');
        $empleado->setLabel('Empleado')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addMultiOption('','-- Seleccionar --')
              ->addMultiOptions(Default_Model_Empleado::getPairsToSelect());
        
        $usuario = new Zend_Form_Element_Text('usuario');
        $usuario->setLabel('Usuario')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');


        $modulo = new Default_Model_Modulo();
        $modulos = $modulo->fetchAll()->toArray();

        $array_mods = array();

        foreach($modulos as $row){

            if($row['list']==='1') {
                
                $mod[$row['id']] = new Zend_Form_Element_Checkbox('mod'. $row['id']);
                $mod[$row['id']]->setLabel(utf8_encode($row['nombre']));

                $array_mods[] = 'mod'. $row['id'];

                $this->addElement($mod[$row['id']]);
            }

        }
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Crear usuario')
               ->setAttrib('class','usuario')
               ->setDecorators(array('ViewHelper'));

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $id, $empleado, $usuario,
                $submit, $cancel, $back
            ));

        $this->addDisplayGroup(
            array(
                'empleado', 'usuario'
            ),
            'infoInputs',
            array(
                'legend'=>'Información acceso'
            )
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );
        
        $this->addDisplayGroup(
            $array_mods,
            'modulosInputs',
            array(
                'legend'=>'Módulos autorizados'
            )
        );

        $modulosInputs = $this->getDisplayGroup('modulosInputs');
        $modulosInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel','back', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            ));

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido ajax',
                'name'      => 'almacen',
                'action'    => $path . '/new'
            ));

    } 
} 
