<?php
class Default_Model_Empresa extends Zend_Db_Table_Abstract
{
    protected $_name = 'propietario';
    
    public function getClientes()
    {
        $cliente = new Cliente();
        $clientes = $cliente->getAll();
        return $clientes;
    }

    public function getContactosClientes()
    {
        $contacto = new ContactoCliente();
        $contactos = $contacto->getAll();
        return $contactos;
    }

    public function getProveedores()
    {
        $proveedor = new Proveedor();
        $proveedores = $proveedor->getAll();
        return $proveedores;
    }

    public function getContactosProveedores()
    {
        $contacto = new ContactoProveedor();
        $contactos = $contacto->getAll();
        return $contactos;
    }

    public function getEmpleados()
    {
        $empleado = new Empleado();
        $empleados = $empleado->getAll();
        return $empleados;
    }


    public function getContratos()
    {
        $contrato = new ContratoEmpleado();
        $contratos = $contrato->getAll();
        return $contratos;
    }

    public function getBancos()
    {
        $banco = new Banco();
        $bancos = $banco->getAll();
        return $bancos;
    }

    public function getCuentasCorrientes()
    {
        $cuenta = new CuentaCorriente();
        $cuentas = $cuenta->getAll();
        return $cuentas;
    }

    public function getTarjetasCredito()
    {
        $tarjeta_credito = new TarjetaCredito();
        $tarjetas_credito = $tarjeta_credito->getAll();
        return $tarjetas_credito;
    }

    public function getTarjetasDebito()
    {
        $tarjeta_debito = new TarjetaDebito();
        $tarjetas_debito = $tarjeta_debito->getAll();
        return $tarjetas_debito;
    }


    public function getFormasPago()
    {
        $forma_pago = new FormaPago();
        $formas_pago = $forma_pago->getAll();
        return $formas_pago;
    }

    public function getEmpresa()
    {
        $db = Zend_Registry::get('db');
        $db->setFetchMode(Zend_Db::FETCH_OBJ);
         $select = $db->select()
            ->from('propietario',
                array(
                    'rut', 'razon_social', 'nombre_fantasia',
                    'direccion', 'telefono', 'ciudad', 'comuna',
                    'giro', 'mail', 'web', 'fax'
                ))
            
            ->limit(1);
        $result = $db->fetchRow($select);
        return $result;
    }

    public function getEmpresaToForm()
    {
        $db = Zend_Registry::get('db');
        $db->setFetchMode(Zend_Db::FETCH_ASSOC);
         $select = $db->select()
            ->from('propietario',
                array(
                    'rut', 'razon_social', 'nombre_fantasia',
                    'direccion', 'telefono', 'ciudad', 'comuna',
                    'giro', 'mail', 'web', 'fax'
                ))

            ->limit(1);
        $result = $db->fetchRow($select);
        return $result;
    }

    public function getRut()
    {
        $db = Zend_Registry::get('db');
        $db->setFetchMode(Zend_Db::FETCH_OBJ);
        $result = $db->fetchOne("SELECT rut FROM propietario LIMIT 1");
        return $result;
    }
}