<?php
class Default_Model_ItemPautaMantencion extends Zend_Db_Table_Abstract
{
    protected $_name = 'items_pautas_mantenciones';
    protected $_primary = 'id';
        

    public function getRowsByPauta($pauta_id)
    {
        $db = Zend_Registry::get('db');
        $db->setFetchMode(Zend_Db::FETCH_OBJ);
        $select = $db->select()
            ->from(array('ipm' => 'items_pautas_mantenciones'),
                   array('id'))
            ->join(array('spm' => 'servicios_pautas_mantenciones'), 'spm.id=ipm.servicio_id',
                   array('servicio' => 'nombre'))
            ->where('ipm.pauta_id = ?', $pauta_id)
            ->order('spm.nombre');
        $result = $db->fetchAll($select);
        return $result;
    }

    public static function checkExist($pauta, $servicio)
    {
        $db = Zend_Registry::get('db');
        $db->setFetchMode(Zend_Db::FETCH_OBJ);
        $select = $db->select()
            ->from('items_pautas_mantenciones',array('id'))
            ->where('pauta_id = ?', $pauta)
            ->where('servicio_id = ?', $servicio)
            ->limit(1);
        $result = $db->fetchOne($select);
        if($result) {
            return  true;
        } else {
            return false;
        }
    }

    public static function checkExistByKm($km, $servicio)
    {
        
        $db = Zend_Registry::get('db');
        $db->setFetchMode(Zend_Db::FETCH_OBJ);
        $select = $db->select()
            ->from(array('ipm' => 'items_pautas_mantenciones'), array('id'))
            ->join(array('pm' => 'pautas_mantenciones'), 'pm.id=ipm.pauta_id', array('id'))
            ->where('pm.kilometraje = ?', $km)
            ->where('ipm.servicio_id = ?', $servicio)
            ->limit(1);
        $result = $db->fetchOne($select);
        if($result) {
            return  true;
        } else {
            return false;
        }
    }
}